{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}

module Curry_Function
  ( d_C_fix
  , nd_C_fix
  , d_C_on
  , nd_C_on
  , d_C_first
  , nd_C_first
  , d_C_second
  , nd_C_second
  , d_OP_star_star_star
  , nd_OP_star_star_star
  , d_OP_amp_amp_amp
  , nd_OP_amp_amp_amp
  , d_C_both
  , nd_C_both )
  where

import Basics
import qualified Curry_Prelude


d_C_fix :: forall t0 . (Curry_Prelude.Curry t0) => (t0 -> Cover -> ConstStore
  -> t0) -> Cover -> ConstStore -> t0
d_C_fix x1 cd cs = let x2 = Curry_Prelude.d_C_apply x1 x2 cd cs in x2

nd_C_fix :: forall t0 . (Curry_Prelude.Curry t0) => Func t0 t0 -> IDSupply
  -> Cover -> ConstStore -> t0
nd_C_fix x1 s cd cs = let s0 = s
  in s0 `seq` (let x2 = Curry_Prelude.nd_C_apply x1 x2 s0 cd cs in x2)

d_C_on :: forall t0 t2 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1) => (t0 -> Cover -> ConstStore -> t0 -> Cover
  -> ConstStore -> t1) -> (t2 -> Cover -> ConstStore -> t0) -> t2 -> t2 -> Cover
  -> ConstStore -> t1
d_C_on x1 x2 x3 x4 cd cs = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply x1
  (Curry_Prelude.d_C_apply x2 x3 cd cs) cd cs) (Curry_Prelude.d_C_apply x2 x4 cd
  cs) cd cs

nd_C_on :: forall t0 t2 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1) => Func t0 (Func t0 t1) -> Func t2 t0 -> t2 -> t2
  -> IDSupply -> Cover -> ConstStore -> t1
nd_C_on x1 x2 x3 x4 s cd cs = let s5 = s
  in s5 `seq` (let s4 = leftSupply s5
                   s6 = rightSupply s5
                   s2 = leftSupply s6
                   s3 = rightSupply s6
  in s4 `seq` (s6 `seq` (s2 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
  (let s1 = leftSupply s2
       s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply x1 (Curry_Prelude.nd_C_apply x2
  x3 s0 cd cs) s1 cd cs)) (Curry_Prelude.nd_C_apply x2 x4 s3 cd cs) s4 cd cs))))

d_C_first :: forall t0 t1 t2 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t2) => (t0 -> Cover -> ConstStore -> t1)
  -> Curry_Prelude.OP_Tuple2 t0 t2 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 t1 t2
d_C_first x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> Curry_Prelude.OP_Tuple2
    (Curry_Prelude.d_C_apply x1 x3 cd cs) x4
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C_first x1 l cd cs)
    (d_C_first x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C_first x1 z
    cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C_first x1 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail "Function.first"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "Function.first" (showCons x2))

nd_C_first :: forall t0 t1 t2 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t2) => Func t0 t1 -> Curry_Prelude.OP_Tuple2 t0 t2
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t1 t2
nd_C_first x1 x2 s cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> let s0 = s
    in s0 `seq` Curry_Prelude.OP_Tuple2 (Curry_Prelude.nd_C_apply x1 x3 s0 cd
    cs) x4
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C_first x1 l s cd cs)
    (nd_C_first x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C_first x1
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (nd_C_first x1 e s cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail "Function.first"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "Function.first" (showCons x2))

d_C_second :: forall t0 t2 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1) => (t0 -> Cover -> ConstStore -> t1)
  -> Curry_Prelude.OP_Tuple2 t2 t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 t2 t1
d_C_second x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> Curry_Prelude.OP_Tuple2 x3
    (Curry_Prelude.d_C_apply x1 x4 cd cs)
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C_second x1 l cd cs)
    (d_C_second x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C_second x1
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C_second x1 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail "Function.second"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "Function.second" (showCons x2))

nd_C_second :: forall t0 t2 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1) => Func t0 t1 -> Curry_Prelude.OP_Tuple2 t2 t0
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t2 t1
nd_C_second x1 x2 s cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> let s0 = s
    in s0 `seq` Curry_Prelude.OP_Tuple2 x3 (Curry_Prelude.nd_C_apply x1 x4 s0 cd
    cs)
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C_second x1 l s cd
    cs) (nd_C_second x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C_second x1
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (nd_C_second x1 e s cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail "Function.second"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "Function.second" (showCons x2))

d_OP_star_star_star :: forall t0 t2 t1 t3 . (Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t2, Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t3) => (t0 -> Cover -> ConstStore -> t1) -> (t2 -> Cover -> ConstStore -> t3)
  -> Curry_Prelude.OP_Tuple2 t0 t2 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 t1 t3
d_OP_star_star_star x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> Curry_Prelude.OP_Tuple2
    (Curry_Prelude.d_C_apply x1 x4 cd cs) (Curry_Prelude.d_C_apply x2 x5 cd cs)
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_OP_star_star_star x1
    x2 l cd cs) (d_OP_star_star_star x1 x2 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_star_star_star x1 x2 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_OP_star_star_star x1
    x2 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail "Function.***"
    [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Function.***" (showCons x3))

nd_OP_star_star_star :: forall t0 t2 t1 t3 . (Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t2, Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t3) => Func t0 t1 -> Func t2 t3 -> Curry_Prelude.OP_Tuple2 t0 t2 -> IDSupply
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t1 t3
nd_OP_star_star_star x1 x2 x3 s cd cs = case x3 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.OP_Tuple2 (Curry_Prelude.nd_C_apply x1
    x4 s0 cd cs) (Curry_Prelude.nd_C_apply x2 x5 s1 cd cs)))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_OP_star_star_star x1
    x2 l s cd cs) (nd_OP_star_star_star x1 x2 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_star_star_star x1 x2 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (nd_OP_star_star_star x1
    x2 e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail "Function.***"
    [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Function.***" (showCons x3))

d_OP_amp_amp_amp :: forall t0 t1 t2 . (Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t2) => (t0 -> Cover
  -> ConstStore -> t1) -> (t0 -> Cover -> ConstStore -> t2) -> t0 -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 t1 t2
d_OP_amp_amp_amp x1 x2 x3 cd cs = Curry_Prelude.OP_Tuple2
  (Curry_Prelude.d_C_apply x1 x3 cd cs) (Curry_Prelude.d_C_apply x2 x3 cd cs)

nd_OP_amp_amp_amp :: forall t0 t1 t2 . (Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t2) => Func t0 t1 -> Func t0 t2
  -> t0 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t1 t2
nd_OP_amp_amp_amp x1 x2 x3 s cd cs = let s2 = s
  in s2 `seq` (let s0 = leftSupply s2
                   s1 = rightSupply s2
  in s0 `seq` (s1 `seq` Curry_Prelude.OP_Tuple2 (Curry_Prelude.nd_C_apply x1 x3
  s0 cd cs) (Curry_Prelude.nd_C_apply x2 x3 s1 cd cs)))

d_C_both :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => (t0 -> Cover -> ConstStore -> t1) -> Curry_Prelude.OP_Tuple2 t0 t0
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t1 t1
d_C_both x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> Curry_Prelude.OP_Tuple2
    (Curry_Prelude.d_C_apply x1 x3 cd cs) (Curry_Prelude.d_C_apply x1 x4 cd cs)
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C_both x1 l cd cs)
    (d_C_both x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C_both x1 z
    cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C_both x1 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail "Function.both"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "Function.both" (showCons x2))

nd_C_both :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Func t0 t1 -> Curry_Prelude.OP_Tuple2 t0 t0 -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 t1 t1
nd_C_both x1 x2 s cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.OP_Tuple2 (Curry_Prelude.nd_C_apply x1
    x3 s0 cd cs) (Curry_Prelude.nd_C_apply x1 x4 s1 cd cs)))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C_both x1 l s cd cs)
    (nd_C_both x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C_both x1 z
    s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (nd_C_both x1 e s cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail "Function.both"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "Function.both" (showCons x2))

