{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}

module FlatCurry.Annotated.Curry_TypeInference
  ( C_TypeEnv
  , d_C_inferProg
  , d_C_inferProgFromProgEnv
  , d_C_inferFunction
  , d_C_inferNewFunctions
  , d_C_inferExpr
  , d_C_inferProgEnv
  , nd_C_inferProgEnv
  , d_C_inferFunctionEnv
  , nd_C_inferFunctionEnv
  , d_C_getTypeEnv
  , nd_C_getTypeEnv
  , d_C_getTypeEnvFromProgEnv
  , nd_C_getTypeEnvFromProgEnv )
  where

import Basics
import qualified Curry_ErrorState
import qualified Curry_FiniteMap
import qualified FlatCurry.Annotated.Curry_Goodies
import qualified FlatCurry.Annotated.Curry_TypeSubst
import qualified FlatCurry.Annotated.Curry_Types
import qualified FlatCurry.Curry_Files
import qualified FlatCurry.Curry_Goodies
import qualified FlatCurry.Curry_Types
import qualified Curry_List
import qualified Curry_Prelude
import qualified Rewriting.Curry_Term
import qualified Rewriting.Curry_Unification
import qualified Rewriting.Curry_UnificationSpec
import qualified Curry_SCC
import qualified Curry_Unsafe


type C_TypeEnv = Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr

type C_TIM t0 = Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))

type C_TypeEqs = Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  FlatCurry.Curry_Types.C_TypeExpr FlatCurry.Curry_Types.C_TypeExpr)

type C_NormState = Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int)

type C_Normalize t0 = t0 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  Curry_Prelude.C_Int) -> Cover -> ConstStore -> Curry_Prelude.C_Either
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  Curry_Prelude.C_Int)))

d_C_inferProg :: FlatCurry.Curry_Types.C_Prog -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (FlatCurry.Annotated.Curry_Types.C_AProg
  FlatCurry.Curry_Types.C_TypeExpr))
d_C_inferProg x1 cd cs = Curry_Prelude.d_OP_gt_gt_eq (d_C_getTypeEnv x1 cd cs)
  (d_OP_inferProg_dot_uscore_hash_lambda1 x1) cd cs

d_OP_inferProg_dot_uscore_hash_lambda1 :: FlatCurry.Curry_Types.C_Prog
  -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (FlatCurry.Annotated.Curry_Types.C_AProg FlatCurry.Curry_Types.C_TypeExpr))
d_OP_inferProg_dot_uscore_hash_lambda1 x1 x2 cd cs = Curry_Prelude.d_C_return
  (d_C_inferProgEnv x2 x1 cd cs) cd cs

nd_OP_inferProg_dot_uscore_hash_lambda1 :: FlatCurry.Curry_Types.C_Prog
  -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (FlatCurry.Annotated.Curry_Types.C_AProg
  FlatCurry.Curry_Types.C_TypeExpr))
nd_OP_inferProg_dot_uscore_hash_lambda1 x1 x2 s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.d_C_return (nd_C_inferProgEnv x2 x1 s0 cd cs) cd cs

d_C_inferProgFromProgEnv :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) FlatCurry.Curry_Types.C_Prog)
  -> FlatCurry.Curry_Types.C_Prog -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (FlatCurry.Annotated.Curry_Types.C_AProg FlatCurry.Curry_Types.C_TypeExpr)
d_C_inferProgFromProgEnv x1 x2 cd cs = d_C__case_23 x2 x1
  (d_C_getTypeEnvFromProgEnv x1 x2 cd cs) cd cs

d_C_inferFunction :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_Prog -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr))
d_C_inferFunction x1 x2 cd cs = Curry_Prelude.d_OP_gt_gt_eq (d_C_getTypeEnv x2
  cd cs) (d_OP_inferFunction_dot_uscore_hash_lambda3 x1 x2) cd cs

d_OP_inferFunction_dot_uscore_hash_lambda3 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> FlatCurry.Curry_Types.C_Prog -> Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr
  -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr))
d_OP_inferFunction_dot_uscore_hash_lambda3 x1 x2 x3 cd cs =
  Curry_Prelude.d_C_return (d_C_inferFunctionEnv x3 x1 x2 cd cs) cd cs

nd_OP_inferFunction_dot_uscore_hash_lambda3 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> FlatCurry.Curry_Types.C_Prog -> Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr))
nd_OP_inferFunction_dot_uscore_hash_lambda3 x1 x2 x3 s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.d_C_return (nd_C_inferFunctionEnv x3 x1 x2 s0 cd cs)
  cd cs

d_C_inferNewFunctions :: FlatCurry.Curry_Types.C_Prog -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_FuncDecl -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)))
d_C_inferNewFunctions x1 x2 cd cs = case x1 of
  FlatCurry.Curry_Types.C_Prog x3 x4 x5 x6 x7 -> Curry_Prelude.d_OP_gt_gt_eq
    (d_C_getTypeEnv x1 cd cs) (d_OP_inferNewFunctions_dot_uscore_hash_lambda4 x2
    x3) cd cs
  FlatCurry.Curry_Types.Choice_C_Prog d i l r -> narrow d i
    (d_C_inferNewFunctions l x2 cd cs) (d_C_inferNewFunctions r x2 cd cs)
  FlatCurry.Curry_Types.Choices_C_Prog d i xs -> narrows cs d i (\z ->
    d_C_inferNewFunctions z x2 cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Prog d c e -> guardCons d c
    (d_C_inferNewFunctions e x2 cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Prog d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.inferNewFunctions" [show x1, show x2]
    info)
  _ -> failCons cd (consFail
    "FlatCurry.Annotated.TypeInference.inferNewFunctions" (showCons x1))

d_OP_inferNewFunctions_dot_uscore_hash_lambda4 :: Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_FuncDecl -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)))
d_OP_inferNewFunctions_dot_uscore_hash_lambda4 x1 x2 x3 cd cs =
  Curry_Prelude.d_C_return (d_C_inferNewFunctionsEnv x3 x2 x1 cd cs) cd cs

nd_OP_inferNewFunctions_dot_uscore_hash_lambda4 :: Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_FuncDecl -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)))
nd_OP_inferNewFunctions_dot_uscore_hash_lambda4 x1 x2 x3 s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.d_C_return (nd_C_inferNewFunctionsEnv x3 x2 x1 s0 cd
  cs) cd cs

d_C_inferExpr :: FlatCurry.Curry_Types.C_Prog -> FlatCurry.Curry_Types.C_Expr
  -> Cover -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr))
d_C_inferExpr x1 x2 cd cs = Curry_Prelude.d_OP_gt_gt_eq (d_C_getTypeEnv x1 cd
  cs) (d_OP_inferExpr_dot_uscore_hash_lambda5 x2) cd cs

d_OP_inferExpr_dot_uscore_hash_lambda5 :: FlatCurry.Curry_Types.C_Expr
  -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr))
d_OP_inferExpr_dot_uscore_hash_lambda5 x1 x2 cd cs = Curry_Prelude.d_C_return
  (d_C_inferExprEnv x2 x1 cd cs) cd cs

nd_OP_inferExpr_dot_uscore_hash_lambda5 :: FlatCurry.Curry_Types.C_Expr
  -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr))
nd_OP_inferExpr_dot_uscore_hash_lambda5 x1 x2 s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.d_C_return (nd_C_inferExprEnv x2 x1 s0 cd cs) cd cs

d_C_inferProgEnv :: Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_Prog -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (FlatCurry.Annotated.Curry_Types.C_AProg FlatCurry.Curry_Types.C_TypeExpr)
d_C_inferProgEnv x1 x2 cd cs = Curry_ErrorState.d_C_evalES
  (Curry_ErrorState.d_OP_gt_plus_eq (d_C_annProg x2 cd cs) d_C_inferAProg)
  (d_C_initTIM x1 cd cs) cd cs

nd_C_inferProgEnv :: Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_Prog -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (FlatCurry.Annotated.Curry_Types.C_AProg FlatCurry.Curry_Types.C_TypeExpr)
nd_C_inferProgEnv x1 x2 s cd cs = let s3 = s
  in s3 `seq` (let s2 = leftSupply s3
                   s4 = rightSupply s3
                   s0 = leftSupply s4
                   s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_ErrorState.nd_C_evalES (wrapNX
  id (Curry_ErrorState.nd_OP_gt_plus_eq (nd_C_annProg x2 s0 cd cs) (wrapNX id
  nd_C_inferAProg))) (nd_C_initTIM x1 s1 cd cs) s2 cd cs))))

d_C_inferFunctionEnv :: Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> FlatCurry.Curry_Types.C_Prog
  -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)
d_C_inferFunctionEnv x1 x2 x3 cd cs = case x3 of
  FlatCurry.Curry_Types.C_Prog x4 x5 x6 x7 x8 -> d_C__case_22 x7 x2 x1
    (Curry_Prelude.d_C_apply (Curry_List.d_C_find
    (d_OP_inferFunctionEnv_dot_hasName_dot_30 x2) cd cs) x7 cd cs) cd cs
  FlatCurry.Curry_Types.Choice_C_Prog d i l r -> narrow d i
    (d_C_inferFunctionEnv x1 x2 l cd cs) (d_C_inferFunctionEnv x1 x2 r cd cs)
  FlatCurry.Curry_Types.Choices_C_Prog d i xs -> narrows cs d i (\z ->
    d_C_inferFunctionEnv x1 x2 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Prog d c e -> guardCons d c
    (d_C_inferFunctionEnv x1 x2 e cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Prog d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.inferFunctionEnv" [show x1, show x2, show
    x3] info)
  _ -> failCons cd (consFail
    "FlatCurry.Annotated.TypeInference.inferFunctionEnv" (showCons x3))

nd_C_inferFunctionEnv :: Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> FlatCurry.Curry_Types.C_Prog
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl FlatCurry.Curry_Types.C_TypeExpr)
nd_C_inferFunctionEnv x1 x2 x3 s cd cs = case x3 of
  FlatCurry.Curry_Types.C_Prog x4 x5 x6 x7 x8 -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq` nd_C__case_22 x7 x2 x1 (let s1 = leftSupply s2
                                                      s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_List.nd_C_find (wrapDX
    id (d_OP_inferFunctionEnv_dot_hasName_dot_30 x2)) s0 cd cs) x7 s1 cd cs)) s3
    cd cs))
  FlatCurry.Curry_Types.Choice_C_Prog d i l r -> narrow d i
    (nd_C_inferFunctionEnv x1 x2 l s cd cs) (nd_C_inferFunctionEnv x1 x2 r s cd
    cs)
  FlatCurry.Curry_Types.Choices_C_Prog d i xs -> narrows cs d i (\z ->
    nd_C_inferFunctionEnv x1 x2 z s cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Prog d c e -> guardCons d c
    (nd_C_inferFunctionEnv x1 x2 e s cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Prog d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.inferFunctionEnv" [show x1, show x2, show
    x3] info)
  _ -> failCons cd (consFail
    "FlatCurry.Annotated.TypeInference.inferFunctionEnv" (showCons x3))

d_OP_inferFunctionEnv_dot_hasName_dot_30 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> FlatCurry.Curry_Types.C_FuncDecl -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_OP_inferFunctionEnv_dot_hasName_dot_30 x1 x2 cd cs = case x2 of
  FlatCurry.Curry_Types.C_Func x3 x4 x5 x6 x7 -> Curry_Prelude.d_OP_eq_eq x1 x3
    cd cs
  FlatCurry.Curry_Types.Choice_C_FuncDecl d i l r -> narrow d i
    (d_OP_inferFunctionEnv_dot_hasName_dot_30 x1 l cd cs)
    (d_OP_inferFunctionEnv_dot_hasName_dot_30 x1 r cd cs)
  FlatCurry.Curry_Types.Choices_C_FuncDecl d i xs -> narrows cs d i (\z ->
    d_OP_inferFunctionEnv_dot_hasName_dot_30 x1 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_FuncDecl d c e -> guardCons d c
    (d_OP_inferFunctionEnv_dot_hasName_dot_30 x1 e cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_FuncDecl d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.inferFunctionEnv.hasName.30" [show x1
    , show x2] info)
  _ -> failCons cd (consFail
    "FlatCurry.Annotated.TypeInference.inferFunctionEnv.hasName.30" (showCons
    x2))

d_C_inferNewFunctionsEnv :: Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_FuncDecl -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr))
d_C_inferNewFunctionsEnv x1 x2 x3 cd cs = Curry_ErrorState.d_C_evalES
  (d_OP_inferNewFunctionsEnv_dot_infer_dot_42 x3 (Curry_Prelude.d_C_apply
  (d_C_depGraph x2 cd cs) x3 cd cs) cd cs) (d_C_initTIM x1 cd cs) cd cs

nd_C_inferNewFunctionsEnv :: Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_FuncDecl -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr))
nd_C_inferNewFunctionsEnv x1 x2 x3 s cd cs = let s5 = s
  in s5 `seq` (let s4 = leftSupply s5
                   s6 = rightSupply s5
                   s2 = leftSupply s6
                   s3 = rightSupply s6
  in s4 `seq` (s6 `seq` (s2 `seq` (s3 `seq` Curry_ErrorState.nd_C_evalES
  (let s1 = leftSupply s2
       s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_OP_inferNewFunctionsEnv_dot_infer_dot_42 x3
  (Curry_Prelude.nd_C_apply (wrapDX id (d_C_depGraph x2 cd cs)) x3 s0 cd cs) s1
  cd cs)) (nd_C_initTIM x1 s3 cd cs) s4 cd cs))))

d_OP_inferNewFunctionsEnv_dot_inferGroup_dot_42 :: Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_FuncDecl -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))
d_OP_inferNewFunctionsEnv_dot_inferGroup_dot_42 x1 cd cs =
  Curry_ErrorState.d_OP_gt_plus_eq (Curry_ErrorState.d_OP_gt_plus_eq
  (d_C_annFuncGroup x1 cd cs) d_C_inferFuncGroup)
  d_OP_inferNewFunctionsEnv_dot_inferGroup_dot_42_dot_uscore_hash_lambda8

nd_OP_inferNewFunctionsEnv_dot_inferGroup_dot_42 :: Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_FuncDecl -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))))
nd_OP_inferNewFunctionsEnv_dot_inferGroup_dot_42 x1 s cd cs = let s0 = s
  in s0 `seq` wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (wrapNX id
  (Curry_ErrorState.nd_OP_gt_plus_eq (nd_C_annFuncGroup x1 s0 cd cs) (wrapNX id
  nd_C_inferFuncGroup))) (wrapNX id
  nd_OP_inferNewFunctionsEnv_dot_inferGroup_dot_42_dot_uscore_hash_lambda8))

d_OP_inferNewFunctionsEnv_dot_inferGroup_dot_42_dot_uscore_hash_lambda8 :: Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl FlatCurry.Curry_Types.C_TypeExpr)
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))
d_OP_inferNewFunctionsEnv_dot_inferGroup_dot_42_dot_uscore_hash_lambda8 x1 cd cs =
  Curry_ErrorState.d_OP_gt_plus (d_C_extendTypeEnv (Curry_Prelude.d_C_foldr
  (acceptCs id
  d_OP_inferNewFunctionsEnv_dot_inferGroup_dot_42_dot_uscore_hash_lambda8_dot_uscore_hash_lambda11)
  Curry_Prelude.OP_List x1 cd cs) cd cs) (Curry_ErrorState.d_C_returnES x1) cd
  cs

nd_OP_inferNewFunctionsEnv_dot_inferGroup_dot_42_dot_uscore_hash_lambda8 :: Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl FlatCurry.Curry_Types.C_TypeExpr)
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))))
nd_OP_inferNewFunctionsEnv_dot_inferGroup_dot_42_dot_uscore_hash_lambda8 x1 s cd cs =
  let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_ErrorState.nd_OP_gt_plus (let s1 = leftSupply s2
                                                            s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C_extendTypeEnv (Curry_Prelude.nd_C_foldr (wrapDX
  (wrapDX id) (acceptCs id
  d_OP_inferNewFunctionsEnv_dot_inferGroup_dot_42_dot_uscore_hash_lambda8_dot_uscore_hash_lambda11))
  Curry_Prelude.OP_List x1 s0 cd cs) s1 cd cs)) (wrapDX id
  (Curry_ErrorState.d_C_returnES x1)) s3 cd cs))

d_OP_inferNewFunctionsEnv_dot_inferGroup_dot_42_dot_uscore_hash_lambda8_dot_uscore_hash_lambda11 :: FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr)
d_OP_inferNewFunctionsEnv_dot_inferGroup_dot_42_dot_uscore_hash_lambda8_dot_uscore_hash_lambda11 x1 x2 cd cs =
  case x1 of
  FlatCurry.Annotated.Curry_Types.C_AFunc x3 x4 x5 x6 x7 -> Curry_Prelude.OP_Cons
    (Curry_Prelude.OP_Tuple2 x3 x6) x2
  FlatCurry.Annotated.Curry_Types.Choice_C_AFuncDecl d i l r -> narrow d i
    (d_OP_inferNewFunctionsEnv_dot_inferGroup_dot_42_dot_uscore_hash_lambda8_dot_uscore_hash_lambda11
    l x2 cd cs)
    (d_OP_inferNewFunctionsEnv_dot_inferGroup_dot_42_dot_uscore_hash_lambda8_dot_uscore_hash_lambda11
    r x2 cd cs)
  FlatCurry.Annotated.Curry_Types.Choices_C_AFuncDecl d i xs -> narrows cs d i
    (\z ->
    d_OP_inferNewFunctionsEnv_dot_inferGroup_dot_42_dot_uscore_hash_lambda8_dot_uscore_hash_lambda11
    z x2 cd cs) xs
  FlatCurry.Annotated.Curry_Types.Guard_C_AFuncDecl d c e -> guardCons d c
    (d_OP_inferNewFunctionsEnv_dot_inferGroup_dot_42_dot_uscore_hash_lambda8_dot_uscore_hash_lambda11
    e x2 cd $! addCs c cs)
  FlatCurry.Annotated.Curry_Types.Fail_C_AFuncDecl d info -> failCons d
    (traceFail
    "FlatCurry.Annotated.TypeInference.inferNewFunctionsEnv.inferGroup.42._#lambda8._#lambda11"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "FlatCurry.Annotated.TypeInference.inferNewFunctionsEnv.inferGroup.42._#lambda8._#lambda11"
    (showCons x1))

d_OP_inferNewFunctionsEnv_dot_extract_dot_42 :: forall t0
  t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => FlatCurry.Curry_Types.C_FuncDecl -> Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl t0) -> Cover -> ConstStore -> t1
  -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl t0) t1)
d_OP_inferNewFunctionsEnv_dot_extract_dot_42 x1 x2 cd cs = d_C__case_21 x2 x1
  (Curry_Prelude.d_C_apply (Curry_List.d_C_find (Curry_Prelude.d_OP_dot
  (Curry_Prelude.d_C_flip (acceptCs id Curry_Prelude.d_OP_eq_eq)
  (Curry_Prelude.d_C_apply (FlatCurry.Curry_Goodies.d_C_funcName cd cs) x1 cd
  cs)) (FlatCurry.Annotated.Curry_Goodies.d_C_funcName cd cs) cd cs) cd cs) x2
  cd cs) cd cs

d_OP_inferNewFunctionsEnv_dot_infer_dot_42 :: Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_FuncDecl -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List FlatCurry.Curry_Types.C_FuncDecl) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))
d_OP_inferNewFunctionsEnv_dot_infer_dot_42 x1 x2 cd cs =
  Curry_ErrorState.d_OP_gt_plus_eq (Curry_ErrorState.d_C_concatMapES
  d_OP_inferNewFunctionsEnv_dot_inferGroup_dot_42 x2 cd cs)
  (d_OP_inferNewFunctionsEnv_dot_infer_dot_42_dot_uscore_hash_lambda7 x1)

nd_OP_inferNewFunctionsEnv_dot_infer_dot_42 :: Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_FuncDecl -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List FlatCurry.Curry_Types.C_FuncDecl) -> IDSupply -> Cover
  -> ConstStore -> Func (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))))
nd_OP_inferNewFunctionsEnv_dot_infer_dot_42 x1 x2 s cd cs = let s0 = s
  in s0 `seq` wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq
  (Curry_ErrorState.nd_C_concatMapES (wrapNX id
  nd_OP_inferNewFunctionsEnv_dot_inferGroup_dot_42) x2 s0 cd cs) (wrapDX (wrapDX
  id) (d_OP_inferNewFunctionsEnv_dot_infer_dot_42_dot_uscore_hash_lambda7 x1)))

d_OP_inferNewFunctionsEnv_dot_infer_dot_42_dot_uscore_hash_lambda7 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List FlatCurry.Curry_Types.C_FuncDecl
  -> Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore -> t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) t0)
d_OP_inferNewFunctionsEnv_dot_infer_dot_42_dot_uscore_hash_lambda7 x1 x2 cd cs =
  Curry_ErrorState.d_C_mapES (Curry_Prelude.d_C_flip (acceptCs id
  d_OP_inferNewFunctionsEnv_dot_extract_dot_42) x2) x1 cd cs

d_C_inferExprEnv :: Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_Expr -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr)
d_C_inferExprEnv x1 x2 cd cs = Curry_ErrorState.d_C_evalES
  (Curry_ErrorState.d_OP_gt_plus_eq (d_C_annExpr x2 cd cs) d_C_inferAExpr)
  (d_C_initTIM x1 cd cs) cd cs

nd_C_inferExprEnv :: Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_Expr -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr)
nd_C_inferExprEnv x1 x2 s cd cs = let s3 = s
  in s3 `seq` (let s2 = leftSupply s3
                   s4 = rightSupply s3
                   s0 = leftSupply s4
                   s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_ErrorState.nd_C_evalES (wrapNX
  id (Curry_ErrorState.nd_OP_gt_plus_eq (nd_C_annExpr x2 s0 cd cs) (wrapNX id
  nd_C_inferAExpr))) (nd_C_initTIM x1 s1 cd cs) s2 cd cs))))

d_C_depGraph :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_FuncDecl
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_FuncDecl)
d_C_depGraph x1 cd cs = Curry_SCC.d_C_scc d_OP_depGraph_dot_def_dot_62
  (d_OP_depGraph_dot_use_dot_62 x1) cd cs

d_OP_depGraph_dot_def_dot_62 :: FlatCurry.Curry_Types.C_FuncDecl -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_depGraph_dot_def_dot_62 x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_Func x2 x3 x4 x5 x6 -> Curry_Prelude.OP_Cons x2
    Curry_Prelude.OP_List
  FlatCurry.Curry_Types.Choice_C_FuncDecl d i l r -> narrow d i
    (d_OP_depGraph_dot_def_dot_62 l cd cs) (d_OP_depGraph_dot_def_dot_62 r cd
    cs)
  FlatCurry.Curry_Types.Choices_C_FuncDecl d i xs -> narrows cs d i (\z ->
    d_OP_depGraph_dot_def_dot_62 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_FuncDecl d c e -> guardCons d c
    (d_OP_depGraph_dot_def_dot_62 e cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_FuncDecl d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.depGraph.def.62" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference.depGraph.def.62"
    (showCons x1))

d_OP_depGraph_dot_called_dot_62 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> FlatCurry.Curry_Types.C_Expr -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_depGraph_dot_called_dot_62 x1 x2 cd cs = case x2 of
  FlatCurry.Curry_Types.C_Var x3 -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_Lit x4 -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_Comb x5 x6 x7 -> d_C__case_20 x1 x7 x5 x6 cd cs
  FlatCurry.Curry_Types.C_Let x13 x14 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_concatMap (d_OP_depGraph_dot_called_dot_62 x1) cd cs)
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_map Curry_Prelude.d_C_snd
    x13 cd cs) (Curry_Prelude.OP_Cons x14 Curry_Prelude.OP_List) cd cs) cd cs
  FlatCurry.Curry_Types.C_Free x15 x16 -> d_OP_depGraph_dot_called_dot_62 x1 x16
    cd cs
  FlatCurry.Curry_Types.C_Or x17 x18 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_concatMap (d_OP_depGraph_dot_called_dot_62 x1) cd cs)
    (Curry_Prelude.OP_Cons x17 (Curry_Prelude.OP_Cons x18
    Curry_Prelude.OP_List)) cd cs
  FlatCurry.Curry_Types.C_Case x19 x20 x21 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_concatMap (d_OP_depGraph_dot_called_dot_62 x1) cd cs)
    (Curry_Prelude.OP_Cons x20 (Curry_Prelude.d_C_map
    (FlatCurry.Curry_Goodies.d_C_branchExpr cd cs) x21 cd cs)) cd cs
  FlatCurry.Curry_Types.C_Typed x22 x23 -> d_OP_depGraph_dot_called_dot_62 x1
    x22 cd cs
  FlatCurry.Curry_Types.Choice_C_Expr d i l r -> narrow d i
    (d_OP_depGraph_dot_called_dot_62 x1 l cd cs)
    (d_OP_depGraph_dot_called_dot_62 x1 r cd cs)
  FlatCurry.Curry_Types.Choices_C_Expr d i xs -> narrows cs d i (\z ->
    d_OP_depGraph_dot_called_dot_62 x1 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Expr d c e -> guardCons d c
    (d_OP_depGraph_dot_called_dot_62 x1 e cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Expr d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.depGraph.called.62" [show x1, show x2]
    info)
  _ -> failCons cd (consFail
    "FlatCurry.Annotated.TypeInference.depGraph.called.62" (showCons x2))

d_OP_depGraph_dot_use_dot_62 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> FlatCurry.Curry_Types.C_FuncDecl -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_depGraph_dot_use_dot_62 x1 x2 cd cs = case x2 of
  FlatCurry.Curry_Types.C_Func x3 x4 x5 x6 x7 -> d_C__case_16 x1 x7 cd cs
  FlatCurry.Curry_Types.Choice_C_FuncDecl d i l r -> narrow d i
    (d_OP_depGraph_dot_use_dot_62 x1 l cd cs) (d_OP_depGraph_dot_use_dot_62 x1 r
    cd cs)
  FlatCurry.Curry_Types.Choices_C_FuncDecl d i xs -> narrows cs d i (\z ->
    d_OP_depGraph_dot_use_dot_62 x1 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_FuncDecl d c e -> guardCons d c
    (d_OP_depGraph_dot_use_dot_62 x1 e cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_FuncDecl d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.depGraph.use.62" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference.depGraph.use.62"
    (showCons x2))

d_C_lookupType :: Cover -> ConstStore -> Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.C_Maybe FlatCurry.Curry_Types.C_TypeExpr
d_C_lookupType cd cs = acceptCs id Curry_FiniteMap.d_C_lookupFM

nd_C_lookupType :: IDSupply -> Cover -> ConstStore -> Func (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Func (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.C_Maybe
  FlatCurry.Curry_Types.C_TypeExpr))
nd_C_lookupType s cd cs = wrapDX (wrapNX id) (acceptCs id
  Curry_FiniteMap.nd_C_lookupFM)

d_C_getTypeEnv :: FlatCurry.Curry_Types.C_Prog -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr)
d_C_getTypeEnv x1 cd cs = Curry_Prelude.d_OP_gt_gt_eq (d_C_extractImported x1 cd
  cs) (d_OP_getTypeEnv_dot_uscore_hash_lambda16 x1) cd cs

nd_C_getTypeEnv :: FlatCurry.Curry_Types.C_Prog -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr)
nd_C_getTypeEnv x1 s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.nd_OP_gt_gt_eq (d_C_extractImported x1 cd cs)
  (wrapNX id (nd_OP_getTypeEnv_dot_uscore_hash_lambda16 x1)) s0 cd cs

d_OP_getTypeEnv_dot_uscore_hash_lambda16 :: FlatCurry.Curry_Types.C_Prog
  -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Prog -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr)
d_OP_getTypeEnv_dot_uscore_hash_lambda16 x1 x2 cd cs = Curry_Prelude.d_C_return
  (Curry_Prelude.d_OP_dollar d_C_extractKnownTypes (Curry_Prelude.OP_Cons x1 x2)
  cd cs) cd cs

nd_OP_getTypeEnv_dot_uscore_hash_lambda16 :: FlatCurry.Curry_Types.C_Prog
  -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Prog -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr)
nd_OP_getTypeEnv_dot_uscore_hash_lambda16 x1 x2 s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.d_C_return (Curry_Prelude.nd_OP_dollar (wrapNX id
  nd_C_extractKnownTypes) (Curry_Prelude.OP_Cons x1 x2) s0 cd cs) cd cs

d_C_extractImported :: FlatCurry.Curry_Types.C_Prog -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Prog)
d_C_extractImported x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_Prog x2 x3 x4 x5 x6 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_mapIO FlatCurry.Curry_Files.d_C_readFlatCurryInt cd cs)
    x3 cd cs
  FlatCurry.Curry_Types.Choice_C_Prog d i l r -> narrow d i (d_C_extractImported
    l cd cs) (d_C_extractImported r cd cs)
  FlatCurry.Curry_Types.Choices_C_Prog d i xs -> narrows cs d i (\z ->
    d_C_extractImported z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Prog d c e -> guardCons d c (d_C_extractImported
    e cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Prog d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.extractImported" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference.extractImported"
    (showCons x1))

d_C_getTypeEnvFromProgEnv :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) FlatCurry.Curry_Types.C_Prog)
  -> FlatCurry.Curry_Types.C_Prog -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr)
d_C_getTypeEnvFromProgEnv x1 x2 cd cs = case x2 of
  FlatCurry.Curry_Types.C_Prog x3 x4 x5 x6 x7 -> d_C__case_15 x4 x1 x2
    (d_OP_getTypeEnvFromProgEnv_dot_extract_dot_127 x1 x4 cd cs) cd cs
  FlatCurry.Curry_Types.Choice_C_Prog d i l r -> narrow d i
    (d_C_getTypeEnvFromProgEnv x1 l cd cs) (d_C_getTypeEnvFromProgEnv x1 r cd
    cs)
  FlatCurry.Curry_Types.Choices_C_Prog d i xs -> narrows cs d i (\z ->
    d_C_getTypeEnvFromProgEnv x1 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Prog d c e -> guardCons d c
    (d_C_getTypeEnvFromProgEnv x1 e cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Prog d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.getTypeEnvFromProgEnv" [show x1, show x2]
    info)
  _ -> failCons cd (consFail
    "FlatCurry.Annotated.TypeInference.getTypeEnvFromProgEnv" (showCons x2))

nd_C_getTypeEnvFromProgEnv :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) FlatCurry.Curry_Types.C_Prog)
  -> FlatCurry.Curry_Types.C_Prog -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr)
nd_C_getTypeEnvFromProgEnv x1 x2 s cd cs = case x2 of
  FlatCurry.Curry_Types.C_Prog x3 x4 x5 x6 x7 -> let s0 = s
    in s0 `seq` nd_C__case_15 x4 x1 x2
    (d_OP_getTypeEnvFromProgEnv_dot_extract_dot_127 x1 x4 cd cs) s0 cd cs
  FlatCurry.Curry_Types.Choice_C_Prog d i l r -> narrow d i
    (nd_C_getTypeEnvFromProgEnv x1 l s cd cs) (nd_C_getTypeEnvFromProgEnv x1 r s
    cd cs)
  FlatCurry.Curry_Types.Choices_C_Prog d i xs -> narrows cs d i (\z ->
    nd_C_getTypeEnvFromProgEnv x1 z s cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Prog d c e -> guardCons d c
    (nd_C_getTypeEnvFromProgEnv x1 e s cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Prog d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.getTypeEnvFromProgEnv" [show x1, show x2]
    info)
  _ -> failCons cd (consFail
    "FlatCurry.Annotated.TypeInference.getTypeEnvFromProgEnv" (showCons x2))

d_OP_getTypeEnvFromProgEnv_dot_extract_dot_127 :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  FlatCurry.Curry_Types.C_Prog) -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_Prog)
d_OP_getTypeEnvFromProgEnv_dot_extract_dot_127 x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_List -> Curry_Prelude.C_Right Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x3 x4 -> d_C__case_14 x1 x3 x4 (Curry_Prelude.d_C_lookup
    x3 x1 cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (d_OP_getTypeEnvFromProgEnv_dot_extract_dot_127 x1 l cd cs)
    (d_OP_getTypeEnvFromProgEnv_dot_extract_dot_127 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_getTypeEnvFromProgEnv_dot_extract_dot_127 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c
    (d_OP_getTypeEnvFromProgEnv_dot_extract_dot_127 x1 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.getTypeEnvFromProgEnv.extract.127" [show
    x1, show x2] info)
  _ -> failCons cd (consFail
    "FlatCurry.Annotated.TypeInference.getTypeEnvFromProgEnv.extract.127"
    (showCons x2))

d_C_extractKnownTypes :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Prog
  -> Cover -> ConstStore -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr
d_C_extractKnownTypes x1 cd cs = Curry_Prelude.d_OP_dollar
  (Curry_FiniteMap.d_C_listToFM (acceptCs id Curry_Prelude.d_OP_lt) cd cs)
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_concatMap
  d_OP_extractKnownTypes_dot_extractProg_dot_145 cd cs) x1 cd cs) cd cs

nd_C_extractKnownTypes :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Prog
  -> IDSupply -> Cover -> ConstStore -> Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr
nd_C_extractKnownTypes x1 s cd cs = let s5 = s
  in s5 `seq` (let s4 = leftSupply s5
                   s6 = rightSupply s5
                   s0 = leftSupply s6
                   s3 = rightSupply s6
  in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` Curry_Prelude.nd_OP_dollar
  (Curry_FiniteMap.nd_C_listToFM (wrapDX (wrapDX id) (acceptCs id
  Curry_Prelude.d_OP_lt)) s0 cd cs) (let s2 = leftSupply s3
                                         s1 = rightSupply s3
  in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_concatMap
  (wrapDX id d_OP_extractKnownTypes_dot_extractProg_dot_145) s1 cd cs) x1 s2 cd
  cs)) s4 cd cs))))

d_OP_extractKnownTypes_dot_extractFuncDecl_dot_145 :: FlatCurry.Curry_Types.C_FuncDecl
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr
d_OP_extractKnownTypes_dot_extractFuncDecl_dot_145 x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_Func x2 x3 x4 x5 x6 -> Curry_Prelude.OP_Tuple2 x2 x5
  FlatCurry.Curry_Types.Choice_C_FuncDecl d i l r -> narrow d i
    (d_OP_extractKnownTypes_dot_extractFuncDecl_dot_145 l cd cs)
    (d_OP_extractKnownTypes_dot_extractFuncDecl_dot_145 r cd cs)
  FlatCurry.Curry_Types.Choices_C_FuncDecl d i xs -> narrows cs d i (\z ->
    d_OP_extractKnownTypes_dot_extractFuncDecl_dot_145 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_FuncDecl d c e -> guardCons d c
    (d_OP_extractKnownTypes_dot_extractFuncDecl_dot_145 e cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_FuncDecl d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.extractKnownTypes.extractFuncDecl.145"
    [show x1] info)
  _ -> failCons cd (consFail
    "FlatCurry.Annotated.TypeInference.extractKnownTypes.extractFuncDecl.145"
    (showCons x1))

d_OP_extractKnownTypes_dot_extractConsDecl_dot_145 :: FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_ConsDecl -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr
d_OP_extractKnownTypes_dot_extractConsDecl_dot_145 x1 x2 cd cs = case x2 of
  FlatCurry.Curry_Types.C_Cons x3 x4 x5 x6 -> Curry_Prelude.OP_Tuple2 x3
    (Curry_Prelude.d_C_foldr (acceptCs (acceptCs id)
    FlatCurry.Curry_Types.C_FuncType) x1 x6 cd cs)
  FlatCurry.Curry_Types.Choice_C_ConsDecl d i l r -> narrow d i
    (d_OP_extractKnownTypes_dot_extractConsDecl_dot_145 x1 l cd cs)
    (d_OP_extractKnownTypes_dot_extractConsDecl_dot_145 x1 r cd cs)
  FlatCurry.Curry_Types.Choices_C_ConsDecl d i xs -> narrows cs d i (\z ->
    d_OP_extractKnownTypes_dot_extractConsDecl_dot_145 x1 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_ConsDecl d c e -> guardCons d c
    (d_OP_extractKnownTypes_dot_extractConsDecl_dot_145 x1 e cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_ConsDecl d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.extractKnownTypes.extractConsDecl.145"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "FlatCurry.Annotated.TypeInference.extractKnownTypes.extractConsDecl.145"
    (showCons x2))

d_OP_extractKnownTypes_dot_extractTypeDecl_dot_145 :: FlatCurry.Curry_Types.C_TypeDecl
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr)
d_OP_extractKnownTypes_dot_extractTypeDecl_dot_145 x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_TypeSyn x2 x3 x4 x5 -> Curry_Prelude.OP_Cons
    (Curry_Prelude.OP_Tuple2 x2 x5) Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_Type x6 x7 x8 x9 -> let x10 = FlatCurry.Curry_Types.C_TCons
                                                    x6 (Curry_Prelude.d_C_map
                                                    (acceptCs id
                                                    FlatCurry.Curry_Types.C_TVar)
                                                    x8 cd cs)
    in Curry_Prelude.d_C_map (d_OP_extractKnownTypes_dot_extractConsDecl_dot_145
    x10) x9 cd cs
  FlatCurry.Curry_Types.Choice_C_TypeDecl d i l r -> narrow d i
    (d_OP_extractKnownTypes_dot_extractTypeDecl_dot_145 l cd cs)
    (d_OP_extractKnownTypes_dot_extractTypeDecl_dot_145 r cd cs)
  FlatCurry.Curry_Types.Choices_C_TypeDecl d i xs -> narrows cs d i (\z ->
    d_OP_extractKnownTypes_dot_extractTypeDecl_dot_145 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_TypeDecl d c e -> guardCons d c
    (d_OP_extractKnownTypes_dot_extractTypeDecl_dot_145 e cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_TypeDecl d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.extractKnownTypes.extractTypeDecl.145"
    [show x1] info)
  _ -> failCons cd (consFail
    "FlatCurry.Annotated.TypeInference.extractKnownTypes.extractTypeDecl.145"
    (showCons x1))

d_OP_extractKnownTypes_dot_extractProg_dot_145 :: FlatCurry.Curry_Types.C_Prog
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr)
d_OP_extractKnownTypes_dot_extractProg_dot_145 x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_Prog x2 x3 x4 x5 x6 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_concatMap
    d_OP_extractKnownTypes_dot_extractTypeDecl_dot_145 cd cs) x4 cd cs)
    (Curry_Prelude.d_C_map d_OP_extractKnownTypes_dot_extractFuncDecl_dot_145 x5
    cd cs) cd cs
  FlatCurry.Curry_Types.Choice_C_Prog d i l r -> narrow d i
    (d_OP_extractKnownTypes_dot_extractProg_dot_145 l cd cs)
    (d_OP_extractKnownTypes_dot_extractProg_dot_145 r cd cs)
  FlatCurry.Curry_Types.Choices_C_Prog d i xs -> narrows cs d i (\z ->
    d_OP_extractKnownTypes_dot_extractProg_dot_145 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Prog d c e -> guardCons d c
    (d_OP_extractKnownTypes_dot_extractProg_dot_145 e cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Prog d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.extractKnownTypes.extractProg.145" [show
    x1] info)
  _ -> failCons cd (consFail
    "FlatCurry.Annotated.TypeInference.extractKnownTypes.extractProg.145"
    (showCons x1))

d_C_initTIM :: Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)
d_C_initTIM x1 cd cs = Curry_Prelude.OP_Tuple4 x1 (Curry_Prelude.C_Int 0#)
  (Curry_FiniteMap.d_C_emptyFM (acceptCs id Curry_Prelude.d_OP_lt) cd cs)
  (Curry_FiniteMap.d_C_emptyFM (acceptCs id Curry_Prelude.d_OP_lt) cd cs)

nd_C_initTIM :: Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)
nd_C_initTIM x1 s cd cs = let s2 = s
  in s2 `seq` (let s0 = leftSupply s2
                   s1 = rightSupply s2
  in s0 `seq` (s1 `seq` Curry_Prelude.OP_Tuple4 x1 (Curry_Prelude.C_Int 0#)
  (Curry_FiniteMap.nd_C_emptyFM (wrapDX (wrapDX id) (acceptCs id
  Curry_Prelude.d_OP_lt)) s0 cd cs) (Curry_FiniteMap.nd_C_emptyFM (wrapDX
  (wrapDX id) (acceptCs id Curry_Prelude.d_OP_lt)) s1 cd cs)))

d_C_extendTypeEnv :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))
d_C_extendTypeEnv x1 cd cs = Curry_ErrorState.d_OP_gt_plus_eq
  Curry_ErrorState.d_C_gets (d_OP_extendTypeEnv_dot_uscore_hash_lambda21 x1)

nd_C_extendTypeEnv :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))))
nd_C_extendTypeEnv x1 s cd cs = wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq
  (wrapDX id Curry_ErrorState.d_C_gets) (wrapNX id
  (nd_OP_extendTypeEnv_dot_uscore_hash_lambda21 x1)))

d_OP_extendTypeEnv_dot_uscore_hash_lambda21 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr)
  -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either t0 (Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))
d_OP_extendTypeEnv_dot_uscore_hash_lambda21 x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple4 x3 x4 x5 x6 -> Curry_ErrorState.d_C_puts
    (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.d_C_addListToFM x3 x1 cd cs) x4 x5
    x6)
  Curry_Prelude.Choice_OP_Tuple4 d i l r -> narrow d i
    (d_OP_extendTypeEnv_dot_uscore_hash_lambda21 x1 l cd cs)
    (d_OP_extendTypeEnv_dot_uscore_hash_lambda21 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple4 d i xs -> narrows cs d i (\z ->
    d_OP_extendTypeEnv_dot_uscore_hash_lambda21 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple4 d c e -> guardCons d c
    (d_OP_extendTypeEnv_dot_uscore_hash_lambda21 x1 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple4 d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.extendTypeEnv._#lambda21" [show x1, show
    x2] info)
  _ -> failCons cd (consFail
    "FlatCurry.Annotated.TypeInference.extendTypeEnv._#lambda21" (showCons x2))

nd_OP_extendTypeEnv_dot_uscore_hash_lambda21 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr)
  -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.C_Either t0
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))))
nd_OP_extendTypeEnv_dot_uscore_hash_lambda21 x1 x2 s cd cs = case x2 of
  Curry_Prelude.OP_Tuple4 x3 x4 x5 x6 -> let s0 = s
    in s0 `seq` wrapDX id (Curry_ErrorState.d_C_puts (Curry_Prelude.OP_Tuple4
    (Curry_FiniteMap.nd_C_addListToFM x3 x1 s0 cd cs) x4 x5 x6))
  Curry_Prelude.Choice_OP_Tuple4 d i l r -> narrow d i
    (nd_OP_extendTypeEnv_dot_uscore_hash_lambda21 x1 l s cd cs)
    (nd_OP_extendTypeEnv_dot_uscore_hash_lambda21 x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple4 d i xs -> narrows cs d i (\z ->
    nd_OP_extendTypeEnv_dot_uscore_hash_lambda21 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple4 d c e -> guardCons d c
    (nd_OP_extendTypeEnv_dot_uscore_hash_lambda21 x1 e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple4 d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.extendTypeEnv._#lambda21" [show x1, show
    x2] info)
  _ -> failCons cd (consFail
    "FlatCurry.Annotated.TypeInference.extendTypeEnv._#lambda21" (showCons x2))

d_C_nextTVar :: Cover -> ConstStore -> Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 FlatCurry.Curry_Types.C_TypeExpr
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))
d_C_nextTVar cd cs = Curry_ErrorState.d_OP_gt_plus_eq Curry_ErrorState.d_C_gets
  d_OP_nextTVar_dot_uscore_hash_lambda22

nd_C_nextTVar :: IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  FlatCurry.Curry_Types.C_TypeExpr (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))))
nd_C_nextTVar s cd cs = wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (wrapDX id
  Curry_ErrorState.d_C_gets) (wrapNX id
  nd_OP_nextTVar_dot_uscore_hash_lambda22))

d_OP_nextTVar_dot_uscore_hash_lambda22 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either t0 (Curry_Prelude.OP_Tuple2
  FlatCurry.Curry_Types.C_TypeExpr (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))
d_OP_nextTVar_dot_uscore_hash_lambda22 x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple4 x2 x3 x4 x5 -> Curry_ErrorState.d_OP_gt_plus
    (Curry_ErrorState.d_C_puts (Curry_Prelude.OP_Tuple4 x2
    (Curry_Prelude.d_OP_plus x3 (Curry_Prelude.C_Int 1#) cd cs) x4 x5))
    (Curry_ErrorState.d_C_returnES (FlatCurry.Curry_Types.C_TVar x3)) cd cs
  Curry_Prelude.Choice_OP_Tuple4 d i l r -> narrow d i
    (d_OP_nextTVar_dot_uscore_hash_lambda22 l cd cs)
    (d_OP_nextTVar_dot_uscore_hash_lambda22 r cd cs)
  Curry_Prelude.Choices_OP_Tuple4 d i xs -> narrows cs d i (\z ->
    d_OP_nextTVar_dot_uscore_hash_lambda22 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple4 d c e -> guardCons d c
    (d_OP_nextTVar_dot_uscore_hash_lambda22 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple4 d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.nextTVar._#lambda22" [show x1] info)
  _ -> failCons cd (consFail
    "FlatCurry.Annotated.TypeInference.nextTVar._#lambda22" (showCons x1))

nd_OP_nextTVar_dot_uscore_hash_lambda22 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.C_Either t0
  (Curry_Prelude.OP_Tuple2 FlatCurry.Curry_Types.C_TypeExpr
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))))
nd_OP_nextTVar_dot_uscore_hash_lambda22 x1 s cd cs = case x1 of
  Curry_Prelude.OP_Tuple4 x2 x3 x4 x5 -> let s0 = s
    in s0 `seq` Curry_ErrorState.nd_OP_gt_plus (wrapDX id
    (Curry_ErrorState.d_C_puts (Curry_Prelude.OP_Tuple4 x2
    (Curry_Prelude.d_OP_plus x3 (Curry_Prelude.C_Int 1#) cd cs) x4 x5))) (wrapDX
    id (Curry_ErrorState.d_C_returnES (FlatCurry.Curry_Types.C_TVar x3))) s0 cd
    cs
  Curry_Prelude.Choice_OP_Tuple4 d i l r -> narrow d i
    (nd_OP_nextTVar_dot_uscore_hash_lambda22 l s cd cs)
    (nd_OP_nextTVar_dot_uscore_hash_lambda22 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple4 d i xs -> narrows cs d i (\z ->
    nd_OP_nextTVar_dot_uscore_hash_lambda22 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple4 d c e -> guardCons d c
    (nd_OP_nextTVar_dot_uscore_hash_lambda22 e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple4 d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.nextTVar._#lambda22" [show x1] info)
  _ -> failCons cd (consFail
    "FlatCurry.Annotated.TypeInference.nextTVar._#lambda22" (showCons x1))

d_C_initVarTypes :: Cover -> ConstStore -> Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))
d_C_initVarTypes cd cs = Curry_Prelude.d_OP_dollar (acceptCs id
  Curry_ErrorState.d_C_modify) d_OP_initVarTypes_dot_uscore_hash_lambda23 cd cs

nd_C_initVarTypes :: IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))))
nd_C_initVarTypes s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.nd_OP_dollar (wrapDX (wrapNX id) (acceptCs id
  Curry_ErrorState.nd_C_modify)) (wrapNX id
  nd_OP_initVarTypes_dot_uscore_hash_lambda23) s0 cd cs

d_OP_initVarTypes_dot_uscore_hash_lambda23 :: forall t0
  t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM t0 t1)
d_OP_initVarTypes_dot_uscore_hash_lambda23 x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple4 x2 x3 x4 x5 -> Curry_Prelude.OP_Tuple4 x2 x3 x4
    (Curry_FiniteMap.d_C_emptyFM (acceptCs id Curry_Prelude.d_OP_lt) cd cs)
  Curry_Prelude.Choice_OP_Tuple4 d i l r -> narrow d i
    (d_OP_initVarTypes_dot_uscore_hash_lambda23 l cd cs)
    (d_OP_initVarTypes_dot_uscore_hash_lambda23 r cd cs)
  Curry_Prelude.Choices_OP_Tuple4 d i xs -> narrows cs d i (\z ->
    d_OP_initVarTypes_dot_uscore_hash_lambda23 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple4 d c e -> guardCons d c
    (d_OP_initVarTypes_dot_uscore_hash_lambda23 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple4 d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.initVarTypes._#lambda23" [show x1] info)
  _ -> failCons cd (consFail
    "FlatCurry.Annotated.TypeInference.initVarTypes._#lambda23" (showCons x1))

nd_OP_initVarTypes_dot_uscore_hash_lambda23 :: forall t0
  t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM t0 t1)
nd_OP_initVarTypes_dot_uscore_hash_lambda23 x1 s cd cs = case x1 of
  Curry_Prelude.OP_Tuple4 x2 x3 x4 x5 -> let s0 = s
    in s0 `seq` Curry_Prelude.OP_Tuple4 x2 x3 x4 (Curry_FiniteMap.nd_C_emptyFM
    (wrapDX (wrapDX id) (acceptCs id Curry_Prelude.d_OP_lt)) s0 cd cs)
  Curry_Prelude.Choice_OP_Tuple4 d i l r -> narrow d i
    (nd_OP_initVarTypes_dot_uscore_hash_lambda23 l s cd cs)
    (nd_OP_initVarTypes_dot_uscore_hash_lambda23 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple4 d i xs -> narrows cs d i (\z ->
    nd_OP_initVarTypes_dot_uscore_hash_lambda23 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple4 d c e -> guardCons d c
    (nd_OP_initVarTypes_dot_uscore_hash_lambda23 e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple4 d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.initVarTypes._#lambda23" [show x1] info)
  _ -> failCons cd (consFail
    "FlatCurry.Annotated.TypeInference.initVarTypes._#lambda23" (showCons x1))

d_C_initSigEnv :: Cover -> ConstStore -> Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))
d_C_initSigEnv cd cs = Curry_Prelude.d_OP_dollar (acceptCs id
  Curry_ErrorState.d_C_modify) d_OP_initSigEnv_dot_uscore_hash_lambda24 cd cs

nd_C_initSigEnv :: IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))))
nd_C_initSigEnv s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.nd_OP_dollar (wrapDX (wrapNX id) (acceptCs id
  Curry_ErrorState.nd_C_modify)) (wrapNX id
  nd_OP_initSigEnv_dot_uscore_hash_lambda24) s0 cd cs

d_OP_initSigEnv_dot_uscore_hash_lambda24 :: forall t0 t1 . (Curry_Prelude.Curry
  t0, Curry_Prelude.Curry t1) => Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM t0 t1) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)
d_OP_initSigEnv_dot_uscore_hash_lambda24 x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple4 x2 x3 x4 x5 -> Curry_Prelude.OP_Tuple4 x2 x3
    (Curry_FiniteMap.d_C_emptyFM (acceptCs id Curry_Prelude.d_OP_lt) cd cs) x5
  Curry_Prelude.Choice_OP_Tuple4 d i l r -> narrow d i
    (d_OP_initSigEnv_dot_uscore_hash_lambda24 l cd cs)
    (d_OP_initSigEnv_dot_uscore_hash_lambda24 r cd cs)
  Curry_Prelude.Choices_OP_Tuple4 d i xs -> narrows cs d i (\z ->
    d_OP_initSigEnv_dot_uscore_hash_lambda24 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple4 d c e -> guardCons d c
    (d_OP_initSigEnv_dot_uscore_hash_lambda24 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple4 d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.initSigEnv._#lambda24" [show x1] info)
  _ -> failCons cd (consFail
    "FlatCurry.Annotated.TypeInference.initSigEnv._#lambda24" (showCons x1))

nd_OP_initSigEnv_dot_uscore_hash_lambda24 :: forall t0 t1 . (Curry_Prelude.Curry
  t0, Curry_Prelude.Curry t1) => Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM t0 t1) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)
nd_OP_initSigEnv_dot_uscore_hash_lambda24 x1 s cd cs = case x1 of
  Curry_Prelude.OP_Tuple4 x2 x3 x4 x5 -> let s0 = s
    in s0 `seq` Curry_Prelude.OP_Tuple4 x2 x3 (Curry_FiniteMap.nd_C_emptyFM
    (wrapDX (wrapDX id) (acceptCs id Curry_Prelude.d_OP_lt)) s0 cd cs) x5
  Curry_Prelude.Choice_OP_Tuple4 d i l r -> narrow d i
    (nd_OP_initSigEnv_dot_uscore_hash_lambda24 l s cd cs)
    (nd_OP_initSigEnv_dot_uscore_hash_lambda24 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple4 d i xs -> narrows cs d i (\z ->
    nd_OP_initSigEnv_dot_uscore_hash_lambda24 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple4 d c e -> guardCons d c
    (nd_OP_initSigEnv_dot_uscore_hash_lambda24 e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple4 d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.initSigEnv._#lambda24" [show x1] info)
  _ -> failCons cd (consFail
    "FlatCurry.Annotated.TypeInference.initSigEnv._#lambda24" (showCons x1))

d_C_insertVarType :: Curry_Prelude.C_Int -> FlatCurry.Curry_Types.C_TypeExpr
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))
d_C_insertVarType x1 x2 cd cs = Curry_Prelude.d_OP_dollar (acceptCs id
  Curry_ErrorState.d_C_modify) (d_OP_insertVarType_dot_uscore_hash_lambda25 x2
  x1) cd cs

nd_C_insertVarType :: Curry_Prelude.C_Int -> FlatCurry.Curry_Types.C_TypeExpr
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))))
nd_C_insertVarType x1 x2 s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.nd_OP_dollar (wrapDX (wrapNX id) (acceptCs id
  Curry_ErrorState.nd_C_modify)) (wrapNX id
  (nd_OP_insertVarType_dot_uscore_hash_lambda25 x2 x1)) s0 cd cs

d_OP_insertVarType_dot_uscore_hash_lambda25 :: FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.C_Int -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)
d_OP_insertVarType_dot_uscore_hash_lambda25 x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.OP_Tuple4 x4 x5 x6 x7 -> Curry_Prelude.OP_Tuple4 x4 x5 x6
    (Curry_FiniteMap.d_C_addToFM x7 x2 x1 cd cs)
  Curry_Prelude.Choice_OP_Tuple4 d i l r -> narrow d i
    (d_OP_insertVarType_dot_uscore_hash_lambda25 x1 x2 l cd cs)
    (d_OP_insertVarType_dot_uscore_hash_lambda25 x1 x2 r cd cs)
  Curry_Prelude.Choices_OP_Tuple4 d i xs -> narrows cs d i (\z ->
    d_OP_insertVarType_dot_uscore_hash_lambda25 x1 x2 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple4 d c e -> guardCons d c
    (d_OP_insertVarType_dot_uscore_hash_lambda25 x1 x2 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple4 d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.insertVarType._#lambda25" [show x1, show
    x2, show x3] info)
  _ -> failCons cd (consFail
    "FlatCurry.Annotated.TypeInference.insertVarType._#lambda25" (showCons x3))

nd_OP_insertVarType_dot_uscore_hash_lambda25 :: FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.C_Int -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)
nd_OP_insertVarType_dot_uscore_hash_lambda25 x1 x2 x3 s cd cs = case x3 of
  Curry_Prelude.OP_Tuple4 x4 x5 x6 x7 -> let s0 = s
    in s0 `seq` Curry_Prelude.OP_Tuple4 x4 x5 x6 (Curry_FiniteMap.nd_C_addToFM
    x7 x2 x1 s0 cd cs)
  Curry_Prelude.Choice_OP_Tuple4 d i l r -> narrow d i
    (nd_OP_insertVarType_dot_uscore_hash_lambda25 x1 x2 l s cd cs)
    (nd_OP_insertVarType_dot_uscore_hash_lambda25 x1 x2 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple4 d i xs -> narrows cs d i (\z ->
    nd_OP_insertVarType_dot_uscore_hash_lambda25 x1 x2 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple4 d c e -> guardCons d c
    (nd_OP_insertVarType_dot_uscore_hash_lambda25 x1 x2 e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple4 d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.insertVarType._#lambda25" [show x1, show
    x2, show x3] info)
  _ -> failCons cd (consFail
    "FlatCurry.Annotated.TypeInference.insertVarType._#lambda25" (showCons x3))

d_C_insertFunType :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))
d_C_insertFunType x1 x2 cd cs = Curry_ErrorState.d_OP_gt_plus_eq
  (d_C_freshVariant x2 cd cs) (d_OP_insertFunType_dot_uscore_hash_lambda26 x1)

nd_C_insertFunType :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))))
nd_C_insertFunType x1 x2 s cd cs = let s0 = s
  in s0 `seq` wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (nd_C_freshVariant x2
  s0 cd cs) (wrapNX id (nd_OP_insertFunType_dot_uscore_hash_lambda26 x1)))

d_OP_insertFunType_dot_uscore_hash_lambda26 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either t0 (Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))
d_OP_insertFunType_dot_uscore_hash_lambda26 x1 x2 cd cs =
  Curry_Prelude.d_OP_dollar (acceptCs id Curry_ErrorState.d_C_modify)
  (d_OP_insertFunType_dot_uscore_hash_lambda26_dot_uscore_hash_lambda27 x1 x2)
  cd cs

nd_OP_insertFunType_dot_uscore_hash_lambda26 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.C_Either t0
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))))
nd_OP_insertFunType_dot_uscore_hash_lambda26 x1 x2 s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.nd_OP_dollar (wrapDX (wrapNX id) (acceptCs id
  Curry_ErrorState.nd_C_modify)) (wrapNX id
  (nd_OP_insertFunType_dot_uscore_hash_lambda26_dot_uscore_hash_lambda27 x1 x2))
  s0 cd cs

d_OP_insertFunType_dot_uscore_hash_lambda26_dot_uscore_hash_lambda27 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)
d_OP_insertFunType_dot_uscore_hash_lambda26_dot_uscore_hash_lambda27 x1 x2 x3 cd cs =
  case x3 of
  Curry_Prelude.OP_Tuple4 x4 x5 x6 x7 -> Curry_Prelude.OP_Tuple4 x4 x5
    (Curry_FiniteMap.d_C_addToFM x6 x1 x2 cd cs) x7
  Curry_Prelude.Choice_OP_Tuple4 d i l r -> narrow d i
    (d_OP_insertFunType_dot_uscore_hash_lambda26_dot_uscore_hash_lambda27 x1 x2
    l cd cs)
    (d_OP_insertFunType_dot_uscore_hash_lambda26_dot_uscore_hash_lambda27 x1 x2
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple4 d i xs -> narrows cs d i (\z ->
    d_OP_insertFunType_dot_uscore_hash_lambda26_dot_uscore_hash_lambda27 x1 x2 z
    cd cs) xs
  Curry_Prelude.Guard_OP_Tuple4 d c e -> guardCons d c
    (d_OP_insertFunType_dot_uscore_hash_lambda26_dot_uscore_hash_lambda27 x1 x2
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple4 d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.insertFunType._#lambda26._#lambda27"
    [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail
    "FlatCurry.Annotated.TypeInference.insertFunType._#lambda26._#lambda27"
    (showCons x3))

nd_OP_insertFunType_dot_uscore_hash_lambda26_dot_uscore_hash_lambda27 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)
nd_OP_insertFunType_dot_uscore_hash_lambda26_dot_uscore_hash_lambda27 x1 x2 x3 s cd cs =
  case x3 of
  Curry_Prelude.OP_Tuple4 x4 x5 x6 x7 -> let s0 = s
    in s0 `seq` Curry_Prelude.OP_Tuple4 x4 x5 (Curry_FiniteMap.nd_C_addToFM x6
    x1 x2 s0 cd cs) x7
  Curry_Prelude.Choice_OP_Tuple4 d i l r -> narrow d i
    (nd_OP_insertFunType_dot_uscore_hash_lambda26_dot_uscore_hash_lambda27 x1 x2
    l s cd cs)
    (nd_OP_insertFunType_dot_uscore_hash_lambda26_dot_uscore_hash_lambda27 x1 x2
    r s cd cs)
  Curry_Prelude.Choices_OP_Tuple4 d i xs -> narrows cs d i (\z ->
    nd_OP_insertFunType_dot_uscore_hash_lambda26_dot_uscore_hash_lambda27 x1 x2
    z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple4 d c e -> guardCons d c
    (nd_OP_insertFunType_dot_uscore_hash_lambda26_dot_uscore_hash_lambda27 x1 x2
    e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple4 d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.insertFunType._#lambda26._#lambda27"
    [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail
    "FlatCurry.Annotated.TypeInference.insertFunType._#lambda26._#lambda27"
    (showCons x3))

d_C_lookupVarType :: Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.C_Maybe
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))
d_C_lookupVarType x1 cd cs = Curry_ErrorState.d_OP_gt_plus_eq
  Curry_ErrorState.d_C_gets (d_OP_lookupVarType_dot_uscore_hash_lambda28 x1)

nd_C_lookupVarType :: Curry_Prelude.C_Int -> IDSupply -> Cover -> ConstStore
  -> Func (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.C_Maybe FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))))
nd_C_lookupVarType x1 s cd cs = wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq
  (wrapDX id Curry_ErrorState.d_C_gets) (wrapNX id
  (nd_OP_lookupVarType_dot_uscore_hash_lambda28 x1)))

d_OP_lookupVarType_dot_uscore_hash_lambda28 :: forall t1
  t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Curry_Prelude.C_Int
  -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore -> t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.C_Maybe FlatCurry.Curry_Types.C_TypeExpr) t0)
d_OP_lookupVarType_dot_uscore_hash_lambda28 x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple4 x3 x4 x5 x6 -> Curry_ErrorState.d_C_returnES
    (Curry_FiniteMap.d_C_lookupFM x6 x1 cd cs)
  Curry_Prelude.Choice_OP_Tuple4 d i l r -> narrow d i
    (d_OP_lookupVarType_dot_uscore_hash_lambda28 x1 l cd cs)
    (d_OP_lookupVarType_dot_uscore_hash_lambda28 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple4 d i xs -> narrows cs d i (\z ->
    d_OP_lookupVarType_dot_uscore_hash_lambda28 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple4 d c e -> guardCons d c
    (d_OP_lookupVarType_dot_uscore_hash_lambda28 x1 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple4 d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.lookupVarType._#lambda28" [show x1, show
    x2] info)
  _ -> failCons cd (consFail
    "FlatCurry.Annotated.TypeInference.lookupVarType._#lambda28" (showCons x2))

nd_OP_lookupVarType_dot_uscore_hash_lambda28 :: forall t1
  t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Curry_Prelude.C_Int
  -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> IDSupply -> Cover -> ConstStore -> Func
  t0 (Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.C_Maybe
  FlatCurry.Curry_Types.C_TypeExpr) t0))
nd_OP_lookupVarType_dot_uscore_hash_lambda28 x1 x2 s cd cs = case x2 of
  Curry_Prelude.OP_Tuple4 x3 x4 x5 x6 -> let s0 = s
    in s0 `seq` wrapDX id (Curry_ErrorState.d_C_returnES
    (Curry_FiniteMap.nd_C_lookupFM x6 x1 s0 cd cs))
  Curry_Prelude.Choice_OP_Tuple4 d i l r -> narrow d i
    (nd_OP_lookupVarType_dot_uscore_hash_lambda28 x1 l s cd cs)
    (nd_OP_lookupVarType_dot_uscore_hash_lambda28 x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple4 d i xs -> narrows cs d i (\z ->
    nd_OP_lookupVarType_dot_uscore_hash_lambda28 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple4 d c e -> guardCons d c
    (nd_OP_lookupVarType_dot_uscore_hash_lambda28 x1 e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple4 d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.lookupVarType._#lambda28" [show x1, show
    x2] info)
  _ -> failCons cd (consFail
    "FlatCurry.Annotated.TypeInference.lookupVarType._#lambda28" (showCons x2))

d_C_getTypeVariant :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))
d_C_getTypeVariant x1 cd cs = Curry_ErrorState.d_OP_gt_plus_eq
  Curry_ErrorState.d_C_gets (d_OP_getTypeVariant_dot_uscore_hash_lambda29 x1)

nd_C_getTypeVariant :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> IDSupply
  -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))))
nd_C_getTypeVariant x1 s cd cs = wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq
  (wrapDX id Curry_ErrorState.d_C_gets) (wrapNX id
  (nd_OP_getTypeVariant_dot_uscore_hash_lambda29 x1)))

d_OP_getTypeVariant_dot_uscore_hash_lambda29 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))
d_OP_getTypeVariant_dot_uscore_hash_lambda29 x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple4 x3 x4 x5 x6 -> d_C__case_12 x1 x3 x5
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (d_C_lookupType cd cs) x3
    cd cs) x1 cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple4 d i l r -> narrow d i
    (d_OP_getTypeVariant_dot_uscore_hash_lambda29 x1 l cd cs)
    (d_OP_getTypeVariant_dot_uscore_hash_lambda29 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple4 d i xs -> narrows cs d i (\z ->
    d_OP_getTypeVariant_dot_uscore_hash_lambda29 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple4 d c e -> guardCons d c
    (d_OP_getTypeVariant_dot_uscore_hash_lambda29 x1 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple4 d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.getTypeVariant._#lambda29" [show x1, show
    x2] info)
  _ -> failCons cd (consFail
    "FlatCurry.Annotated.TypeInference.getTypeVariant._#lambda29" (showCons x2))

nd_OP_getTypeVariant_dot_uscore_hash_lambda29 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))))
nd_OP_getTypeVariant_dot_uscore_hash_lambda29 x1 x2 s cd cs = case x2 of
  Curry_Prelude.OP_Tuple4 x3 x4 x5 x6 -> let s6 = s
    in s6 `seq` (let s5 = leftSupply s6
                     s4 = rightSupply s6
    in s5 `seq` (s4 `seq` nd_C__case_12 x1 x3 x5 (let s3 = leftSupply s4
                                                      s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (nd_C_lookupType s0 cd cs) x3
    s1 cd cs)) x1 s3 cd cs)) s5 cd cs))
  Curry_Prelude.Choice_OP_Tuple4 d i l r -> narrow d i
    (nd_OP_getTypeVariant_dot_uscore_hash_lambda29 x1 l s cd cs)
    (nd_OP_getTypeVariant_dot_uscore_hash_lambda29 x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple4 d i xs -> narrows cs d i (\z ->
    nd_OP_getTypeVariant_dot_uscore_hash_lambda29 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple4 d c e -> guardCons d c
    (nd_OP_getTypeVariant_dot_uscore_hash_lambda29 x1 e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple4 d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.getTypeVariant._#lambda29" [show x1, show
    x2] info)
  _ -> failCons cd (consFail
    "FlatCurry.Annotated.TypeInference.getTypeVariant._#lambda29" (showCons x2))

d_OP_getTypeVariant_dot_uscore_hash_lambda29_dot_uscore_hash_lambda32 :: forall t1
  t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore -> t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) t0)
d_OP_getTypeVariant_dot_uscore_hash_lambda29_dot_uscore_hash_lambda32 x1 x2 cd cs =
  Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Tuple2 x1 x2)

d_C_freshVariant :: FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 FlatCurry.Curry_Types.C_TypeExpr
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))
d_C_freshVariant x1 cd cs = Curry_ErrorState.d_OP_lt_dollar_gt
  Curry_Prelude.d_C_snd (d_OP_freshVariant_dot_rename_dot_224
  Curry_Prelude.OP_List x1 cd cs) cd cs

nd_C_freshVariant :: FlatCurry.Curry_Types.C_TypeExpr -> IDSupply -> Cover
  -> ConstStore -> Func (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  FlatCurry.Curry_Types.C_TypeExpr (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))))
nd_C_freshVariant x1 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_ErrorState.nd_OP_lt_dollar_gt (wrapDX id
  Curry_Prelude.d_C_snd) (nd_OP_freshVariant_dot_rename_dot_224
  Curry_Prelude.OP_List x1 s0 cd cs) s1 cd cs))

d_OP_freshVariant_dot_rename_dot_224 :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  -> FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))
d_OP_freshVariant_dot_rename_dot_224 x1 x2 cd cs = case x2 of
  FlatCurry.Curry_Types.C_TVar x3 -> d_C__case_10 x1 x3
    (Curry_Prelude.d_C_lookup x3 x1 cd cs) cd cs
  FlatCurry.Curry_Types.C_FuncType x5 x6 -> Curry_ErrorState.d_OP_gt_plus_eq
    (d_OP_freshVariant_dot_rename_dot_224 x1 x5 cd cs)
    (d_OP_freshVariant_dot_rename_dot_224_dot_uscore_hash_lambda35 x6)
  FlatCurry.Curry_Types.C_TCons x7 x8 -> Curry_ErrorState.d_OP_gt_plus_eq
    (Curry_ErrorState.d_C_mapAccumES (acceptCs id
    d_OP_freshVariant_dot_rename_dot_224) x1 x8 cd cs)
    (d_OP_freshVariant_dot_rename_dot_224_dot_uscore_hash_lambda37 x7)
  FlatCurry.Curry_Types.Choice_C_TypeExpr d i l r -> narrow d i
    (d_OP_freshVariant_dot_rename_dot_224 x1 l cd cs)
    (d_OP_freshVariant_dot_rename_dot_224 x1 r cd cs)
  FlatCurry.Curry_Types.Choices_C_TypeExpr d i xs -> narrows cs d i (\z ->
    d_OP_freshVariant_dot_rename_dot_224 x1 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_TypeExpr d c e -> guardCons d c
    (d_OP_freshVariant_dot_rename_dot_224 x1 e cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_TypeExpr d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.freshVariant.rename.224" [show x1, show
    x2] info)
  _ -> failCons cd (consFail
    "FlatCurry.Annotated.TypeInference.freshVariant.rename.224" (showCons x2))

nd_OP_freshVariant_dot_rename_dot_224 :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  -> FlatCurry.Curry_Types.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))))
nd_OP_freshVariant_dot_rename_dot_224 x1 x2 s cd cs = case x2 of
  FlatCurry.Curry_Types.C_TVar x3 -> let s0 = s
    in s0 `seq` nd_C__case_10 x1 x3 (Curry_Prelude.d_C_lookup x3 x1 cd cs) s0 cd
    cs
  FlatCurry.Curry_Types.C_FuncType x5 x6 -> let s0 = s
    in s0 `seq` wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq
    (nd_OP_freshVariant_dot_rename_dot_224 x1 x5 s0 cd cs) (wrapNX id
    (nd_OP_freshVariant_dot_rename_dot_224_dot_uscore_hash_lambda35 x6)))
  FlatCurry.Curry_Types.C_TCons x7 x8 -> let s0 = s
    in s0 `seq` wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq
    (Curry_ErrorState.nd_C_mapAccumES (wrapDX (wrapNX id) (acceptCs id
    nd_OP_freshVariant_dot_rename_dot_224)) x1 x8 s0 cd cs) (wrapDX (wrapDX id)
    (d_OP_freshVariant_dot_rename_dot_224_dot_uscore_hash_lambda37 x7)))
  FlatCurry.Curry_Types.Choice_C_TypeExpr d i l r -> narrow d i
    (nd_OP_freshVariant_dot_rename_dot_224 x1 l s cd cs)
    (nd_OP_freshVariant_dot_rename_dot_224 x1 r s cd cs)
  FlatCurry.Curry_Types.Choices_C_TypeExpr d i xs -> narrows cs d i (\z ->
    nd_OP_freshVariant_dot_rename_dot_224 x1 z s cd cs) xs
  FlatCurry.Curry_Types.Guard_C_TypeExpr d c e -> guardCons d c
    (nd_OP_freshVariant_dot_rename_dot_224 x1 e s cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_TypeExpr d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.freshVariant.rename.224" [show x1, show
    x2] info)
  _ -> failCons cd (consFail
    "FlatCurry.Annotated.TypeInference.freshVariant.rename.224" (showCons x2))

d_OP_freshVariant_dot_rename_dot_224_dot_uscore_hash_lambda34 :: forall t1
  t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Curry_Prelude.C_Int
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> FlatCurry.Curry_Types.C_TypeExpr -> Cover
  -> ConstStore -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_Either t1
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) FlatCurry.Curry_Types.C_TypeExpr) t0)
d_OP_freshVariant_dot_rename_dot_224_dot_uscore_hash_lambda34 x1 x2 x3 cd cs =
  Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Cons
  (Curry_Prelude.OP_Tuple2 x1 x3) x2) x3)

d_OP_freshVariant_dot_rename_dot_224_dot_uscore_hash_lambda35 :: FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr))
  FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))
d_OP_freshVariant_dot_rename_dot_224_dot_uscore_hash_lambda35 x1 x2 cd cs =
  case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> Curry_ErrorState.d_OP_gt_plus_eq
    (d_OP_freshVariant_dot_rename_dot_224 x3 x1 cd cs)
    (d_OP_freshVariant_dot_rename_dot_224_dot_uscore_hash_lambda35_dot_uscore_hash_lambda36
    x4)
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_freshVariant_dot_rename_dot_224_dot_uscore_hash_lambda35 x1 l cd cs)
    (d_OP_freshVariant_dot_rename_dot_224_dot_uscore_hash_lambda35 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_freshVariant_dot_rename_dot_224_dot_uscore_hash_lambda35 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_freshVariant_dot_rename_dot_224_dot_uscore_hash_lambda35 x1 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.freshVariant.rename.224._#lambda35" [show
    x1, show x2] info)
  _ -> failCons cd (consFail
    "FlatCurry.Annotated.TypeInference.freshVariant.rename.224._#lambda35"
    (showCons x2))

nd_OP_freshVariant_dot_rename_dot_224_dot_uscore_hash_lambda35 :: FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr))
  FlatCurry.Curry_Types.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))))
nd_OP_freshVariant_dot_rename_dot_224_dot_uscore_hash_lambda35 x1 x2 s cd cs =
  case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> let s0 = s
    in s0 `seq` wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq
    (nd_OP_freshVariant_dot_rename_dot_224 x3 x1 s0 cd cs) (wrapDX (wrapDX id)
    (d_OP_freshVariant_dot_rename_dot_224_dot_uscore_hash_lambda35_dot_uscore_hash_lambda36
    x4)))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_freshVariant_dot_rename_dot_224_dot_uscore_hash_lambda35 x1 l s cd
    cs) (nd_OP_freshVariant_dot_rename_dot_224_dot_uscore_hash_lambda35 x1 r s
    cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_freshVariant_dot_rename_dot_224_dot_uscore_hash_lambda35 x1 z s cd cs)
    xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (nd_OP_freshVariant_dot_rename_dot_224_dot_uscore_hash_lambda35 x1 e s cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.freshVariant.rename.224._#lambda35" [show
    x1, show x2] info)
  _ -> failCons cd (consFail
    "FlatCurry.Annotated.TypeInference.freshVariant.rename.224._#lambda35"
    (showCons x2))

d_OP_freshVariant_dot_rename_dot_224_dot_uscore_hash_lambda35_dot_uscore_hash_lambda36 :: forall t1
  t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => FlatCurry.Curry_Types.C_TypeExpr -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) FlatCurry.Curry_Types.C_TypeExpr -> Cover
  -> ConstStore -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_Either t1
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) FlatCurry.Curry_Types.C_TypeExpr) t0)
d_OP_freshVariant_dot_rename_dot_224_dot_uscore_hash_lambda35_dot_uscore_hash_lambda36 x1 x2 cd cs =
  case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> Curry_ErrorState.d_C_returnES
    (Curry_Prelude.OP_Tuple2 x3 (FlatCurry.Curry_Types.C_FuncType x1 x4))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_freshVariant_dot_rename_dot_224_dot_uscore_hash_lambda35_dot_uscore_hash_lambda36
    x1 l cd cs)
    (d_OP_freshVariant_dot_rename_dot_224_dot_uscore_hash_lambda35_dot_uscore_hash_lambda36
    x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_freshVariant_dot_rename_dot_224_dot_uscore_hash_lambda35_dot_uscore_hash_lambda36
    x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_freshVariant_dot_rename_dot_224_dot_uscore_hash_lambda35_dot_uscore_hash_lambda36
    x1 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.freshVariant.rename.224._#lambda35._#lambda36"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "FlatCurry.Annotated.TypeInference.freshVariant.rename.224._#lambda35._#lambda36"
    (showCons x2))

d_OP_freshVariant_dot_rename_dot_224_dot_uscore_hash_lambda37 :: forall t1
  t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore -> t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr))
  FlatCurry.Curry_Types.C_TypeExpr) t0)
d_OP_freshVariant_dot_rename_dot_224_dot_uscore_hash_lambda37 x1 x2 cd cs =
  case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> Curry_ErrorState.d_C_returnES
    (Curry_Prelude.OP_Tuple2 x3 (FlatCurry.Curry_Types.C_TCons x1 x4))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_freshVariant_dot_rename_dot_224_dot_uscore_hash_lambda37 x1 l cd cs)
    (d_OP_freshVariant_dot_rename_dot_224_dot_uscore_hash_lambda37 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_freshVariant_dot_rename_dot_224_dot_uscore_hash_lambda37 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_freshVariant_dot_rename_dot_224_dot_uscore_hash_lambda37 x1 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.freshVariant.rename.224._#lambda37" [show
    x1, show x2] info)
  _ -> failCons cd (consFail
    "FlatCurry.Annotated.TypeInference.freshVariant.rename.224._#lambda37"
    (showCons x2))

d_C_annProg :: FlatCurry.Curry_Types.C_Prog -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AProg
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))
d_C_annProg x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_Prog x2 x3 x4 x5 x6 -> Curry_ErrorState.d_OP_lt_dollar_gt
    (d_OP_annProg_dot_uscore_hash_lambda38 x3 x2 x6 x4)
    (Curry_ErrorState.d_C_mapES d_C_annFunc x5 cd cs) cd cs
  FlatCurry.Curry_Types.Choice_C_Prog d i l r -> narrow d i (d_C_annProg l cd
    cs) (d_C_annProg r cd cs)
  FlatCurry.Curry_Types.Choices_C_Prog d i xs -> narrows cs d i (\z ->
    d_C_annProg z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Prog d c e -> guardCons d c (d_C_annProg e cd $!
    addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Prog d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.annProg" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference.annProg"
    (showCons x1))

nd_C_annProg :: FlatCurry.Curry_Types.C_Prog -> IDSupply -> Cover -> ConstStore
  -> Func (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AProg FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))))
nd_C_annProg x1 s cd cs = case x1 of
  FlatCurry.Curry_Types.C_Prog x2 x3 x4 x5 x6 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_ErrorState.nd_OP_lt_dollar_gt (wrapDX id
    (d_OP_annProg_dot_uscore_hash_lambda38 x3 x2 x6 x4))
    (Curry_ErrorState.nd_C_mapES (wrapNX id nd_C_annFunc) x5 s0 cd cs) s1 cd
    cs))
  FlatCurry.Curry_Types.Choice_C_Prog d i l r -> narrow d i (nd_C_annProg l s cd
    cs) (nd_C_annProg r s cd cs)
  FlatCurry.Curry_Types.Choices_C_Prog d i xs -> narrows cs d i (\z ->
    nd_C_annProg z s cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Prog d c e -> guardCons d c (nd_C_annProg e s
    cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Prog d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.annProg" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference.annProg"
    (showCons x1))

d_OP_annProg_dot_uscore_hash_lambda38 :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_OpDecl
  -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_TypeDecl
  -> Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> FlatCurry.Annotated.Curry_Types.C_AProg FlatCurry.Curry_Types.C_TypeExpr
d_OP_annProg_dot_uscore_hash_lambda38 x1 x2 x3 x4 x5 cd cs =
  FlatCurry.Annotated.Curry_Types.C_AProg x2 x1 x4 x5 x3

d_C_annFuncGroup :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_FuncDecl
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))
d_C_annFuncGroup x1 cd cs = let x2 = Curry_Prelude.d_C_foldr (acceptCs id
                                  d_OP_annFuncGroup_dot_uscore_hash_lambda41)
                                  Curry_Prelude.OP_List x1 cd cs
  in Curry_ErrorState.d_OP_gt_plus (Curry_ErrorState.d_OP_gt_plus
  (d_C_initSigEnv cd cs) (Curry_ErrorState.d_C_mapES (Curry_Prelude.d_C_uncurry
  (acceptCs id d_C_insertFunType)) x2 cd cs) cd cs) (Curry_ErrorState.d_C_mapES
  d_C_annFunc x1 cd cs) cd cs

nd_C_annFuncGroup :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_FuncDecl
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))))
nd_C_annFuncGroup x1 s cd cs = let s10 = s
  in s10 `seq` (let s0 = leftSupply s10
                    s8 = rightSupply s10
  in s0 `seq` (s8 `seq` (let x2 = Curry_Prelude.nd_C_foldr (wrapDX (wrapDX id)
                               (acceptCs id
                               d_OP_annFuncGroup_dot_uscore_hash_lambda41))
                               Curry_Prelude.OP_List x1 s0 cd cs
  in let s7 = leftSupply s8
         s9 = rightSupply s8
         s4 = leftSupply s9
         s6 = rightSupply s9
  in s7 `seq` (s9 `seq` (s4 `seq` (s6 `seq` Curry_ErrorState.nd_OP_gt_plus
  (let s3 = leftSupply s4
       s5 = rightSupply s4
       s1 = leftSupply s5
       s2 = rightSupply s5
  in s3 `seq` (s5 `seq` (s1 `seq` (s2 `seq` Curry_ErrorState.nd_OP_gt_plus
  (nd_C_initSigEnv s1 cd cs) (Curry_ErrorState.nd_C_mapES (wrapNX id
  (Curry_Prelude.nd_C_uncurry (wrapDX (wrapNX id) (acceptCs id
  nd_C_insertFunType)))) x2 s2 cd cs) s3 cd cs)))) (Curry_ErrorState.nd_C_mapES
  (wrapNX id nd_C_annFunc) x1 s6 cd cs) s7 cd cs))))))

d_OP_annFuncGroup_dot_uscore_hash_lambda41 :: FlatCurry.Curry_Types.C_FuncDecl
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr)
d_OP_annFuncGroup_dot_uscore_hash_lambda41 x1 x2 cd cs = case x1 of
  FlatCurry.Curry_Types.C_Func x3 x4 x5 x6 x7 -> Curry_Prelude.OP_Cons
    (Curry_Prelude.OP_Tuple2 x3 x6) x2
  FlatCurry.Curry_Types.Choice_C_FuncDecl d i l r -> narrow d i
    (d_OP_annFuncGroup_dot_uscore_hash_lambda41 l x2 cd cs)
    (d_OP_annFuncGroup_dot_uscore_hash_lambda41 r x2 cd cs)
  FlatCurry.Curry_Types.Choices_C_FuncDecl d i xs -> narrows cs d i (\z ->
    d_OP_annFuncGroup_dot_uscore_hash_lambda41 z x2 cd cs) xs
  FlatCurry.Curry_Types.Guard_C_FuncDecl d c e -> guardCons d c
    (d_OP_annFuncGroup_dot_uscore_hash_lambda41 e x2 cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_FuncDecl d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.annFuncGroup._#lambda41" [show x1, show
    x2] info)
  _ -> failCons cd (consFail
    "FlatCurry.Annotated.TypeInference.annFuncGroup._#lambda41" (showCons x1))

d_C_annFunc :: FlatCurry.Curry_Types.C_FuncDecl -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))
d_C_annFunc x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_Func x2 x3 x4 x5 x6 -> Curry_ErrorState.d_OP_gt_plus
    (d_C_initVarTypes cd cs) (Curry_ErrorState.d_OP_lt_star_gt
    (Curry_ErrorState.d_OP_lt_dollar_gt (acceptCs (acceptCs id)
    (FlatCurry.Annotated.Curry_Types.C_AFunc x2 x3 x4))
    (Curry_ErrorState.d_OP_lt_dollar_gt Curry_Prelude.d_C_snd
    (d_C_getTypeVariant x2 cd cs) cd cs) cd cs) (d_C_annRule x6 cd cs) cd cs) cd
    cs
  FlatCurry.Curry_Types.Choice_C_FuncDecl d i l r -> narrow d i (d_C_annFunc l
    cd cs) (d_C_annFunc r cd cs)
  FlatCurry.Curry_Types.Choices_C_FuncDecl d i xs -> narrows cs d i (\z ->
    d_C_annFunc z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_FuncDecl d c e -> guardCons d c (d_C_annFunc e
    cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_FuncDecl d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.annFunc" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference.annFunc"
    (showCons x1))

nd_C_annFunc :: FlatCurry.Curry_Types.C_FuncDecl -> IDSupply -> Cover
  -> ConstStore -> Func (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))))
nd_C_annFunc x1 s cd cs = case x1 of
  FlatCurry.Curry_Types.C_Func x2 x3 x4 x5 x6 -> let s11 = s
    in s11 `seq` (let s10 = leftSupply s11
                      s12 = rightSupply s11
                      s0 = leftSupply s12
                      s8 = rightSupply s12
    in s10 `seq` (s12 `seq` (s0 `seq` (s8 `seq` Curry_ErrorState.nd_OP_gt_plus
    (nd_C_initVarTypes s0 cd cs) (let s7 = leftSupply s8
                                      s9 = rightSupply s8
                                      s5 = leftSupply s9
                                      s6 = rightSupply s9
    in s7 `seq` (s9 `seq` (s5 `seq` (s6 `seq` Curry_ErrorState.nd_OP_lt_star_gt
    (let s4 = leftSupply s5
         s3 = rightSupply s5
    in s4 `seq` (s3 `seq` Curry_ErrorState.nd_OP_lt_dollar_gt (wrapDX (wrapDX
    id) (acceptCs (acceptCs id) (FlatCurry.Annotated.Curry_Types.C_AFunc x2 x3
    x4))) (let s2 = leftSupply s3
               s1 = rightSupply s3
    in s2 `seq` (s1 `seq` Curry_ErrorState.nd_OP_lt_dollar_gt (wrapDX id
    Curry_Prelude.d_C_snd) (nd_C_getTypeVariant x2 s1 cd cs) s2 cd cs)) s4 cd
    cs)) (nd_C_annRule x6 s6 cd cs) s7 cd cs)))) s10 cd cs))))
  FlatCurry.Curry_Types.Choice_C_FuncDecl d i l r -> narrow d i (nd_C_annFunc l
    s cd cs) (nd_C_annFunc r s cd cs)
  FlatCurry.Curry_Types.Choices_C_FuncDecl d i xs -> narrows cs d i (\z ->
    nd_C_annFunc z s cd cs) xs
  FlatCurry.Curry_Types.Guard_C_FuncDecl d c e -> guardCons d c (nd_C_annFunc e
    s cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_FuncDecl d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.annFunc" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference.annFunc"
    (showCons x1))

d_C_annRule :: FlatCurry.Curry_Types.C_Rule -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_ARule
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))
d_C_annRule x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_Rule x2 x3 -> Curry_ErrorState.d_OP_lt_star_gt
    (Curry_ErrorState.d_OP_lt_star_gt (Curry_ErrorState.d_OP_lt_dollar_gt
    (acceptCs (acceptCs (acceptCs id)) FlatCurry.Annotated.Curry_Types.C_ARule)
    (d_C_nextTVar cd cs) cd cs) (Curry_ErrorState.d_C_mapES d_C_annVar x2 cd cs)
    cd cs) (d_C_annExpr x3 cd cs) cd cs
  FlatCurry.Curry_Types.C_External x4 -> Curry_ErrorState.d_OP_lt_dollar_gt
    (Curry_Prelude.d_C_flip (acceptCs (acceptCs id)
    FlatCurry.Annotated.Curry_Types.C_AExternal) x4) (d_C_nextTVar cd cs) cd cs
  FlatCurry.Curry_Types.Choice_C_Rule d i l r -> narrow d i (d_C_annRule l cd
    cs) (d_C_annRule r cd cs)
  FlatCurry.Curry_Types.Choices_C_Rule d i xs -> narrows cs d i (\z ->
    d_C_annRule z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Rule d c e -> guardCons d c (d_C_annRule e cd $!
    addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Rule d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.annRule" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference.annRule"
    (showCons x1))

nd_C_annRule :: FlatCurry.Curry_Types.C_Rule -> IDSupply -> Cover -> ConstStore
  -> Func (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_ARule FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))))
nd_C_annRule x1 s cd cs = case x1 of
  FlatCurry.Curry_Types.C_Rule x2 x3 -> let s9 = s
    in s9 `seq` (let s8 = leftSupply s9
                     s10 = rightSupply s9
                     s5 = leftSupply s10
                     s7 = rightSupply s10
    in s8 `seq` (s10 `seq` (s5 `seq` (s7 `seq` Curry_ErrorState.nd_OP_lt_star_gt
    (let s4 = leftSupply s5
         s6 = rightSupply s5
         s2 = leftSupply s6
         s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s2 `seq` (s3 `seq` Curry_ErrorState.nd_OP_lt_star_gt
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_ErrorState.nd_OP_lt_dollar_gt (wrapDX (wrapDX
    (wrapDX id)) (acceptCs (acceptCs (acceptCs id))
    FlatCurry.Annotated.Curry_Types.C_ARule)) (nd_C_nextTVar s0 cd cs) s1 cd
    cs)) (Curry_ErrorState.nd_C_mapES (wrapNX id nd_C_annVar) x2 s3 cd cs) s4 cd
    cs)))) (nd_C_annExpr x3 s7 cd cs) s8 cd cs))))
  FlatCurry.Curry_Types.C_External x4 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_ErrorState.nd_OP_lt_dollar_gt (wrapNX id
    (Curry_Prelude.nd_C_flip (wrapDX (wrapDX id) (acceptCs (acceptCs id)
    FlatCurry.Annotated.Curry_Types.C_AExternal)) x4)) (nd_C_nextTVar s0 cd cs)
    s1 cd cs))
  FlatCurry.Curry_Types.Choice_C_Rule d i l r -> narrow d i (nd_C_annRule l s cd
    cs) (nd_C_annRule r s cd cs)
  FlatCurry.Curry_Types.Choices_C_Rule d i xs -> narrows cs d i (\z ->
    nd_C_annRule z s cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Rule d c e -> guardCons d c (nd_C_annRule e s
    cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Rule d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.annRule" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference.annRule"
    (showCons x1))

d_C_annExpr :: FlatCurry.Curry_Types.C_Expr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))
d_C_annExpr x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_Var x2 -> let x3 = Curry_Prelude.d_OP_plus_plus
                                          (Curry_Prelude.toCurryString
                                          "Variable ")
                                          (Curry_Prelude.d_OP_plus_plus
                                          (Curry_Prelude.d_C_show x2 cd cs)
                                          (Curry_Prelude.toCurryString
                                          " not initialized with a type!") cd
                                          cs) cd cs
    in Curry_ErrorState.d_OP_gt_plus_eq (d_C_lookupVarType x2 cd cs)
    (Curry_Prelude.d_C_maybe (Curry_ErrorState.d_C_failES x3)
    (d_OP_annExpr_dot_uscore_hash_lambda43 x2))
  FlatCurry.Curry_Types.C_Lit x4 -> Curry_ErrorState.d_OP_gt_plus_eq
    (d_C_nextTVar cd cs) (d_OP_annExpr_dot_uscore_hash_lambda44 x4)
  FlatCurry.Curry_Types.C_Comb x5 x6 x7 -> Curry_ErrorState.d_OP_lt_star_gt
    (Curry_ErrorState.d_OP_lt_star_gt (Curry_ErrorState.d_OP_lt_dollar_gt
    (Curry_Prelude.d_C_flip (acceptCs (acceptCs (acceptCs (acceptCs id)))
    FlatCurry.Annotated.Curry_Types.C_AComb) x5) (d_C_nextTVar cd cs) cd cs)
    (d_C_getTypeVariant x6 cd cs) cd cs) (Curry_ErrorState.d_C_mapES d_C_annExpr
    x7 cd cs) cd cs
  FlatCurry.Curry_Types.C_Case x8 x9 x10 -> Curry_ErrorState.d_OP_lt_star_gt
    (Curry_ErrorState.d_OP_lt_star_gt (Curry_ErrorState.d_OP_lt_dollar_gt
    (Curry_Prelude.d_C_flip (acceptCs (acceptCs (acceptCs (acceptCs id)))
    FlatCurry.Annotated.Curry_Types.C_ACase) x8) (d_C_nextTVar cd cs) cd cs)
    (d_C_annExpr x9 cd cs) cd cs) (Curry_ErrorState.d_C_mapES d_C_annBranch x10
    cd cs) cd cs
  FlatCurry.Curry_Types.C_Or x11 x12 -> Curry_ErrorState.d_OP_lt_star_gt
    (Curry_ErrorState.d_OP_lt_star_gt (Curry_ErrorState.d_OP_lt_dollar_gt
    (acceptCs (acceptCs (acceptCs id)) FlatCurry.Annotated.Curry_Types.C_AOr)
    (d_C_nextTVar cd cs) cd cs) (d_C_annExpr x11 cd cs) cd cs) (d_C_annExpr x12
    cd cs) cd cs
  FlatCurry.Curry_Types.C_Let x13 x14 -> Curry_ErrorState.d_OP_lt_star_gt
    (Curry_ErrorState.d_OP_lt_star_gt (Curry_ErrorState.d_OP_lt_dollar_gt
    (acceptCs (acceptCs (acceptCs id)) FlatCurry.Annotated.Curry_Types.C_ALet)
    (d_C_nextTVar cd cs) cd cs) (d_OP_annExpr_dot_annBindings_dot_270 x13 cd cs)
    cd cs) (d_C_annExpr x14 cd cs) cd cs
  FlatCurry.Curry_Types.C_Free x15 x16 -> Curry_ErrorState.d_OP_lt_star_gt
    (Curry_ErrorState.d_OP_lt_star_gt (Curry_ErrorState.d_OP_lt_dollar_gt
    (acceptCs (acceptCs (acceptCs id)) FlatCurry.Annotated.Curry_Types.C_AFree)
    (d_C_nextTVar cd cs) cd cs) (Curry_ErrorState.d_C_mapES
    d_OP_annExpr_dot_annFree_dot_280 x15 cd cs) cd cs) (d_C_annExpr x16 cd cs)
    cd cs
  FlatCurry.Curry_Types.C_Typed x17 x18 -> Curry_ErrorState.d_OP_lt_star_gt
    (Curry_ErrorState.d_OP_lt_star_gt (Curry_ErrorState.d_OP_lt_dollar_gt
    (acceptCs (acceptCs (acceptCs id)) FlatCurry.Annotated.Curry_Types.C_ATyped)
    (d_C_nextTVar cd cs) cd cs) (d_C_annExpr x17 cd cs) cd cs) (d_C_freshVariant
    x18 cd cs) cd cs
  FlatCurry.Curry_Types.Choice_C_Expr d i l r -> narrow d i (d_C_annExpr l cd
    cs) (d_C_annExpr r cd cs)
  FlatCurry.Curry_Types.Choices_C_Expr d i xs -> narrows cs d i (\z ->
    d_C_annExpr z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Expr d c e -> guardCons d c (d_C_annExpr e cd $!
    addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Expr d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.annExpr" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference.annExpr"
    (showCons x1))

nd_C_annExpr :: FlatCurry.Curry_Types.C_Expr -> IDSupply -> Cover -> ConstStore
  -> Func (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))))
nd_C_annExpr x1 s cd cs = case x1 of
  FlatCurry.Curry_Types.C_Var x2 -> let s0 = s
    in s0 `seq` (let x3 = Curry_Prelude.d_OP_plus_plus
                       (Curry_Prelude.toCurryString "Variable ")
                       (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_show x2
                       cd cs) (Curry_Prelude.toCurryString
                       " not initialized with a type!") cd cs) cd cs
    in wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (nd_C_lookupVarType x2 s0 cd
    cs) (wrapNX id (Curry_Prelude.nd_C_maybe (wrapDX id
    (Curry_ErrorState.d_C_failES x3)) (wrapDX (wrapDX id)
    (d_OP_annExpr_dot_uscore_hash_lambda43 x2))))))
  FlatCurry.Curry_Types.C_Lit x4 -> let s0 = s
    in s0 `seq` wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (nd_C_nextTVar s0
    cd cs) (wrapDX (wrapDX id) (d_OP_annExpr_dot_uscore_hash_lambda44 x4)))
  FlatCurry.Curry_Types.C_Comb x5 x6 x7 -> let s9 = s
    in s9 `seq` (let s8 = leftSupply s9
                     s10 = rightSupply s9
                     s5 = leftSupply s10
                     s7 = rightSupply s10
    in s8 `seq` (s10 `seq` (s5 `seq` (s7 `seq` Curry_ErrorState.nd_OP_lt_star_gt
    (let s4 = leftSupply s5
         s6 = rightSupply s5
         s2 = leftSupply s6
         s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s2 `seq` (s3 `seq` Curry_ErrorState.nd_OP_lt_star_gt
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_ErrorState.nd_OP_lt_dollar_gt (wrapNX id
    (Curry_Prelude.nd_C_flip (wrapDX (wrapDX (wrapDX (wrapDX id))) (acceptCs
    (acceptCs (acceptCs (acceptCs id)))
    FlatCurry.Annotated.Curry_Types.C_AComb)) x5)) (nd_C_nextTVar s0 cd cs) s1
    cd cs)) (nd_C_getTypeVariant x6 s3 cd cs) s4 cd cs))))
    (Curry_ErrorState.nd_C_mapES (wrapNX id nd_C_annExpr) x7 s7 cd cs) s8 cd
    cs))))
  FlatCurry.Curry_Types.C_Case x8 x9 x10 -> let s9 = s
    in s9 `seq` (let s8 = leftSupply s9
                     s10 = rightSupply s9
                     s5 = leftSupply s10
                     s7 = rightSupply s10
    in s8 `seq` (s10 `seq` (s5 `seq` (s7 `seq` Curry_ErrorState.nd_OP_lt_star_gt
    (let s4 = leftSupply s5
         s6 = rightSupply s5
         s2 = leftSupply s6
         s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s2 `seq` (s3 `seq` Curry_ErrorState.nd_OP_lt_star_gt
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_ErrorState.nd_OP_lt_dollar_gt (wrapNX id
    (Curry_Prelude.nd_C_flip (wrapDX (wrapDX (wrapDX (wrapDX id))) (acceptCs
    (acceptCs (acceptCs (acceptCs id)))
    FlatCurry.Annotated.Curry_Types.C_ACase)) x8)) (nd_C_nextTVar s0 cd cs) s1
    cd cs)) (nd_C_annExpr x9 s3 cd cs) s4 cd cs)))) (Curry_ErrorState.nd_C_mapES
    (wrapNX id nd_C_annBranch) x10 s7 cd cs) s8 cd cs))))
  FlatCurry.Curry_Types.C_Or x11 x12 -> let s9 = s
    in s9 `seq` (let s8 = leftSupply s9
                     s10 = rightSupply s9
                     s5 = leftSupply s10
                     s7 = rightSupply s10
    in s8 `seq` (s10 `seq` (s5 `seq` (s7 `seq` Curry_ErrorState.nd_OP_lt_star_gt
    (let s4 = leftSupply s5
         s6 = rightSupply s5
         s2 = leftSupply s6
         s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s2 `seq` (s3 `seq` Curry_ErrorState.nd_OP_lt_star_gt
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_ErrorState.nd_OP_lt_dollar_gt (wrapDX (wrapDX
    (wrapDX id)) (acceptCs (acceptCs (acceptCs id))
    FlatCurry.Annotated.Curry_Types.C_AOr)) (nd_C_nextTVar s0 cd cs) s1 cd cs))
    (nd_C_annExpr x11 s3 cd cs) s4 cd cs)))) (nd_C_annExpr x12 s7 cd cs) s8 cd
    cs))))
  FlatCurry.Curry_Types.C_Let x13 x14 -> let s9 = s
    in s9 `seq` (let s8 = leftSupply s9
                     s10 = rightSupply s9
                     s5 = leftSupply s10
                     s7 = rightSupply s10
    in s8 `seq` (s10 `seq` (s5 `seq` (s7 `seq` Curry_ErrorState.nd_OP_lt_star_gt
    (let s4 = leftSupply s5
         s6 = rightSupply s5
         s2 = leftSupply s6
         s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s2 `seq` (s3 `seq` Curry_ErrorState.nd_OP_lt_star_gt
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_ErrorState.nd_OP_lt_dollar_gt (wrapDX (wrapDX
    (wrapDX id)) (acceptCs (acceptCs (acceptCs id))
    FlatCurry.Annotated.Curry_Types.C_ALet)) (nd_C_nextTVar s0 cd cs) s1 cd cs))
    (nd_OP_annExpr_dot_annBindings_dot_270 x13 s3 cd cs) s4 cd cs))))
    (nd_C_annExpr x14 s7 cd cs) s8 cd cs))))
  FlatCurry.Curry_Types.C_Free x15 x16 -> let s9 = s
    in s9 `seq` (let s8 = leftSupply s9
                     s10 = rightSupply s9
                     s5 = leftSupply s10
                     s7 = rightSupply s10
    in s8 `seq` (s10 `seq` (s5 `seq` (s7 `seq` Curry_ErrorState.nd_OP_lt_star_gt
    (let s4 = leftSupply s5
         s6 = rightSupply s5
         s2 = leftSupply s6
         s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s2 `seq` (s3 `seq` Curry_ErrorState.nd_OP_lt_star_gt
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_ErrorState.nd_OP_lt_dollar_gt (wrapDX (wrapDX
    (wrapDX id)) (acceptCs (acceptCs (acceptCs id))
    FlatCurry.Annotated.Curry_Types.C_AFree)) (nd_C_nextTVar s0 cd cs) s1 cd
    cs)) (Curry_ErrorState.nd_C_mapES (wrapNX id
    nd_OP_annExpr_dot_annFree_dot_280) x15 s3 cd cs) s4 cd cs)))) (nd_C_annExpr
    x16 s7 cd cs) s8 cd cs))))
  FlatCurry.Curry_Types.C_Typed x17 x18 -> let s9 = s
    in s9 `seq` (let s8 = leftSupply s9
                     s10 = rightSupply s9
                     s5 = leftSupply s10
                     s7 = rightSupply s10
    in s8 `seq` (s10 `seq` (s5 `seq` (s7 `seq` Curry_ErrorState.nd_OP_lt_star_gt
    (let s4 = leftSupply s5
         s6 = rightSupply s5
         s2 = leftSupply s6
         s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s2 `seq` (s3 `seq` Curry_ErrorState.nd_OP_lt_star_gt
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_ErrorState.nd_OP_lt_dollar_gt (wrapDX (wrapDX
    (wrapDX id)) (acceptCs (acceptCs (acceptCs id))
    FlatCurry.Annotated.Curry_Types.C_ATyped)) (nd_C_nextTVar s0 cd cs) s1 cd
    cs)) (nd_C_annExpr x17 s3 cd cs) s4 cd cs)))) (nd_C_freshVariant x18 s7 cd
    cs) s8 cd cs))))
  FlatCurry.Curry_Types.Choice_C_Expr d i l r -> narrow d i (nd_C_annExpr l s cd
    cs) (nd_C_annExpr r s cd cs)
  FlatCurry.Curry_Types.Choices_C_Expr d i xs -> narrows cs d i (\z ->
    nd_C_annExpr z s cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Expr d c e -> guardCons d c (nd_C_annExpr e s
    cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Expr d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.annExpr" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference.annExpr"
    (showCons x1))

d_OP_annExpr_dot_uscore_hash_lambda43 :: forall t1 t0 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Curry_Prelude.C_Int
  -> FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore -> t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr) t0)
d_OP_annExpr_dot_uscore_hash_lambda43 x1 x2 cd cs =
  Curry_ErrorState.d_C_returnES (FlatCurry.Annotated.Curry_Types.C_AVar x2 x1)

d_OP_annExpr_dot_uscore_hash_lambda44 :: forall t1 t0 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => FlatCurry.Curry_Types.C_Literal
  -> FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore -> t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr) t0)
d_OP_annExpr_dot_uscore_hash_lambda44 x1 x2 cd cs =
  Curry_ErrorState.d_C_returnES (FlatCurry.Annotated.Curry_Types.C_ALit x2 x1)

d_OP_annExpr_dot_annBound_dot_270 :: Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))
d_OP_annExpr_dot_annBound_dot_270 x1 cd cs = Curry_ErrorState.d_OP_gt_plus
  (d_C_checkShadowing x1 cd cs) (d_C_annVar x1 cd cs) cd cs

nd_OP_annExpr_dot_annBound_dot_270 :: Curry_Prelude.C_Int -> IDSupply -> Cover
  -> ConstStore -> Func (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))))
nd_OP_annExpr_dot_annBound_dot_270 x1 s cd cs = let s3 = s
  in s3 `seq` (let s2 = leftSupply s3
                   s4 = rightSupply s3
                   s0 = leftSupply s4
                   s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_ErrorState.nd_OP_gt_plus
  (nd_C_checkShadowing x1 s0 cd cs) (nd_C_annVar x1 s1 cd cs) s2 cd cs))))

d_OP_annExpr_dot_annBindings_dot_270 :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int FlatCurry.Curry_Types.C_Expr)
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  (FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr)))
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))
d_OP_annExpr_dot_annBindings_dot_270 x1 cd cs = let x2 = Curry_Prelude.d_C_unzip
                                                      x1 cd cs
                                                    x3 = d_OP_annExpr_dot_annBindings_dot_270_dot_uscore_hash_selFP2_hash_vs
                                                      x2 cd cs
                                                    x4 = d_OP_annExpr_dot_annBindings_dot_270_dot_uscore_hash_selFP3_hash_es
                                                      x2 cd cs
  in Curry_ErrorState.d_OP_gt_plus_eq (Curry_ErrorState.d_C_mapES
  d_OP_annExpr_dot_annBound_dot_270 x3 cd cs)
  (d_OP_annExpr_dot_annBindings_dot_270_dot_uscore_hash_lambda45 x4)

nd_OP_annExpr_dot_annBindings_dot_270 :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int FlatCurry.Curry_Types.C_Expr)
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  (FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr)))
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))))
nd_OP_annExpr_dot_annBindings_dot_270 x1 s cd cs = let s0 = s
  in s0 `seq` (let x2 = Curry_Prelude.d_C_unzip x1 cd cs
                   x3 = d_OP_annExpr_dot_annBindings_dot_270_dot_uscore_hash_selFP2_hash_vs
                     x2 cd cs
                   x4 = d_OP_annExpr_dot_annBindings_dot_270_dot_uscore_hash_selFP3_hash_es
                     x2 cd cs
  in wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (Curry_ErrorState.nd_C_mapES
  (wrapNX id nd_OP_annExpr_dot_annBound_dot_270) x3 s0 cd cs) (wrapNX id
  (nd_OP_annExpr_dot_annBindings_dot_270_dot_uscore_hash_lambda45 x4))))

d_OP_annExpr_dot_annBindings_dot_270_dot_uscore_hash_selFP2_hash_vs :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Int) (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_Expr) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Int
d_OP_annExpr_dot_annBindings_dot_270_dot_uscore_hash_selFP2_hash_vs x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_annExpr_dot_annBindings_dot_270_dot_uscore_hash_selFP2_hash_vs l cd
    cs) (d_OP_annExpr_dot_annBindings_dot_270_dot_uscore_hash_selFP2_hash_vs r
    cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_annExpr_dot_annBindings_dot_270_dot_uscore_hash_selFP2_hash_vs z cd cs)
    xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_annExpr_dot_annBindings_dot_270_dot_uscore_hash_selFP2_hash_vs e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.annExpr.annBindings.270._#selFP2#vs"
    [show x1] info)
  _ -> failCons cd (consFail
    "FlatCurry.Annotated.TypeInference.annExpr.annBindings.270._#selFP2#vs"
    (showCons x1))

d_OP_annExpr_dot_annBindings_dot_270_dot_uscore_hash_selFP3_hash_es :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Int) (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_Expr) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_Expr
d_OP_annExpr_dot_annBindings_dot_270_dot_uscore_hash_selFP3_hash_es x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_annExpr_dot_annBindings_dot_270_dot_uscore_hash_selFP3_hash_es l cd
    cs) (d_OP_annExpr_dot_annBindings_dot_270_dot_uscore_hash_selFP3_hash_es r
    cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_annExpr_dot_annBindings_dot_270_dot_uscore_hash_selFP3_hash_es z cd cs)
    xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_annExpr_dot_annBindings_dot_270_dot_uscore_hash_selFP3_hash_es e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.annExpr.annBindings.270._#selFP3#es"
    [show x1] info)
  _ -> failCons cd (consFail
    "FlatCurry.Annotated.TypeInference.annExpr.annBindings.270._#selFP3#es"
    (showCons x1))

d_OP_annExpr_dot_annBindings_dot_270_dot_uscore_hash_lambda45 :: Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_Expr -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  (FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr)))
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))
d_OP_annExpr_dot_annBindings_dot_270_dot_uscore_hash_lambda45 x1 x2 cd cs =
  Curry_ErrorState.d_OP_gt_plus_eq (Curry_ErrorState.d_C_mapES d_C_annExpr x1 cd
  cs)
  (d_OP_annExpr_dot_annBindings_dot_270_dot_uscore_hash_lambda45_dot_uscore_hash_lambda46
  x2)

nd_OP_annExpr_dot_annBindings_dot_270_dot_uscore_hash_lambda45 :: Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_Expr -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr) -> IDSupply -> Cover
  -> ConstStore -> Func (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  (FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr)))
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))))
nd_OP_annExpr_dot_annBindings_dot_270_dot_uscore_hash_lambda45 x1 x2 s cd cs =
  let s0 = s
  in s0 `seq` wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq
  (Curry_ErrorState.nd_C_mapES (wrapNX id nd_C_annExpr) x1 s0 cd cs) (wrapDX
  (wrapDX id)
  (d_OP_annExpr_dot_annBindings_dot_270_dot_uscore_hash_lambda45_dot_uscore_hash_lambda46
  x2)))

d_OP_annExpr_dot_annBindings_dot_270_dot_uscore_hash_lambda45_dot_uscore_hash_lambda46 :: forall t1
  t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  -> Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore -> t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  (FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr)))
  t0)
d_OP_annExpr_dot_annBindings_dot_270_dot_uscore_hash_lambda45_dot_uscore_hash_lambda46 x1 x2 cd cs =
  Curry_ErrorState.d_C_returnES (Curry_Prelude.d_C_zip x1 x2 cd cs)

d_OP_annExpr_dot_annFree_dot_280 :: Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))
d_OP_annExpr_dot_annFree_dot_280 x1 cd cs = Curry_ErrorState.d_OP_gt_plus
  (d_C_checkShadowing x1 cd cs) (d_C_annVar x1 cd cs) cd cs

nd_OP_annExpr_dot_annFree_dot_280 :: Curry_Prelude.C_Int -> IDSupply -> Cover
  -> ConstStore -> Func (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))))
nd_OP_annExpr_dot_annFree_dot_280 x1 s cd cs = let s3 = s
  in s3 `seq` (let s2 = leftSupply s3
                   s4 = rightSupply s3
                   s0 = leftSupply s4
                   s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_ErrorState.nd_OP_gt_plus
  (nd_C_checkShadowing x1 s0 cd cs) (nd_C_annVar x1 s1 cd cs) s2 cd cs))))

d_C_annVar :: Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))
d_C_annVar x1 cd cs = Curry_ErrorState.d_OP_gt_plus_eq (d_C_nextTVar cd cs)
  (d_OP_annVar_dot_uscore_hash_lambda47 x1)

nd_C_annVar :: Curry_Prelude.C_Int -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))))
nd_C_annVar x1 s cd cs = let s0 = s
  in s0 `seq` wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (nd_C_nextTVar s0 cd
  cs) (wrapNX id (nd_OP_annVar_dot_uscore_hash_lambda47 x1)))

d_OP_annVar_dot_uscore_hash_lambda47 :: Curry_Prelude.C_Int
  -> FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))
d_OP_annVar_dot_uscore_hash_lambda47 x1 x2 cd cs = Curry_ErrorState.d_OP_gt_plus
  (d_C_insertVarType x1 x2 cd cs) (Curry_ErrorState.d_C_returnES
  (Curry_Prelude.OP_Tuple2 x1 x2)) cd cs

nd_OP_annVar_dot_uscore_hash_lambda47 :: Curry_Prelude.C_Int
  -> FlatCurry.Curry_Types.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))))
nd_OP_annVar_dot_uscore_hash_lambda47 x1 x2 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_ErrorState.nd_OP_gt_plus (nd_C_insertVarType x1 x2
  s0 cd cs) (wrapDX id (Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Tuple2
  x1 x2))) s1 cd cs))

d_C_checkShadowing :: Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))
d_C_checkShadowing x1 cd cs = let x2 = Curry_Prelude.d_OP_plus_plus
                                    (Curry_Prelude.toCurryString
                                    "shadowing with variable ")
                                    (Curry_Prelude.d_OP_plus_plus
                                    (Curry_Prelude.d_C_show x1 cd cs)
                                    (Curry_Prelude.toCurryString " occurred!")
                                    cd cs) cd cs
  in Curry_ErrorState.d_OP_gt_plus_eq (d_C_lookupVarType x1 cd cs)
  (Curry_Prelude.d_C_maybe (Curry_ErrorState.d_C_returnES Curry_Prelude.OP_Unit)
  (d_OP_checkShadowing_dot_uscore_hash_lambda48 x2))

nd_C_checkShadowing :: Curry_Prelude.C_Int -> IDSupply -> Cover -> ConstStore
  -> Func (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))))
nd_C_checkShadowing x1 s cd cs = let s0 = s
  in s0 `seq` (let x2 = Curry_Prelude.d_OP_plus_plus
                     (Curry_Prelude.toCurryString "shadowing with variable ")
                     (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_show x1 cd
                     cs) (Curry_Prelude.toCurryString " occurred!") cd cs) cd cs
  in wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (nd_C_lookupVarType x1 s0 cd
  cs) (wrapNX id (Curry_Prelude.nd_C_maybe (wrapDX id
  (Curry_ErrorState.d_C_returnES Curry_Prelude.OP_Unit)) (wrapDX (wrapDX id)
  (d_OP_checkShadowing_dot_uscore_hash_lambda48 x2))))))

d_OP_checkShadowing_dot_uscore_hash_lambda48 :: forall t1
  t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> FlatCurry.Curry_Types.C_TypeExpr -> Cover
  -> ConstStore -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 t1 t0)
d_OP_checkShadowing_dot_uscore_hash_lambda48 x1 x2 cd cs =
  Curry_ErrorState.d_C_failES x1

d_C_annBranch :: FlatCurry.Curry_Types.C_BranchExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_ABranchExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))
d_C_annBranch x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_Branch x2 x3 -> Curry_ErrorState.d_OP_lt_star_gt
    (Curry_ErrorState.d_OP_lt_dollar_gt (acceptCs (acceptCs id)
    FlatCurry.Annotated.Curry_Types.C_ABranch) (d_C_annPattern x2 cd cs) cd cs)
    (d_C_annExpr x3 cd cs) cd cs
  FlatCurry.Curry_Types.Choice_C_BranchExpr d i l r -> narrow d i (d_C_annBranch
    l cd cs) (d_C_annBranch r cd cs)
  FlatCurry.Curry_Types.Choices_C_BranchExpr d i xs -> narrows cs d i (\z ->
    d_C_annBranch z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_BranchExpr d c e -> guardCons d c (d_C_annBranch
    e cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_BranchExpr d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.annBranch" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference.annBranch"
    (showCons x1))

nd_C_annBranch :: FlatCurry.Curry_Types.C_BranchExpr -> IDSupply -> Cover
  -> ConstStore -> Func (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_ABranchExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))))
nd_C_annBranch x1 s cd cs = case x1 of
  FlatCurry.Curry_Types.C_Branch x2 x3 -> let s5 = s
    in s5 `seq` (let s4 = leftSupply s5
                     s6 = rightSupply s5
                     s2 = leftSupply s6
                     s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s2 `seq` (s3 `seq` Curry_ErrorState.nd_OP_lt_star_gt
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_ErrorState.nd_OP_lt_dollar_gt (wrapDX (wrapDX
    id) (acceptCs (acceptCs id) FlatCurry.Annotated.Curry_Types.C_ABranch))
    (nd_C_annPattern x2 s0 cd cs) s1 cd cs)) (nd_C_annExpr x3 s3 cd cs) s4 cd
    cs))))
  FlatCurry.Curry_Types.Choice_C_BranchExpr d i l r -> narrow d i
    (nd_C_annBranch l s cd cs) (nd_C_annBranch r s cd cs)
  FlatCurry.Curry_Types.Choices_C_BranchExpr d i xs -> narrows cs d i (\z ->
    nd_C_annBranch z s cd cs) xs
  FlatCurry.Curry_Types.Guard_C_BranchExpr d c e -> guardCons d c
    (nd_C_annBranch e s cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_BranchExpr d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.annBranch" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference.annBranch"
    (showCons x1))

d_C_annPattern :: FlatCurry.Curry_Types.C_Pattern -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_APattern
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))
d_C_annPattern x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_Pattern x2 x3 -> Curry_ErrorState.d_OP_lt_star_gt
    (Curry_ErrorState.d_OP_lt_star_gt (Curry_ErrorState.d_OP_lt_dollar_gt
    (acceptCs (acceptCs (acceptCs id))
    FlatCurry.Annotated.Curry_Types.C_APattern) (d_C_nextTVar cd cs) cd cs)
    (d_C_getTypeVariant x2 cd cs) cd cs) (Curry_ErrorState.d_C_mapES
    d_OP_annPattern_dot_annPVar_dot_296 x3 cd cs) cd cs
  FlatCurry.Curry_Types.C_LPattern x4 -> Curry_ErrorState.d_OP_lt_dollar_gt
    (Curry_Prelude.d_C_flip (acceptCs (acceptCs id)
    FlatCurry.Annotated.Curry_Types.C_ALPattern) x4) (d_C_nextTVar cd cs) cd cs
  FlatCurry.Curry_Types.Choice_C_Pattern d i l r -> narrow d i (d_C_annPattern l
    cd cs) (d_C_annPattern r cd cs)
  FlatCurry.Curry_Types.Choices_C_Pattern d i xs -> narrows cs d i (\z ->
    d_C_annPattern z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Pattern d c e -> guardCons d c (d_C_annPattern e
    cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Pattern d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.annPattern" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference.annPattern"
    (showCons x1))

nd_C_annPattern :: FlatCurry.Curry_Types.C_Pattern -> IDSupply -> Cover
  -> ConstStore -> Func (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_APattern FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))))
nd_C_annPattern x1 s cd cs = case x1 of
  FlatCurry.Curry_Types.C_Pattern x2 x3 -> let s9 = s
    in s9 `seq` (let s8 = leftSupply s9
                     s10 = rightSupply s9
                     s5 = leftSupply s10
                     s7 = rightSupply s10
    in s8 `seq` (s10 `seq` (s5 `seq` (s7 `seq` Curry_ErrorState.nd_OP_lt_star_gt
    (let s4 = leftSupply s5
         s6 = rightSupply s5
         s2 = leftSupply s6
         s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s2 `seq` (s3 `seq` Curry_ErrorState.nd_OP_lt_star_gt
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_ErrorState.nd_OP_lt_dollar_gt (wrapDX (wrapDX
    (wrapDX id)) (acceptCs (acceptCs (acceptCs id))
    FlatCurry.Annotated.Curry_Types.C_APattern)) (nd_C_nextTVar s0 cd cs) s1 cd
    cs)) (nd_C_getTypeVariant x2 s3 cd cs) s4 cd cs))))
    (Curry_ErrorState.nd_C_mapES (wrapNX id
    nd_OP_annPattern_dot_annPVar_dot_296) x3 s7 cd cs) s8 cd cs))))
  FlatCurry.Curry_Types.C_LPattern x4 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_ErrorState.nd_OP_lt_dollar_gt (wrapNX id
    (Curry_Prelude.nd_C_flip (wrapDX (wrapDX id) (acceptCs (acceptCs id)
    FlatCurry.Annotated.Curry_Types.C_ALPattern)) x4)) (nd_C_nextTVar s0 cd cs)
    s1 cd cs))
  FlatCurry.Curry_Types.Choice_C_Pattern d i l r -> narrow d i (nd_C_annPattern
    l s cd cs) (nd_C_annPattern r s cd cs)
  FlatCurry.Curry_Types.Choices_C_Pattern d i xs -> narrows cs d i (\z ->
    nd_C_annPattern z s cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Pattern d c e -> guardCons d c (nd_C_annPattern
    e s cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Pattern d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.annPattern" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference.annPattern"
    (showCons x1))

d_OP_annPattern_dot_annPVar_dot_296 :: Curry_Prelude.C_Int -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))
d_OP_annPattern_dot_annPVar_dot_296 x1 cd cs = Curry_ErrorState.d_OP_gt_plus
  (d_C_checkShadowing x1 cd cs) (d_C_annVar x1 cd cs) cd cs

nd_OP_annPattern_dot_annPVar_dot_296 :: Curry_Prelude.C_Int -> IDSupply -> Cover
  -> ConstStore -> Func (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))))
nd_OP_annPattern_dot_annPVar_dot_296 x1 s cd cs = let s3 = s
  in s3 `seq` (let s2 = leftSupply s3
                   s4 = rightSupply s3
                   s0 = leftSupply s4
                   s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_ErrorState.nd_OP_gt_plus
  (nd_C_checkShadowing x1 s0 cd cs) (nd_C_annVar x1 s1 cd cs) s2 cd cs))))

d_OP_eq_dot_eq :: FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 FlatCurry.Curry_Types.C_TypeExpr
  FlatCurry.Curry_Types.C_TypeExpr
d_OP_eq_dot_eq x1 x2 cd cs = Curry_Prelude.OP_Tuple2 x1 x2

d_C_showTypeEqs :: Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 FlatCurry.Curry_Types.C_TypeExpr
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showTypeEqs cd cs = Curry_Prelude.d_OP_dot Curry_Prelude.d_C_unlines
  (Curry_Prelude.d_C_map d_OP_showTypeEqs_dot_showEquation_dot_304) cd cs

d_OP_showTypeEqs_dot_showEquation_dot_304 :: forall t0 t1 . (Curry_Prelude.Curry
  t0, Curry_Prelude.Curry t1) => Curry_Prelude.OP_Tuple2 t0 t1 -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_showTypeEqs_dot_showEquation_dot_304 x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_show x2 cd cs) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " =.= ") (Curry_Prelude.d_C_show x3 cd cs) cd
    cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_showTypeEqs_dot_showEquation_dot_304 l cd cs)
    (d_OP_showTypeEqs_dot_showEquation_dot_304 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_showTypeEqs_dot_showEquation_dot_304 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_showTypeEqs_dot_showEquation_dot_304 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.showTypeEqs.showEquation.304" [show x1]
    info)
  _ -> failCons cd (consFail
    "FlatCurry.Annotated.TypeInference.showTypeEqs.showEquation.304" (showCons
    x1))

d_OP_plus_plus_eq :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))) -> (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))
d_OP_plus_plus_eq x1 x2 cd cs = Curry_ErrorState.d_OP_lt_star_gt
  (Curry_ErrorState.d_OP_lt_dollar_gt (acceptCs id Curry_Prelude.d_OP_plus_plus)
  x1 cd cs) x2 cd cs

nd_OP_plus_plus_eq :: forall t0 . (Curry_Prelude.Curry t0) => Func
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))) -> Func (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))) -> IDSupply -> Cover -> ConstStore
  -> Func (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))))
nd_OP_plus_plus_eq x1 x2 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_ErrorState.nd_OP_lt_star_gt
  (Curry_ErrorState.nd_OP_lt_dollar_gt (wrapDX (wrapDX id) (acceptCs id
  Curry_Prelude.d_OP_plus_plus)) x1 s0 cd cs) x2 s1 cd cs))

d_C_inferAProg :: FlatCurry.Annotated.Curry_Types.C_AProg
  FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AProg
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))
d_C_inferAProg x1 cd cs = case x1 of
  FlatCurry.Annotated.Curry_Types.C_AProg x2 x3 x4 x5 x6 -> Curry_ErrorState.d_OP_lt_dollar_gt
    (d_OP_inferAProg_dot_uscore_hash_lambda49 x3 x2 x6 x4)
    (Curry_ErrorState.d_C_mapES d_C_inferFunc x5 cd cs) cd cs
  FlatCurry.Annotated.Curry_Types.Choice_C_AProg d i l r -> narrow d i
    (d_C_inferAProg l cd cs) (d_C_inferAProg r cd cs)
  FlatCurry.Annotated.Curry_Types.Choices_C_AProg d i xs -> narrows cs d i
    (\z -> d_C_inferAProg z cd cs) xs
  FlatCurry.Annotated.Curry_Types.Guard_C_AProg d c e -> guardCons d c
    (d_C_inferAProg e cd $! addCs c cs)
  FlatCurry.Annotated.Curry_Types.Fail_C_AProg d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.inferAProg" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference.inferAProg"
    (showCons x1))

nd_C_inferAProg :: FlatCurry.Annotated.Curry_Types.C_AProg
  FlatCurry.Curry_Types.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AProg FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))))
nd_C_inferAProg x1 s cd cs = case x1 of
  FlatCurry.Annotated.Curry_Types.C_AProg x2 x3 x4 x5 x6 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_ErrorState.nd_OP_lt_dollar_gt (wrapDX id
    (d_OP_inferAProg_dot_uscore_hash_lambda49 x3 x2 x6 x4))
    (Curry_ErrorState.nd_C_mapES (wrapNX id nd_C_inferFunc) x5 s0 cd cs) s1 cd
    cs))
  FlatCurry.Annotated.Curry_Types.Choice_C_AProg d i l r -> narrow d i
    (nd_C_inferAProg l s cd cs) (nd_C_inferAProg r s cd cs)
  FlatCurry.Annotated.Curry_Types.Choices_C_AProg d i xs -> narrows cs d i
    (\z -> nd_C_inferAProg z s cd cs) xs
  FlatCurry.Annotated.Curry_Types.Guard_C_AProg d c e -> guardCons d c
    (nd_C_inferAProg e s cd $! addCs c cs)
  FlatCurry.Annotated.Curry_Types.Fail_C_AProg d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.inferAProg" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference.inferAProg"
    (showCons x1))

d_OP_inferAProg_dot_uscore_hash_lambda49 :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_OpDecl
  -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_TypeDecl
  -> Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> FlatCurry.Annotated.Curry_Types.C_AProg FlatCurry.Curry_Types.C_TypeExpr
d_OP_inferAProg_dot_uscore_hash_lambda49 x1 x2 x3 x4 x5 cd cs =
  FlatCurry.Annotated.Curry_Types.C_AProg x2 x1 x4 x5 x3

d_C_inferFuncGroup :: Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl FlatCurry.Curry_Types.C_TypeExpr)
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))
d_C_inferFuncGroup x1 cd cs = Curry_ErrorState.d_OP_gt_plus_eq
  (Curry_ErrorState.d_C_concatMapES (Curry_Prelude.d_C_uncurry (acceptCs id
  d_C_eqsRule)) (Curry_Prelude.d_C_foldr (acceptCs id
  d_OP_inferFuncGroup_dot_uscore_hash_lambda52) Curry_Prelude.OP_List x1 cd cs)
  cd cs) (d_OP_inferFuncGroup_dot_uscore_hash_lambda54 x1)

nd_C_inferFuncGroup :: Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl FlatCurry.Curry_Types.C_TypeExpr)
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))))
nd_C_inferFuncGroup x1 s cd cs = let s2 = s
  in s2 `seq` wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (let s1 = leftSupply
                                                                  s2
                                                                s0 = rightSupply
                                                                  s2
  in s1 `seq` (s0 `seq` Curry_ErrorState.nd_C_concatMapES (wrapNX id
  (Curry_Prelude.nd_C_uncurry (wrapDX (wrapNX id) (acceptCs id nd_C_eqsRule))))
  (Curry_Prelude.nd_C_foldr (wrapDX (wrapDX id) (acceptCs id
  d_OP_inferFuncGroup_dot_uscore_hash_lambda52)) Curry_Prelude.OP_List x1 s0 cd
  cs) s1 cd cs)) (wrapNX id (nd_OP_inferFuncGroup_dot_uscore_hash_lambda54 x1)))

d_OP_inferFuncGroup_dot_uscore_hash_lambda52 :: FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 FlatCurry.Curry_Types.C_TypeExpr
  (FlatCurry.Annotated.Curry_Types.C_ARule FlatCurry.Curry_Types.C_TypeExpr))
  -> Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  FlatCurry.Curry_Types.C_TypeExpr (FlatCurry.Annotated.Curry_Types.C_ARule
  FlatCurry.Curry_Types.C_TypeExpr))
d_OP_inferFuncGroup_dot_uscore_hash_lambda52 x1 x2 cd cs = case x1 of
  FlatCurry.Annotated.Curry_Types.C_AFunc x3 x4 x5 x6 x7 -> Curry_Prelude.OP_Cons
    (Curry_Prelude.OP_Tuple2 x6 x7) x2
  FlatCurry.Annotated.Curry_Types.Choice_C_AFuncDecl d i l r -> narrow d i
    (d_OP_inferFuncGroup_dot_uscore_hash_lambda52 l x2 cd cs)
    (d_OP_inferFuncGroup_dot_uscore_hash_lambda52 r x2 cd cs)
  FlatCurry.Annotated.Curry_Types.Choices_C_AFuncDecl d i xs -> narrows cs d i
    (\z -> d_OP_inferFuncGroup_dot_uscore_hash_lambda52 z x2 cd cs) xs
  FlatCurry.Annotated.Curry_Types.Guard_C_AFuncDecl d c e -> guardCons d c
    (d_OP_inferFuncGroup_dot_uscore_hash_lambda52 e x2 cd $! addCs c cs)
  FlatCurry.Annotated.Curry_Types.Fail_C_AFuncDecl d info -> failCons d
    (traceFail "FlatCurry.Annotated.TypeInference.inferFuncGroup._#lambda52"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "FlatCurry.Annotated.TypeInference.inferFuncGroup._#lambda52" (showCons x1))

d_OP_inferFuncGroup_dot_uscore_hash_lambda54 :: Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl FlatCurry.Curry_Types.C_TypeExpr)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  FlatCurry.Curry_Types.C_TypeExpr FlatCurry.Curry_Types.C_TypeExpr) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))
d_OP_inferFuncGroup_dot_uscore_hash_lambda54 x1 x2 cd cs =
  Curry_ErrorState.d_OP_gt_plus_eq (d_C_solve x2 cd cs)
  (d_OP_inferFuncGroup_dot_uscore_hash_lambda54_dot_uscore_hash_lambda55 x1)

nd_OP_inferFuncGroup_dot_uscore_hash_lambda54 :: Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl FlatCurry.Curry_Types.C_TypeExpr)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  FlatCurry.Curry_Types.C_TypeExpr FlatCurry.Curry_Types.C_TypeExpr) -> IDSupply
  -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))))
nd_OP_inferFuncGroup_dot_uscore_hash_lambda54 x1 x2 s cd cs = let s0 = s
  in s0 `seq` wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (nd_C_solve x2 s0 cd
  cs) (wrapNX id
  (nd_OP_inferFuncGroup_dot_uscore_hash_lambda54_dot_uscore_hash_lambda55 x1)))

d_OP_inferFuncGroup_dot_uscore_hash_lambda54_dot_uscore_hash_lambda55 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr) -> Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore -> t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) t0)
d_OP_inferFuncGroup_dot_uscore_hash_lambda54_dot_uscore_hash_lambda55 x1 x2 cd cs =
  Curry_ErrorState.d_OP_gt_plus_eq (Curry_ErrorState.d_C_mapES
  (Curry_Prelude.d_OP_dot (d_C_normalize d_C_normFunc)
  (FlatCurry.Annotated.Curry_TypeSubst.d_C_substFunc x2) cd cs) x1 cd cs)
  d_OP_inferFuncGroup_dot_uscore_hash_lambda54_dot_uscore_hash_lambda55_dot_uscore_hash_lambda56

nd_OP_inferFuncGroup_dot_uscore_hash_lambda54_dot_uscore_hash_lambda55 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr) -> Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Func t0
  (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) t0))
nd_OP_inferFuncGroup_dot_uscore_hash_lambda54_dot_uscore_hash_lambda55 x1 x2 s cd cs =
  let s2 = s
  in s2 `seq` wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (let s1 = leftSupply
                                                                  s2
                                                                s0 = rightSupply
                                                                  s2
  in s1 `seq` (s0 `seq` Curry_ErrorState.nd_C_mapES (Curry_Prelude.nd_OP_dot
  (wrapNX id (nd_C_normalize (wrapNX id nd_C_normFunc))) (wrapNX id
  (FlatCurry.Annotated.Curry_TypeSubst.nd_C_substFunc x2)) s0 cd cs) x1 s1 cd
  cs)) (wrapDX (wrapDX id)
  d_OP_inferFuncGroup_dot_uscore_hash_lambda54_dot_uscore_hash_lambda55_dot_uscore_hash_lambda56))

d_OP_inferFuncGroup_dot_uscore_hash_lambda54_dot_uscore_hash_lambda55_dot_uscore_hash_lambda56 :: forall t1
  t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl FlatCurry.Curry_Types.C_TypeExpr)
  -> Cover -> ConstStore -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_Either
  t1 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)) t0)
d_OP_inferFuncGroup_dot_uscore_hash_lambda54_dot_uscore_hash_lambda55_dot_uscore_hash_lambda56 x1 cd cs =
  Curry_ErrorState.d_C_returnES x1

d_C_inferFunc :: FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))
d_C_inferFunc x1 cd cs = case x1 of
  FlatCurry.Annotated.Curry_Types.C_AFunc x2 x3 x4 x5 x6 -> Curry_ErrorState.d_OP_gt_plus_eq
    (d_C_eqsRule x5 x6 cd cs) (d_OP_inferFunc_dot_uscore_hash_lambda57 x1)
  FlatCurry.Annotated.Curry_Types.Choice_C_AFuncDecl d i l r -> narrow d i
    (d_C_inferFunc l cd cs) (d_C_inferFunc r cd cs)
  FlatCurry.Annotated.Curry_Types.Choices_C_AFuncDecl d i xs -> narrows cs d i
    (\z -> d_C_inferFunc z cd cs) xs
  FlatCurry.Annotated.Curry_Types.Guard_C_AFuncDecl d c e -> guardCons d c
    (d_C_inferFunc e cd $! addCs c cs)
  FlatCurry.Annotated.Curry_Types.Fail_C_AFuncDecl d info -> failCons d
    (traceFail "FlatCurry.Annotated.TypeInference.inferFunc" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference.inferFunc"
    (showCons x1))

nd_C_inferFunc :: FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))))
nd_C_inferFunc x1 s cd cs = case x1 of
  FlatCurry.Annotated.Curry_Types.C_AFunc x2 x3 x4 x5 x6 -> let s0 = s
    in s0 `seq` wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (nd_C_eqsRule x5 x6
    s0 cd cs) (wrapNX id (nd_OP_inferFunc_dot_uscore_hash_lambda57 x1)))
  FlatCurry.Annotated.Curry_Types.Choice_C_AFuncDecl d i l r -> narrow d i
    (nd_C_inferFunc l s cd cs) (nd_C_inferFunc r s cd cs)
  FlatCurry.Annotated.Curry_Types.Choices_C_AFuncDecl d i xs -> narrows cs d i
    (\z -> nd_C_inferFunc z s cd cs) xs
  FlatCurry.Annotated.Curry_Types.Guard_C_AFuncDecl d c e -> guardCons d c
    (nd_C_inferFunc e s cd $! addCs c cs)
  FlatCurry.Annotated.Curry_Types.Fail_C_AFuncDecl d info -> failCons d
    (traceFail "FlatCurry.Annotated.TypeInference.inferFunc" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference.inferFunc"
    (showCons x1))

d_OP_inferFunc_dot_uscore_hash_lambda57 :: FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 FlatCurry.Curry_Types.C_TypeExpr
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))
d_OP_inferFunc_dot_uscore_hash_lambda57 x1 x2 cd cs =
  Curry_ErrorState.d_OP_gt_plus_eq (d_C_solve x2 cd cs)
  (d_OP_inferFunc_dot_uscore_hash_lambda57_dot_uscore_hash_lambda58 x1)

nd_OP_inferFunc_dot_uscore_hash_lambda57 :: FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 FlatCurry.Curry_Types.C_TypeExpr
  FlatCurry.Curry_Types.C_TypeExpr) -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))))
nd_OP_inferFunc_dot_uscore_hash_lambda57 x1 x2 s cd cs = let s0 = s
  in s0 `seq` wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (nd_C_solve x2 s0 cd
  cs) (wrapNX id
  (nd_OP_inferFunc_dot_uscore_hash_lambda57_dot_uscore_hash_lambda58 x1)))

d_OP_inferFunc_dot_uscore_hash_lambda57_dot_uscore_hash_lambda58 :: forall t0 . (Curry_Prelude.Curry
  t0) => FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr -> Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore -> t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl FlatCurry.Curry_Types.C_TypeExpr)
  t0)
d_OP_inferFunc_dot_uscore_hash_lambda57_dot_uscore_hash_lambda58 x1 x2 cd cs =
  d_C_normalize d_C_normFunc (FlatCurry.Annotated.Curry_TypeSubst.d_C_substFunc
  x2 x1 cd cs) cd cs

nd_OP_inferFunc_dot_uscore_hash_lambda57_dot_uscore_hash_lambda58 :: forall t0 . (Curry_Prelude.Curry
  t0) => FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr -> Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Func t0
  (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr) t0))
nd_OP_inferFunc_dot_uscore_hash_lambda57_dot_uscore_hash_lambda58 x1 x2 s cd cs =
  let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C_normalize (wrapNX id nd_C_normFunc)
  (FlatCurry.Annotated.Curry_TypeSubst.nd_C_substFunc x2 x1 s0 cd cs) s1 cd cs))

d_C_inferAExpr :: FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))
d_C_inferAExpr x1 cd cs = Curry_ErrorState.d_OP_gt_plus_eq (d_C_eqsExpr x1 cd
  cs) (d_OP_inferAExpr_dot_uscore_hash_lambda59 x1)

nd_C_inferAExpr :: FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))))
nd_C_inferAExpr x1 s cd cs = let s0 = s
  in s0 `seq` wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (nd_C_eqsExpr x1 s0
  cd cs) (wrapNX id (nd_OP_inferAExpr_dot_uscore_hash_lambda59 x1)))

d_OP_inferAExpr_dot_uscore_hash_lambda59 :: FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 FlatCurry.Curry_Types.C_TypeExpr
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))
d_OP_inferAExpr_dot_uscore_hash_lambda59 x1 x2 cd cs =
  Curry_ErrorState.d_OP_gt_plus_eq (d_C_solve x2 cd cs)
  (d_OP_inferAExpr_dot_uscore_hash_lambda59_dot_uscore_hash_lambda60 x1)

nd_OP_inferAExpr_dot_uscore_hash_lambda59 :: FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 FlatCurry.Curry_Types.C_TypeExpr
  FlatCurry.Curry_Types.C_TypeExpr) -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))))
nd_OP_inferAExpr_dot_uscore_hash_lambda59 x1 x2 s cd cs = let s0 = s
  in s0 `seq` wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (nd_C_solve x2 s0 cd
  cs) (wrapNX id
  (nd_OP_inferAExpr_dot_uscore_hash_lambda59_dot_uscore_hash_lambda60 x1)))

d_OP_inferAExpr_dot_uscore_hash_lambda59_dot_uscore_hash_lambda60 :: forall t0 . (Curry_Prelude.Curry
  t0) => FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr -> Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore -> t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr) t0)
d_OP_inferAExpr_dot_uscore_hash_lambda59_dot_uscore_hash_lambda60 x1 x2 cd cs =
  d_C_normalize d_C_normExpr (FlatCurry.Annotated.Curry_TypeSubst.d_C_substExpr
  x2 x1 cd cs) cd cs

nd_OP_inferAExpr_dot_uscore_hash_lambda59_dot_uscore_hash_lambda60 :: forall t0 . (Curry_Prelude.Curry
  t0) => FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr -> Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Func t0
  (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) t0))
nd_OP_inferAExpr_dot_uscore_hash_lambda59_dot_uscore_hash_lambda60 x1 x2 s cd cs =
  let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C_normalize (wrapNX id nd_C_normExpr)
  (FlatCurry.Annotated.Curry_TypeSubst.nd_C_substExpr x2 x1 s0 cd cs) s1 cd cs))

d_C_eqsRule :: FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Annotated.Curry_Types.C_ARule FlatCurry.Curry_Types.C_TypeExpr
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  FlatCurry.Curry_Types.C_TypeExpr FlatCurry.Curry_Types.C_TypeExpr))
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))
d_C_eqsRule x1 x2 cd cs = case x2 of
  FlatCurry.Annotated.Curry_Types.C_ARule x3 x4 x5 -> d_OP_plus_plus_eq
    (Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x1 x3
    cd cs) (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x3 (Curry_Prelude.d_C_foldr1
    (acceptCs (acceptCs id) FlatCurry.Curry_Types.C_FuncType)
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_map Curry_Prelude.d_C_snd
    x4 cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply (d_C_exprType cd
    cs) x5 cd cs) Curry_Prelude.OP_List) cd cs) cd cs) cd cs)
    Curry_Prelude.OP_List))) (d_C_eqsExpr x5 cd cs) cd cs
  FlatCurry.Annotated.Curry_Types.C_AExternal x6 x7 -> Curry_ErrorState.d_C_returnES
    (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x1 x6 cd cs) Curry_Prelude.OP_List)
  FlatCurry.Annotated.Curry_Types.Choice_C_ARule d i l r -> narrow d i
    (d_C_eqsRule x1 l cd cs) (d_C_eqsRule x1 r cd cs)
  FlatCurry.Annotated.Curry_Types.Choices_C_ARule d i xs -> narrows cs d i
    (\z -> d_C_eqsRule x1 z cd cs) xs
  FlatCurry.Annotated.Curry_Types.Guard_C_ARule d c e -> guardCons d c
    (d_C_eqsRule x1 e cd $! addCs c cs)
  FlatCurry.Annotated.Curry_Types.Fail_C_ARule d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.eqsRule" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference.eqsRule"
    (showCons x2))

nd_C_eqsRule :: FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Annotated.Curry_Types.C_ARule FlatCurry.Curry_Types.C_TypeExpr
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  FlatCurry.Curry_Types.C_TypeExpr FlatCurry.Curry_Types.C_TypeExpr))
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))))
nd_C_eqsRule x1 x2 s cd cs = case x2 of
  FlatCurry.Annotated.Curry_Types.C_ARule x3 x4 x5 -> let s7 = s
    in s7 `seq` (let s6 = leftSupply s7
                     s8 = rightSupply s7
                     s4 = leftSupply s8
                     s5 = rightSupply s8
    in s6 `seq` (s8 `seq` (s4 `seq` (s5 `seq` nd_OP_plus_plus_eq (wrapDX id
    (Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x1 x3
    cd cs) (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x3 (let s3 = leftSupply s4
                                                          s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_foldr1 (wrapDX (wrapDX id)
    (acceptCs (acceptCs id) FlatCurry.Curry_Types.C_FuncType))
    (let s0 = leftSupply s2
         s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.nd_C_map
    (wrapDX id Curry_Prelude.d_C_snd) x4 s0 cd cs) (Curry_Prelude.OP_Cons
    (Curry_Prelude.nd_C_apply (wrapDX id (d_C_exprType cd cs)) x5 s1 cd cs)
    Curry_Prelude.OP_List) cd cs)) s3 cd cs)) cd cs) Curry_Prelude.OP_List))))
    (nd_C_eqsExpr x5 s5 cd cs) s6 cd cs))))
  FlatCurry.Annotated.Curry_Types.C_AExternal x6 x7 -> wrapDX id
    (Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x1 x6
    cd cs) Curry_Prelude.OP_List))
  FlatCurry.Annotated.Curry_Types.Choice_C_ARule d i l r -> narrow d i
    (nd_C_eqsRule x1 l s cd cs) (nd_C_eqsRule x1 r s cd cs)
  FlatCurry.Annotated.Curry_Types.Choices_C_ARule d i xs -> narrows cs d i
    (\z -> nd_C_eqsRule x1 z s cd cs) xs
  FlatCurry.Annotated.Curry_Types.Guard_C_ARule d c e -> guardCons d c
    (nd_C_eqsRule x1 e s cd $! addCs c cs)
  FlatCurry.Annotated.Curry_Types.Fail_C_ARule d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.eqsRule" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference.eqsRule"
    (showCons x2))

d_C_eqsExpr :: FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  FlatCurry.Curry_Types.C_TypeExpr FlatCurry.Curry_Types.C_TypeExpr))
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))
d_C_eqsExpr x1 cd cs = case x1 of
  FlatCurry.Annotated.Curry_Types.C_AVar x2 x3 -> Curry_ErrorState.d_C_returnES
    Curry_Prelude.OP_List
  FlatCurry.Annotated.Curry_Types.C_ALit x4 x5 -> Curry_ErrorState.d_C_returnES
    (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x4 (d_C_literalType x5 cd cs) cd cs)
    Curry_Prelude.OP_List)
  FlatCurry.Annotated.Curry_Types.C_AComb x6 x7 x8 x9 -> d_C__case_9 x9 x6 x8 cd
    cs
  FlatCurry.Annotated.Curry_Types.C_ACase x12 x13 x14 x15 -> d_OP_plus_plus_eq
    (d_C_eqsExpr x14 cd cs) (Curry_ErrorState.d_C_concatMapES (d_C_eqsBranch x12
    x14) x15 cd cs) cd cs
  FlatCurry.Annotated.Curry_Types.C_AOr x16 x17 x18 -> d_OP_plus_plus_eq
    (d_OP_plus_plus_eq (Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Cons
    (d_OP_eq_dot_eq (Curry_Prelude.d_C_apply (d_C_exprType cd cs) x17 cd cs) x16
    cd cs) (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq (Curry_Prelude.d_C_apply
    (d_C_exprType cd cs) x18 cd cs) x16 cd cs) Curry_Prelude.OP_List)))
    (d_C_eqsExpr x17 cd cs) cd cs) (d_C_eqsExpr x18 cd cs) cd cs
  FlatCurry.Annotated.Curry_Types.C_ALet x19 x20 x21 -> d_OP_plus_plus_eq
    (d_OP_plus_plus_eq (Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Cons
    (d_OP_eq_dot_eq x19 (Curry_Prelude.d_C_apply (d_C_exprType cd cs) x21 cd cs)
    cd cs) Curry_Prelude.OP_List)) (Curry_ErrorState.d_C_returnES
    (Curry_Prelude.d_C_map d_OP_eqsExpr_dot_uscore_hash_lambda61 x20 cd cs)) cd
    cs) (Curry_ErrorState.d_C_concatMapES d_C_eqsExpr (Curry_Prelude.OP_Cons x21
    (Curry_Prelude.d_C_map Curry_Prelude.d_C_snd x20 cd cs)) cd cs) cd cs
  FlatCurry.Annotated.Curry_Types.C_AFree x22 x23 x24 -> d_OP_plus_plus_eq
    (Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x22
    (Curry_Prelude.d_C_apply (d_C_exprType cd cs) x24 cd cs) cd cs)
    Curry_Prelude.OP_List)) (d_C_eqsExpr x24 cd cs) cd cs
  FlatCurry.Annotated.Curry_Types.C_ATyped x25 x26 x27 -> d_OP_plus_plus_eq
    (Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x25
    (Curry_Prelude.d_C_apply (d_C_exprType cd cs) x26 cd cs) cd cs)
    (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x25 x27 cd cs)
    Curry_Prelude.OP_List))) (d_C_eqsExpr x26 cd cs) cd cs
  FlatCurry.Annotated.Curry_Types.Choice_C_AExpr d i l r -> narrow d i
    (d_C_eqsExpr l cd cs) (d_C_eqsExpr r cd cs)
  FlatCurry.Annotated.Curry_Types.Choices_C_AExpr d i xs -> narrows cs d i
    (\z -> d_C_eqsExpr z cd cs) xs
  FlatCurry.Annotated.Curry_Types.Guard_C_AExpr d c e -> guardCons d c
    (d_C_eqsExpr e cd $! addCs c cs)
  FlatCurry.Annotated.Curry_Types.Fail_C_AExpr d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.eqsExpr" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference.eqsExpr"
    (showCons x1))

nd_C_eqsExpr :: FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  FlatCurry.Curry_Types.C_TypeExpr FlatCurry.Curry_Types.C_TypeExpr))
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))))
nd_C_eqsExpr x1 s cd cs = case x1 of
  FlatCurry.Annotated.Curry_Types.C_AVar x2 x3 -> wrapDX id
    (Curry_ErrorState.d_C_returnES Curry_Prelude.OP_List)
  FlatCurry.Annotated.Curry_Types.C_ALit x4 x5 -> wrapDX id
    (Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x4
    (d_C_literalType x5 cd cs) cd cs) Curry_Prelude.OP_List))
  FlatCurry.Annotated.Curry_Types.C_AComb x6 x7 x8 x9 -> let s0 = s
    in s0 `seq` nd_C__case_9 x9 x6 x8 s0 cd cs
  FlatCurry.Annotated.Curry_Types.C_ACase x12 x13 x14 x15 -> let s3 = s
    in s3 `seq` (let s2 = leftSupply s3
                     s4 = rightSupply s3
                     s0 = leftSupply s4
                     s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` nd_OP_plus_plus_eq (nd_C_eqsExpr
    x14 s0 cd cs) (Curry_ErrorState.nd_C_concatMapES (wrapNX id (nd_C_eqsBranch
    x12 x14)) x15 s1 cd cs) s2 cd cs))))
  FlatCurry.Annotated.Curry_Types.C_AOr x16 x17 x18 -> let s9 = s
    in s9 `seq` (let s8 = leftSupply s9
                     s10 = rightSupply s9
                     s5 = leftSupply s10
                     s7 = rightSupply s10
    in s8 `seq` (s10 `seq` (s5 `seq` (s7 `seq` nd_OP_plus_plus_eq
    (let s4 = leftSupply s5
         s6 = rightSupply s5
         s2 = leftSupply s6
         s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s2 `seq` (s3 `seq` nd_OP_plus_plus_eq (wrapDX id
    (Curry_ErrorState.d_C_returnES (let s0 = leftSupply s2
                                        s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.OP_Cons (d_OP_eq_dot_eq
    (Curry_Prelude.nd_C_apply (wrapDX id (d_C_exprType cd cs)) x17 s0 cd cs) x16
    cd cs) (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq (Curry_Prelude.nd_C_apply
    (wrapDX id (d_C_exprType cd cs)) x18 s1 cd cs) x16 cd cs)
    Curry_Prelude.OP_List))))) (nd_C_eqsExpr x17 s3 cd cs) s4 cd cs))))
    (nd_C_eqsExpr x18 s7 cd cs) s8 cd cs))))
  FlatCurry.Annotated.Curry_Types.C_ALet x19 x20 x21 -> let s9 = s
    in s9 `seq` (let s8 = leftSupply s9
                     s10 = rightSupply s9
                     s3 = leftSupply s10
                     s7 = rightSupply s10
    in s8 `seq` (s10 `seq` (s3 `seq` (s7 `seq` nd_OP_plus_plus_eq
    (let s2 = leftSupply s3
         s4 = rightSupply s3
         s0 = leftSupply s4
         s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` nd_OP_plus_plus_eq (wrapDX id
    (Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x19
    (Curry_Prelude.nd_C_apply (wrapDX id (d_C_exprType cd cs)) x21 s0 cd cs) cd
    cs) Curry_Prelude.OP_List))) (wrapDX id (Curry_ErrorState.d_C_returnES
    (Curry_Prelude.nd_C_map (wrapDX id d_OP_eqsExpr_dot_uscore_hash_lambda61)
    x20 s1 cd cs))) s2 cd cs)))) (let s6 = leftSupply s7
                                      s5 = rightSupply s7
    in s6 `seq` (s5 `seq` Curry_ErrorState.nd_C_concatMapES (wrapNX id
    nd_C_eqsExpr) (Curry_Prelude.OP_Cons x21 (Curry_Prelude.nd_C_map (wrapDX id
    Curry_Prelude.d_C_snd) x20 s5 cd cs)) s6 cd cs)) s8 cd cs))))
  FlatCurry.Annotated.Curry_Types.C_AFree x22 x23 x24 -> let s3 = s
    in s3 `seq` (let s2 = leftSupply s3
                     s4 = rightSupply s3
                     s0 = leftSupply s4
                     s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` nd_OP_plus_plus_eq (wrapDX id
    (Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x22
    (Curry_Prelude.nd_C_apply (wrapDX id (d_C_exprType cd cs)) x24 s0 cd cs) cd
    cs) Curry_Prelude.OP_List))) (nd_C_eqsExpr x24 s1 cd cs) s2 cd cs))))
  FlatCurry.Annotated.Curry_Types.C_ATyped x25 x26 x27 -> let s3 = s
    in s3 `seq` (let s2 = leftSupply s3
                     s4 = rightSupply s3
                     s0 = leftSupply s4
                     s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` nd_OP_plus_plus_eq (wrapDX id
    (Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x25
    (Curry_Prelude.nd_C_apply (wrapDX id (d_C_exprType cd cs)) x26 s0 cd cs) cd
    cs) (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x25 x27 cd cs)
    Curry_Prelude.OP_List)))) (nd_C_eqsExpr x26 s1 cd cs) s2 cd cs))))
  FlatCurry.Annotated.Curry_Types.Choice_C_AExpr d i l r -> narrow d i
    (nd_C_eqsExpr l s cd cs) (nd_C_eqsExpr r s cd cs)
  FlatCurry.Annotated.Curry_Types.Choices_C_AExpr d i xs -> narrows cs d i
    (\z -> nd_C_eqsExpr z s cd cs) xs
  FlatCurry.Annotated.Curry_Types.Guard_C_AExpr d c e -> guardCons d c
    (nd_C_eqsExpr e s cd $! addCs c cs)
  FlatCurry.Annotated.Curry_Types.Fail_C_AExpr d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.eqsExpr" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference.eqsExpr"
    (showCons x1))

d_OP_eqsExpr_dot_uscore_hash_lambda61 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  (FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr)
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  FlatCurry.Curry_Types.C_TypeExpr FlatCurry.Curry_Types.C_TypeExpr
d_OP_eqsExpr_dot_uscore_hash_lambda61 x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> d_C__case_8 x3 x2 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_eqsExpr_dot_uscore_hash_lambda61 l cd cs)
    (d_OP_eqsExpr_dot_uscore_hash_lambda61 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_eqsExpr_dot_uscore_hash_lambda61 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_eqsExpr_dot_uscore_hash_lambda61 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.eqsExpr._#lambda61" [show x1] info)
  _ -> failCons cd (consFail
    "FlatCurry.Annotated.TypeInference.eqsExpr._#lambda61" (showCons x1))

d_C_eqsBranch :: FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Annotated.Curry_Types.C_ABranchExpr
  FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  FlatCurry.Curry_Types.C_TypeExpr FlatCurry.Curry_Types.C_TypeExpr))
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))
d_C_eqsBranch x1 x2 x3 cd cs = case x3 of
  FlatCurry.Annotated.Curry_Types.C_ABranch x4 x5 -> d_OP_plus_plus_eq
    (d_OP_plus_plus_eq (Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Cons
    (d_OP_eq_dot_eq x1 (Curry_Prelude.d_C_apply (d_C_exprType cd cs) x5 cd cs)
    cd cs) Curry_Prelude.OP_List)) (d_C_eqsPattern (Curry_Prelude.d_C_apply
    (d_C_exprType cd cs) x2 cd cs) x4 cd cs) cd cs) (d_C_eqsExpr x5 cd cs) cd cs
  FlatCurry.Annotated.Curry_Types.Choice_C_ABranchExpr d i l r -> narrow d i
    (d_C_eqsBranch x1 x2 l cd cs) (d_C_eqsBranch x1 x2 r cd cs)
  FlatCurry.Annotated.Curry_Types.Choices_C_ABranchExpr d i xs -> narrows cs d i
    (\z -> d_C_eqsBranch x1 x2 z cd cs) xs
  FlatCurry.Annotated.Curry_Types.Guard_C_ABranchExpr d c e -> guardCons d c
    (d_C_eqsBranch x1 x2 e cd $! addCs c cs)
  FlatCurry.Annotated.Curry_Types.Fail_C_ABranchExpr d info -> failCons d
    (traceFail "FlatCurry.Annotated.TypeInference.eqsBranch" [show x1, show x2
    , show x3] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference.eqsBranch"
    (showCons x3))

nd_C_eqsBranch :: FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Annotated.Curry_Types.C_ABranchExpr
  FlatCurry.Curry_Types.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  FlatCurry.Curry_Types.C_TypeExpr FlatCurry.Curry_Types.C_TypeExpr))
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))))
nd_C_eqsBranch x1 x2 x3 s cd cs = case x3 of
  FlatCurry.Annotated.Curry_Types.C_ABranch x4 x5 -> let s9 = s
    in s9 `seq` (let s8 = leftSupply s9
                     s10 = rightSupply s9
                     s5 = leftSupply s10
                     s7 = rightSupply s10
    in s8 `seq` (s10 `seq` (s5 `seq` (s7 `seq` nd_OP_plus_plus_eq
    (let s4 = leftSupply s5
         s6 = rightSupply s5
         s0 = leftSupply s6
         s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` nd_OP_plus_plus_eq (wrapDX id
    (Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x1
    (Curry_Prelude.nd_C_apply (wrapDX id (d_C_exprType cd cs)) x5 s0 cd cs) cd
    cs) Curry_Prelude.OP_List))) (let s2 = leftSupply s3
                                      s1 = rightSupply s3
    in s2 `seq` (s1 `seq` nd_C_eqsPattern (Curry_Prelude.nd_C_apply (wrapDX id
    (d_C_exprType cd cs)) x2 s1 cd cs) x4 s2 cd cs)) s4 cd cs)))) (nd_C_eqsExpr
    x5 s7 cd cs) s8 cd cs))))
  FlatCurry.Annotated.Curry_Types.Choice_C_ABranchExpr d i l r -> narrow d i
    (nd_C_eqsBranch x1 x2 l s cd cs) (nd_C_eqsBranch x1 x2 r s cd cs)
  FlatCurry.Annotated.Curry_Types.Choices_C_ABranchExpr d i xs -> narrows cs d i
    (\z -> nd_C_eqsBranch x1 x2 z s cd cs) xs
  FlatCurry.Annotated.Curry_Types.Guard_C_ABranchExpr d c e -> guardCons d c
    (nd_C_eqsBranch x1 x2 e s cd $! addCs c cs)
  FlatCurry.Annotated.Curry_Types.Fail_C_ABranchExpr d info -> failCons d
    (traceFail "FlatCurry.Annotated.TypeInference.eqsBranch" [show x1, show x2
    , show x3] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference.eqsBranch"
    (showCons x3))

d_C_eqsPattern :: FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Annotated.Curry_Types.C_APattern FlatCurry.Curry_Types.C_TypeExpr
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  FlatCurry.Curry_Types.C_TypeExpr FlatCurry.Curry_Types.C_TypeExpr))
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))
d_C_eqsPattern x1 x2 cd cs = case x2 of
  FlatCurry.Annotated.Curry_Types.C_APattern x3 x4 x5 -> d_C__case_7 x3 x5 x1 x4
    cd cs
  FlatCurry.Annotated.Curry_Types.C_ALPattern x8 x9 -> Curry_ErrorState.d_C_returnES
    (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x1 x8 cd cs) (Curry_Prelude.OP_Cons
    (d_OP_eq_dot_eq x8 (d_C_literalType x9 cd cs) cd cs) Curry_Prelude.OP_List))
  FlatCurry.Annotated.Curry_Types.Choice_C_APattern d i l r -> narrow d i
    (d_C_eqsPattern x1 l cd cs) (d_C_eqsPattern x1 r cd cs)
  FlatCurry.Annotated.Curry_Types.Choices_C_APattern d i xs -> narrows cs d i
    (\z -> d_C_eqsPattern x1 z cd cs) xs
  FlatCurry.Annotated.Curry_Types.Guard_C_APattern d c e -> guardCons d c
    (d_C_eqsPattern x1 e cd $! addCs c cs)
  FlatCurry.Annotated.Curry_Types.Fail_C_APattern d info -> failCons d
    (traceFail "FlatCurry.Annotated.TypeInference.eqsPattern" [show x1, show x2]
    info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference.eqsPattern"
    (showCons x2))

nd_C_eqsPattern :: FlatCurry.Curry_Types.C_TypeExpr
  -> FlatCurry.Annotated.Curry_Types.C_APattern FlatCurry.Curry_Types.C_TypeExpr
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  FlatCurry.Curry_Types.C_TypeExpr FlatCurry.Curry_Types.C_TypeExpr))
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))))
nd_C_eqsPattern x1 x2 s cd cs = case x2 of
  FlatCurry.Annotated.Curry_Types.C_APattern x3 x4 x5 -> let s0 = s
    in s0 `seq` nd_C__case_7 x3 x5 x1 x4 s0 cd cs
  FlatCurry.Annotated.Curry_Types.C_ALPattern x8 x9 -> wrapDX id
    (Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x1 x8
    cd cs) (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x8 (d_C_literalType x9 cd cs)
    cd cs) Curry_Prelude.OP_List)))
  FlatCurry.Annotated.Curry_Types.Choice_C_APattern d i l r -> narrow d i
    (nd_C_eqsPattern x1 l s cd cs) (nd_C_eqsPattern x1 r s cd cs)
  FlatCurry.Annotated.Curry_Types.Choices_C_APattern d i xs -> narrows cs d i
    (\z -> nd_C_eqsPattern x1 z s cd cs) xs
  FlatCurry.Annotated.Curry_Types.Guard_C_APattern d c e -> guardCons d c
    (nd_C_eqsPattern x1 e s cd $! addCs c cs)
  FlatCurry.Annotated.Curry_Types.Fail_C_APattern d info -> failCons d
    (traceFail "FlatCurry.Annotated.TypeInference.eqsPattern" [show x1, show x2]
    info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference.eqsPattern"
    (showCons x2))

d_C_literalType :: FlatCurry.Curry_Types.C_Literal -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_TypeExpr
d_C_literalType x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_Intc x2 -> FlatCurry.Curry_Types.C_TCons
    (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "Prelude")
    (Curry_Prelude.toCurryString "Int")) Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_Floatc x3 -> FlatCurry.Curry_Types.C_TCons
    (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "Prelude")
    (Curry_Prelude.toCurryString "Float")) Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_Charc x4 -> FlatCurry.Curry_Types.C_TCons
    (Curry_Prelude.OP_Tuple2 (Curry_Prelude.toCurryString "Prelude")
    (Curry_Prelude.toCurryString "Char")) Curry_Prelude.OP_List
  FlatCurry.Curry_Types.Choice_C_Literal d i l r -> narrow d i (d_C_literalType
    l cd cs) (d_C_literalType r cd cs)
  FlatCurry.Curry_Types.Choices_C_Literal d i xs -> narrows cs d i (\z ->
    d_C_literalType z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Literal d c e -> guardCons d c (d_C_literalType
    e cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Literal d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.literalType" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference.literalType"
    (showCons x1))

d_C_exprType :: Cover -> ConstStore -> FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_TypeExpr
d_C_exprType cd cs = FlatCurry.Annotated.Curry_Goodies.d_C_annExpr

d_C_solve :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  FlatCurry.Curry_Types.C_TypeExpr FlatCurry.Curry_Types.C_TypeExpr) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))
d_C_solve x1 cd cs = d_C__case_6 x1 (Rewriting.Curry_Unification.d_C_unify
  (Curry_Prelude.d_C_apply (d_C_fromTypeEqs cd cs) x1 cd cs) cd cs) cd cs

nd_C_solve :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  FlatCurry.Curry_Types.C_TypeExpr FlatCurry.Curry_Types.C_TypeExpr) -> IDSupply
  -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))))
nd_C_solve x1 s cd cs = let s4 = s
  in s4 `seq` (let s3 = leftSupply s4
                   s2 = rightSupply s4
  in s3 `seq` (s2 `seq` nd_C__case_6 x1 (let s1 = leftSupply s2
                                             s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Rewriting.Curry_Unification.nd_C_unify
  (Curry_Prelude.nd_C_apply (wrapDX id (d_C_fromTypeEqs cd cs)) x1 s0 cd cs) s1
  cd cs)) s3 cd cs))

d_OP_solve_dot_uscore_hash_lambda63 :: Curry_Prelude.C_Int -> Cover
  -> ConstStore -> Rewriting.Curry_Term.C_Term (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_TypeExpr
d_OP_solve_dot_uscore_hash_lambda63 x1 cd cs = d_C_toTypeExpr

d_C_fromTypeEqs :: Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 FlatCurry.Curry_Types.C_TypeExpr
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Rewriting.Curry_Term.C_Term
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Rewriting.Curry_Term.C_Term
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
d_C_fromTypeEqs cd cs = Curry_Prelude.d_C_map
  d_OP_fromTypeEqs_dot_uscore_hash_lambda64

d_OP_fromTypeEqs_dot_uscore_hash_lambda64 :: Curry_Prelude.OP_Tuple2
  FlatCurry.Curry_Types.C_TypeExpr FlatCurry.Curry_Types.C_TypeExpr -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 (Rewriting.Curry_Term.C_Term
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Rewriting.Curry_Term.C_Term
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_fromTypeEqs_dot_uscore_hash_lambda64 x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> Curry_Prelude.OP_Tuple2 (d_C_fromTypeExpr x2
    cd cs) (d_C_fromTypeExpr x3 cd cs)
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_fromTypeEqs_dot_uscore_hash_lambda64 l cd cs)
    (d_OP_fromTypeEqs_dot_uscore_hash_lambda64 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_fromTypeEqs_dot_uscore_hash_lambda64 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_fromTypeEqs_dot_uscore_hash_lambda64 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.fromTypeEqs._#lambda64" [show x1] info)
  _ -> failCons cd (consFail
    "FlatCurry.Annotated.TypeInference.fromTypeEqs._#lambda64" (showCons x1))

d_C_toTypeEqs :: Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Rewriting.Curry_Term.C_Term (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Rewriting.Curry_Term.C_Term (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 FlatCurry.Curry_Types.C_TypeExpr
  FlatCurry.Curry_Types.C_TypeExpr)
d_C_toTypeEqs cd cs = Curry_Prelude.d_C_map
  d_OP_toTypeEqs_dot_uscore_hash_lambda65

d_OP_toTypeEqs_dot_uscore_hash_lambda65 :: Curry_Prelude.OP_Tuple2
  (Rewriting.Curry_Term.C_Term (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  (Rewriting.Curry_Term.C_Term (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  FlatCurry.Curry_Types.C_TypeExpr FlatCurry.Curry_Types.C_TypeExpr
d_OP_toTypeEqs_dot_uscore_hash_lambda65 x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> d_OP_eq_dot_eq (d_C_toTypeExpr x2 cd cs)
    (d_C_toTypeExpr x3 cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_toTypeEqs_dot_uscore_hash_lambda65 l cd cs)
    (d_OP_toTypeEqs_dot_uscore_hash_lambda65 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_toTypeEqs_dot_uscore_hash_lambda65 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_toTypeEqs_dot_uscore_hash_lambda65 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.toTypeEqs._#lambda65" [show x1] info)
  _ -> failCons cd (consFail
    "FlatCurry.Annotated.TypeInference.toTypeEqs._#lambda65" (showCons x1))

d_C_fromTypeExpr :: FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Rewriting.Curry_Term.C_Term (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_fromTypeExpr x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_TVar x2 -> Rewriting.Curry_Term.C_TermVar x2
  FlatCurry.Curry_Types.C_TCons x3 x4 -> Rewriting.Curry_Term.C_TermCons
    (d_C_fromQName x3 cd cs) (Curry_Prelude.d_C_map d_C_fromTypeExpr x4 cd cs)
  FlatCurry.Curry_Types.C_FuncType x5 x6 -> Rewriting.Curry_Term.C_TermCons
    (Curry_Prelude.toCurryString "->") (Curry_Prelude.OP_Cons (d_C_fromTypeExpr
    x5 cd cs) (Curry_Prelude.OP_Cons (d_C_fromTypeExpr x6 cd cs)
    Curry_Prelude.OP_List))
  FlatCurry.Curry_Types.Choice_C_TypeExpr d i l r -> narrow d i
    (d_C_fromTypeExpr l cd cs) (d_C_fromTypeExpr r cd cs)
  FlatCurry.Curry_Types.Choices_C_TypeExpr d i xs -> narrows cs d i (\z ->
    d_C_fromTypeExpr z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_TypeExpr d c e -> guardCons d c
    (d_C_fromTypeExpr e cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_TypeExpr d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.fromTypeExpr" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference.fromTypeExpr"
    (showCons x1))

d_C_toTypeExpr :: Rewriting.Curry_Term.C_Term (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_TypeExpr
d_C_toTypeExpr x1 cd cs = case x1 of
  Rewriting.Curry_Term.C_TermVar x2 -> FlatCurry.Curry_Types.C_TVar x2
  Rewriting.Curry_Term.C_TermCons x3 x4 -> d_C__case_5 x3 x4
    (Curry_Prelude.d_OP_eq_eq x3 (Curry_Prelude.toCurryString "->") cd cs) cd cs
  Rewriting.Curry_Term.Choice_C_Term d i l r -> narrow d i (d_C_toTypeExpr l cd
    cs) (d_C_toTypeExpr r cd cs)
  Rewriting.Curry_Term.Choices_C_Term d i xs -> narrows cs d i (\z ->
    d_C_toTypeExpr z cd cs) xs
  Rewriting.Curry_Term.Guard_C_Term d c e -> guardCons d c (d_C_toTypeExpr e
    cd $! addCs c cs)
  Rewriting.Curry_Term.Fail_C_Term d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.toTypeExpr" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference.toTypeExpr"
    (showCons x1))

d_C_fromQName :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_fromQName x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> Curry_Prelude.d_OP_plus_plus x2
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString ";") x3 cd cs) cd
    cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C_fromQName l cd cs)
    (d_C_fromQName r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C_fromQName
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C_fromQName e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.fromQName" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference.fromQName"
    (showCons x1))

d_C_toQName :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_toQName x1 cd cs = let x2 = d_C_splitFirst x1 (Curry_Prelude.C_Char ';'#) cd
                             cs
  in Curry_Prelude.OP_Tuple2 (Curry_Prelude.d_C_fst x2 cd cs)
  (Curry_Prelude.d_C_snd x2 cd cs)

d_C_splitFirst :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  t0 -> t0 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List t0)
d_C_splitFirst x1 x2 cd cs = case x1 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_List
    Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x3 x4 -> let x5 = d_C_splitFirst x4 x2 cd cs
    in d_C__case_3 x2 x3 x5 x4 (Curry_Prelude.d_OP_eq_eq x3 x2 cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C_splitFirst l x2 cd cs)
    (d_C_splitFirst r x2 cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C_splitFirst z
    x2 cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C_splitFirst e x2 cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.splitFirst" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference.splitFirst"
    (showCons x1))

d_C_showUnificationError :: Rewriting.Curry_UnificationSpec.C_UnificationError
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showUnificationError x1 cd cs = case x1 of
  Rewriting.Curry_UnificationSpec.C_Clash x2 x3 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "Clash: ") (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_show (d_C_toTypeExpr x2 cd cs) cd cs)
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString " = ")
    (Curry_Prelude.d_C_show (d_C_toTypeExpr x3 cd cs) cd cs) cd cs) cd cs) cd cs
  Rewriting.Curry_UnificationSpec.C_OccurCheck x4 x5 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "OccurCheck: Variable ")
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_show (d_C_toTypeExpr
    (Rewriting.Curry_Term.C_TermVar x4) cd cs) cd cs)
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString " occurs in ")
    (Curry_Prelude.d_C_show (d_C_toTypeExpr x5 cd cs) cd cs) cd cs) cd cs) cd cs
  Rewriting.Curry_UnificationSpec.Choice_C_UnificationError d i l r -> narrow d
    i (d_C_showUnificationError l cd cs) (d_C_showUnificationError r cd cs)
  Rewriting.Curry_UnificationSpec.Choices_C_UnificationError d i xs -> narrows
    cs d i (\z -> d_C_showUnificationError z cd cs) xs
  Rewriting.Curry_UnificationSpec.Guard_C_UnificationError d c e -> guardCons d
    c (d_C_showUnificationError e cd $! addCs c cs)
  Rewriting.Curry_UnificationSpec.Fail_C_UnificationError d info -> failCons d
    (traceFail "FlatCurry.Annotated.TypeInference.showUnificationError" [show
    x1] info)
  _ -> failCons cd (consFail
    "FlatCurry.Annotated.TypeInference.showUnificationError" (showCons x1))

d_C_normalize :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => (t0 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  Curry_Prelude.C_Int) -> Cover -> ConstStore -> Curry_Prelude.C_Either
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  Curry_Prelude.C_Int)))) -> t0 -> Cover -> ConstStore -> t1 -> Cover
  -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 t0 t1)
d_C_normalize x1 x2 cd cs = d_C__case_1 x2 x1 (Curry_ErrorState.d_C_evalES
  (Curry_Prelude.d_C_apply x1 x2 cd cs) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.C_Int 0#) (Curry_FiniteMap.d_C_emptyFM (acceptCs id
  Curry_Prelude.d_OP_lt) cd cs)) cd cs) cd cs

nd_C_normalize :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Func t0 (Func (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int))
  (Curry_Prelude.C_Either Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int Curry_Prelude.C_Int))))) -> t0 -> IDSupply -> Cover
  -> ConstStore -> Func t1 (Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 t0 t1))
nd_C_normalize x1 x2 s cd cs = let s6 = s
  in s6 `seq` (let s5 = leftSupply s6
                   s3 = rightSupply s6
  in s5 `seq` (s3 `seq` nd_C__case_1 x2 x1 (let s2 = leftSupply s3
                                                s4 = rightSupply s3
                                                s0 = leftSupply s4
                                                s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_ErrorState.nd_C_evalES
  (Curry_Prelude.nd_C_apply x1 x2 s0 cd cs) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.C_Int 0#) (Curry_FiniteMap.nd_C_emptyFM (wrapDX (wrapDX id)
  (acceptCs id Curry_Prelude.d_OP_lt)) s1 cd cs)) s2 cd cs)))) s5 cd cs))

d_C_normFunc :: FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int Curry_Prelude.C_Int) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int Curry_Prelude.C_Int)))
d_C_normFunc x1 cd cs = case x1 of
  FlatCurry.Annotated.Curry_Types.C_AFunc x2 x3 x4 x5 x6 -> Curry_ErrorState.d_OP_lt_star_gt
    (Curry_ErrorState.d_OP_lt_dollar_gt (acceptCs (acceptCs id)
    (FlatCurry.Annotated.Curry_Types.C_AFunc x2 x3 x4)) (d_C_normType x5 cd cs)
    cd cs) (d_C_normRule x6 cd cs) cd cs
  FlatCurry.Annotated.Curry_Types.Choice_C_AFuncDecl d i l r -> narrow d i
    (d_C_normFunc l cd cs) (d_C_normFunc r cd cs)
  FlatCurry.Annotated.Curry_Types.Choices_C_AFuncDecl d i xs -> narrows cs d i
    (\z -> d_C_normFunc z cd cs) xs
  FlatCurry.Annotated.Curry_Types.Guard_C_AFuncDecl d c e -> guardCons d c
    (d_C_normFunc e cd $! addCs c cs)
  FlatCurry.Annotated.Curry_Types.Fail_C_AFuncDecl d info -> failCons d
    (traceFail "FlatCurry.Annotated.TypeInference.normFunc" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference.normFunc"
    (showCons x1))

nd_C_normFunc :: FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int Curry_Prelude.C_Int)) (Curry_Prelude.C_Either
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int Curry_Prelude.C_Int))))
nd_C_normFunc x1 s cd cs = case x1 of
  FlatCurry.Annotated.Curry_Types.C_AFunc x2 x3 x4 x5 x6 -> let s5 = s
    in s5 `seq` (let s4 = leftSupply s5
                     s6 = rightSupply s5
                     s2 = leftSupply s6
                     s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s2 `seq` (s3 `seq` Curry_ErrorState.nd_OP_lt_star_gt
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_ErrorState.nd_OP_lt_dollar_gt (wrapDX (wrapDX
    id) (acceptCs (acceptCs id) (FlatCurry.Annotated.Curry_Types.C_AFunc x2 x3
    x4))) (nd_C_normType x5 s0 cd cs) s1 cd cs)) (nd_C_normRule x6 s3 cd cs) s4
    cd cs))))
  FlatCurry.Annotated.Curry_Types.Choice_C_AFuncDecl d i l r -> narrow d i
    (nd_C_normFunc l s cd cs) (nd_C_normFunc r s cd cs)
  FlatCurry.Annotated.Curry_Types.Choices_C_AFuncDecl d i xs -> narrows cs d i
    (\z -> nd_C_normFunc z s cd cs) xs
  FlatCurry.Annotated.Curry_Types.Guard_C_AFuncDecl d c e -> guardCons d c
    (nd_C_normFunc e s cd $! addCs c cs)
  FlatCurry.Annotated.Curry_Types.Fail_C_AFuncDecl d info -> failCons d
    (traceFail "FlatCurry.Annotated.TypeInference.normFunc" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference.normFunc"
    (showCons x1))

d_C_normType :: FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int Curry_Prelude.C_Int) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple2
  FlatCurry.Curry_Types.C_TypeExpr (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int)))
d_C_normType x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_TVar x2 -> Curry_ErrorState.d_OP_gt_plus_eq
    Curry_ErrorState.d_C_gets (d_OP_normType_dot_uscore_hash_lambda67 x2)
  FlatCurry.Curry_Types.C_TCons x3 x4 -> Curry_ErrorState.d_OP_lt_dollar_gt
    (acceptCs id (FlatCurry.Curry_Types.C_TCons x3)) (Curry_ErrorState.d_C_mapES
    d_C_normType x4 cd cs) cd cs
  FlatCurry.Curry_Types.C_FuncType x5 x6 -> Curry_ErrorState.d_OP_lt_star_gt
    (Curry_ErrorState.d_OP_lt_dollar_gt (acceptCs (acceptCs id)
    FlatCurry.Curry_Types.C_FuncType) (d_C_normType x5 cd cs) cd cs)
    (d_C_normType x6 cd cs) cd cs
  FlatCurry.Curry_Types.Choice_C_TypeExpr d i l r -> narrow d i (d_C_normType l
    cd cs) (d_C_normType r cd cs)
  FlatCurry.Curry_Types.Choices_C_TypeExpr d i xs -> narrows cs d i (\z ->
    d_C_normType z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_TypeExpr d c e -> guardCons d c (d_C_normType e
    cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_TypeExpr d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.normType" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference.normType"
    (showCons x1))

nd_C_normType :: FlatCurry.Curry_Types.C_TypeExpr -> IDSupply -> Cover
  -> ConstStore -> Func (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int))
  (Curry_Prelude.C_Either Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple2
  FlatCurry.Curry_Types.C_TypeExpr (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int))))
nd_C_normType x1 s cd cs = case x1 of
  FlatCurry.Curry_Types.C_TVar x2 -> wrapNX id
    (Curry_ErrorState.nd_OP_gt_plus_eq (wrapDX id Curry_ErrorState.d_C_gets)
    (wrapNX id (nd_OP_normType_dot_uscore_hash_lambda67 x2)))
  FlatCurry.Curry_Types.C_TCons x3 x4 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_ErrorState.nd_OP_lt_dollar_gt (wrapDX id
    (acceptCs id (FlatCurry.Curry_Types.C_TCons x3)))
    (Curry_ErrorState.nd_C_mapES (wrapNX id nd_C_normType) x4 s0 cd cs) s1 cd
    cs))
  FlatCurry.Curry_Types.C_FuncType x5 x6 -> let s5 = s
    in s5 `seq` (let s4 = leftSupply s5
                     s6 = rightSupply s5
                     s2 = leftSupply s6
                     s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s2 `seq` (s3 `seq` Curry_ErrorState.nd_OP_lt_star_gt
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_ErrorState.nd_OP_lt_dollar_gt (wrapDX (wrapDX
    id) (acceptCs (acceptCs id) FlatCurry.Curry_Types.C_FuncType))
    (nd_C_normType x5 s0 cd cs) s1 cd cs)) (nd_C_normType x6 s3 cd cs) s4 cd
    cs))))
  FlatCurry.Curry_Types.Choice_C_TypeExpr d i l r -> narrow d i (nd_C_normType l
    s cd cs) (nd_C_normType r s cd cs)
  FlatCurry.Curry_Types.Choices_C_TypeExpr d i xs -> narrows cs d i (\z ->
    nd_C_normType z s cd cs) xs
  FlatCurry.Curry_Types.Guard_C_TypeExpr d c e -> guardCons d c (nd_C_normType e
    s cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_TypeExpr d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.normType" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference.normType"
    (showCons x1))

d_OP_normType_dot_uscore_hash_lambda67 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.C_Int -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int) -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int) -> Cover
  -> ConstStore -> Curry_Prelude.C_Either t0 (Curry_Prelude.OP_Tuple2
  FlatCurry.Curry_Types.C_TypeExpr (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int)))
d_OP_normType_dot_uscore_hash_lambda67 x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> d_C__case_0 x1 x4 x3
    (Curry_FiniteMap.d_C_lookupFM x4 x1 cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_normType_dot_uscore_hash_lambda67 x1 l cd cs)
    (d_OP_normType_dot_uscore_hash_lambda67 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_normType_dot_uscore_hash_lambda67 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_normType_dot_uscore_hash_lambda67 x1 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.normType._#lambda67" [show x1, show x2]
    info)
  _ -> failCons cd (consFail
    "FlatCurry.Annotated.TypeInference.normType._#lambda67" (showCons x2))

nd_OP_normType_dot_uscore_hash_lambda67 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.C_Int -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int) -> IDSupply
  -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int))
  (Curry_Prelude.C_Either t0 (Curry_Prelude.OP_Tuple2
  FlatCurry.Curry_Types.C_TypeExpr (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int))))
nd_OP_normType_dot_uscore_hash_lambda67 x1 x2 s cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_0 x1 x4 x3 (Curry_FiniteMap.nd_C_lookupFM
    x4 x1 s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_normType_dot_uscore_hash_lambda67 x1 l s cd cs)
    (nd_OP_normType_dot_uscore_hash_lambda67 x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_normType_dot_uscore_hash_lambda67 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (nd_OP_normType_dot_uscore_hash_lambda67 x1 e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.normType._#lambda67" [show x1, show x2]
    info)
  _ -> failCons cd (consFail
    "FlatCurry.Annotated.TypeInference.normType._#lambda67" (showCons x2))

d_C_normRule :: FlatCurry.Annotated.Curry_Types.C_ARule
  FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int Curry_Prelude.C_Int) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_ARule FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int Curry_Prelude.C_Int)))
d_C_normRule x1 cd cs = case x1 of
  FlatCurry.Annotated.Curry_Types.C_ARule x2 x3 x4 -> Curry_ErrorState.d_OP_lt_star_gt
    (Curry_ErrorState.d_OP_lt_star_gt (Curry_ErrorState.d_OP_lt_dollar_gt
    (acceptCs (acceptCs (acceptCs id)) FlatCurry.Annotated.Curry_Types.C_ARule)
    (d_C_normType x2 cd cs) cd cs) (Curry_ErrorState.d_C_mapES d_C_normSnd x3 cd
    cs) cd cs) (d_C_normExpr x4 cd cs) cd cs
  FlatCurry.Annotated.Curry_Types.C_AExternal x5 x6 -> Curry_ErrorState.d_OP_lt_dollar_gt
    (Curry_Prelude.d_C_flip (acceptCs (acceptCs id)
    FlatCurry.Annotated.Curry_Types.C_AExternal) x6) (d_C_normType x5 cd cs) cd
    cs
  FlatCurry.Annotated.Curry_Types.Choice_C_ARule d i l r -> narrow d i
    (d_C_normRule l cd cs) (d_C_normRule r cd cs)
  FlatCurry.Annotated.Curry_Types.Choices_C_ARule d i xs -> narrows cs d i
    (\z -> d_C_normRule z cd cs) xs
  FlatCurry.Annotated.Curry_Types.Guard_C_ARule d c e -> guardCons d c
    (d_C_normRule e cd $! addCs c cs)
  FlatCurry.Annotated.Curry_Types.Fail_C_ARule d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.normRule" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference.normRule"
    (showCons x1))

nd_C_normRule :: FlatCurry.Annotated.Curry_Types.C_ARule
  FlatCurry.Curry_Types.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int Curry_Prelude.C_Int)) (Curry_Prelude.C_Either
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_ARule FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int Curry_Prelude.C_Int))))
nd_C_normRule x1 s cd cs = case x1 of
  FlatCurry.Annotated.Curry_Types.C_ARule x2 x3 x4 -> let s9 = s
    in s9 `seq` (let s8 = leftSupply s9
                     s10 = rightSupply s9
                     s5 = leftSupply s10
                     s7 = rightSupply s10
    in s8 `seq` (s10 `seq` (s5 `seq` (s7 `seq` Curry_ErrorState.nd_OP_lt_star_gt
    (let s4 = leftSupply s5
         s6 = rightSupply s5
         s2 = leftSupply s6
         s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s2 `seq` (s3 `seq` Curry_ErrorState.nd_OP_lt_star_gt
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_ErrorState.nd_OP_lt_dollar_gt (wrapDX (wrapDX
    (wrapDX id)) (acceptCs (acceptCs (acceptCs id))
    FlatCurry.Annotated.Curry_Types.C_ARule)) (nd_C_normType x2 s0 cd cs) s1 cd
    cs)) (Curry_ErrorState.nd_C_mapES (wrapNX id nd_C_normSnd) x3 s3 cd cs) s4
    cd cs)))) (nd_C_normExpr x4 s7 cd cs) s8 cd cs))))
  FlatCurry.Annotated.Curry_Types.C_AExternal x5 x6 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_ErrorState.nd_OP_lt_dollar_gt (wrapNX id
    (Curry_Prelude.nd_C_flip (wrapDX (wrapDX id) (acceptCs (acceptCs id)
    FlatCurry.Annotated.Curry_Types.C_AExternal)) x6)) (nd_C_normType x5 s0 cd
    cs) s1 cd cs))
  FlatCurry.Annotated.Curry_Types.Choice_C_ARule d i l r -> narrow d i
    (nd_C_normRule l s cd cs) (nd_C_normRule r s cd cs)
  FlatCurry.Annotated.Curry_Types.Choices_C_ARule d i xs -> narrows cs d i
    (\z -> nd_C_normRule z s cd cs) xs
  FlatCurry.Annotated.Curry_Types.Guard_C_ARule d c e -> guardCons d c
    (nd_C_normRule e s cd $! addCs c cs)
  FlatCurry.Annotated.Curry_Types.Fail_C_ARule d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.normRule" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference.normRule"
    (showCons x1))

d_C_normExpr :: FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int Curry_Prelude.C_Int) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int Curry_Prelude.C_Int)))
d_C_normExpr x1 cd cs = case x1 of
  FlatCurry.Annotated.Curry_Types.C_AVar x2 x3 -> Curry_ErrorState.d_OP_lt_dollar_gt
    (Curry_Prelude.d_C_flip (acceptCs (acceptCs id)
    FlatCurry.Annotated.Curry_Types.C_AVar) x3) (d_C_normType x2 cd cs) cd cs
  FlatCurry.Annotated.Curry_Types.C_ALit x4 x5 -> Curry_ErrorState.d_OP_lt_dollar_gt
    (Curry_Prelude.d_C_flip (acceptCs (acceptCs id)
    FlatCurry.Annotated.Curry_Types.C_ALit) x5) (d_C_normType x4 cd cs) cd cs
  FlatCurry.Annotated.Curry_Types.C_AComb x6 x7 x8 x9 -> Curry_ErrorState.d_OP_lt_star_gt
    (Curry_ErrorState.d_OP_lt_star_gt (Curry_ErrorState.d_OP_lt_dollar_gt
    (Curry_Prelude.d_C_flip (acceptCs (acceptCs (acceptCs (acceptCs id)))
    FlatCurry.Annotated.Curry_Types.C_AComb) x7) (d_C_normType x6 cd cs) cd cs)
    (d_C_normSnd x8 cd cs) cd cs) (Curry_ErrorState.d_C_mapES d_C_normExpr x9 cd
    cs) cd cs
  FlatCurry.Annotated.Curry_Types.C_ALet x10 x11 x12 -> Curry_ErrorState.d_OP_lt_star_gt
    (Curry_ErrorState.d_OP_lt_star_gt (Curry_ErrorState.d_OP_lt_dollar_gt
    (acceptCs (acceptCs (acceptCs id)) FlatCurry.Annotated.Curry_Types.C_ALet)
    (d_C_normType x10 cd cs) cd cs) (Curry_ErrorState.d_C_mapES
    d_OP_normExpr_dot_normBinding_dot_453 x11 cd cs) cd cs) (d_C_normExpr x12 cd
    cs) cd cs
  FlatCurry.Annotated.Curry_Types.C_AOr x13 x14 x15 -> Curry_ErrorState.d_OP_lt_star_gt
    (Curry_ErrorState.d_OP_lt_star_gt (Curry_ErrorState.d_OP_lt_dollar_gt
    (acceptCs (acceptCs (acceptCs id)) FlatCurry.Annotated.Curry_Types.C_AOr)
    (d_C_normType x13 cd cs) cd cs) (d_C_normExpr x14 cd cs) cd cs)
    (d_C_normExpr x15 cd cs) cd cs
  FlatCurry.Annotated.Curry_Types.C_ACase x16 x17 x18 x19 -> Curry_ErrorState.d_OP_lt_star_gt
    (Curry_ErrorState.d_OP_lt_star_gt (Curry_ErrorState.d_OP_lt_dollar_gt
    (Curry_Prelude.d_C_flip (acceptCs (acceptCs (acceptCs (acceptCs id)))
    FlatCurry.Annotated.Curry_Types.C_ACase) x17) (d_C_normType x16 cd cs) cd
    cs) (d_C_normExpr x18 cd cs) cd cs) (Curry_ErrorState.d_C_mapES
    d_C_normBranch x19 cd cs) cd cs
  FlatCurry.Annotated.Curry_Types.C_AFree x20 x21 x22 -> Curry_ErrorState.d_OP_lt_star_gt
    (Curry_ErrorState.d_OP_lt_star_gt (Curry_ErrorState.d_OP_lt_dollar_gt
    (acceptCs (acceptCs (acceptCs id)) FlatCurry.Annotated.Curry_Types.C_AFree)
    (d_C_normType x20 cd cs) cd cs) (Curry_ErrorState.d_C_mapES d_C_normSnd x21
    cd cs) cd cs) (d_C_normExpr x22 cd cs) cd cs
  FlatCurry.Annotated.Curry_Types.C_ATyped x23 x24 x25 -> Curry_ErrorState.d_OP_lt_star_gt
    (Curry_ErrorState.d_OP_lt_star_gt (Curry_ErrorState.d_OP_lt_dollar_gt
    (acceptCs (acceptCs (acceptCs id)) FlatCurry.Annotated.Curry_Types.C_ATyped)
    (d_C_normType x23 cd cs) cd cs) (d_C_normExpr x24 cd cs) cd cs)
    (d_C_normType x25 cd cs) cd cs
  FlatCurry.Annotated.Curry_Types.Choice_C_AExpr d i l r -> narrow d i
    (d_C_normExpr l cd cs) (d_C_normExpr r cd cs)
  FlatCurry.Annotated.Curry_Types.Choices_C_AExpr d i xs -> narrows cs d i
    (\z -> d_C_normExpr z cd cs) xs
  FlatCurry.Annotated.Curry_Types.Guard_C_AExpr d c e -> guardCons d c
    (d_C_normExpr e cd $! addCs c cs)
  FlatCurry.Annotated.Curry_Types.Fail_C_AExpr d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.normExpr" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference.normExpr"
    (showCons x1))

nd_C_normExpr :: FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int Curry_Prelude.C_Int)) (Curry_Prelude.C_Either
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int Curry_Prelude.C_Int))))
nd_C_normExpr x1 s cd cs = case x1 of
  FlatCurry.Annotated.Curry_Types.C_AVar x2 x3 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_ErrorState.nd_OP_lt_dollar_gt (wrapNX id
    (Curry_Prelude.nd_C_flip (wrapDX (wrapDX id) (acceptCs (acceptCs id)
    FlatCurry.Annotated.Curry_Types.C_AVar)) x3)) (nd_C_normType x2 s0 cd cs) s1
    cd cs))
  FlatCurry.Annotated.Curry_Types.C_ALit x4 x5 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_ErrorState.nd_OP_lt_dollar_gt (wrapNX id
    (Curry_Prelude.nd_C_flip (wrapDX (wrapDX id) (acceptCs (acceptCs id)
    FlatCurry.Annotated.Curry_Types.C_ALit)) x5)) (nd_C_normType x4 s0 cd cs) s1
    cd cs))
  FlatCurry.Annotated.Curry_Types.C_AComb x6 x7 x8 x9 -> let s9 = s
    in s9 `seq` (let s8 = leftSupply s9
                     s10 = rightSupply s9
                     s5 = leftSupply s10
                     s7 = rightSupply s10
    in s8 `seq` (s10 `seq` (s5 `seq` (s7 `seq` Curry_ErrorState.nd_OP_lt_star_gt
    (let s4 = leftSupply s5
         s6 = rightSupply s5
         s2 = leftSupply s6
         s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s2 `seq` (s3 `seq` Curry_ErrorState.nd_OP_lt_star_gt
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_ErrorState.nd_OP_lt_dollar_gt (wrapNX id
    (Curry_Prelude.nd_C_flip (wrapDX (wrapDX (wrapDX (wrapDX id))) (acceptCs
    (acceptCs (acceptCs (acceptCs id)))
    FlatCurry.Annotated.Curry_Types.C_AComb)) x7)) (nd_C_normType x6 s0 cd cs)
    s1 cd cs)) (nd_C_normSnd x8 s3 cd cs) s4 cd cs))))
    (Curry_ErrorState.nd_C_mapES (wrapNX id nd_C_normExpr) x9 s7 cd cs) s8 cd
    cs))))
  FlatCurry.Annotated.Curry_Types.C_ALet x10 x11 x12 -> let s9 = s
    in s9 `seq` (let s8 = leftSupply s9
                     s10 = rightSupply s9
                     s5 = leftSupply s10
                     s7 = rightSupply s10
    in s8 `seq` (s10 `seq` (s5 `seq` (s7 `seq` Curry_ErrorState.nd_OP_lt_star_gt
    (let s4 = leftSupply s5
         s6 = rightSupply s5
         s2 = leftSupply s6
         s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s2 `seq` (s3 `seq` Curry_ErrorState.nd_OP_lt_star_gt
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_ErrorState.nd_OP_lt_dollar_gt (wrapDX (wrapDX
    (wrapDX id)) (acceptCs (acceptCs (acceptCs id))
    FlatCurry.Annotated.Curry_Types.C_ALet)) (nd_C_normType x10 s0 cd cs) s1 cd
    cs)) (Curry_ErrorState.nd_C_mapES (wrapNX id
    nd_OP_normExpr_dot_normBinding_dot_453) x11 s3 cd cs) s4 cd cs))))
    (nd_C_normExpr x12 s7 cd cs) s8 cd cs))))
  FlatCurry.Annotated.Curry_Types.C_AOr x13 x14 x15 -> let s9 = s
    in s9 `seq` (let s8 = leftSupply s9
                     s10 = rightSupply s9
                     s5 = leftSupply s10
                     s7 = rightSupply s10
    in s8 `seq` (s10 `seq` (s5 `seq` (s7 `seq` Curry_ErrorState.nd_OP_lt_star_gt
    (let s4 = leftSupply s5
         s6 = rightSupply s5
         s2 = leftSupply s6
         s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s2 `seq` (s3 `seq` Curry_ErrorState.nd_OP_lt_star_gt
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_ErrorState.nd_OP_lt_dollar_gt (wrapDX (wrapDX
    (wrapDX id)) (acceptCs (acceptCs (acceptCs id))
    FlatCurry.Annotated.Curry_Types.C_AOr)) (nd_C_normType x13 s0 cd cs) s1 cd
    cs)) (nd_C_normExpr x14 s3 cd cs) s4 cd cs)))) (nd_C_normExpr x15 s7 cd cs)
    s8 cd cs))))
  FlatCurry.Annotated.Curry_Types.C_ACase x16 x17 x18 x19 -> let s9 = s
    in s9 `seq` (let s8 = leftSupply s9
                     s10 = rightSupply s9
                     s5 = leftSupply s10
                     s7 = rightSupply s10
    in s8 `seq` (s10 `seq` (s5 `seq` (s7 `seq` Curry_ErrorState.nd_OP_lt_star_gt
    (let s4 = leftSupply s5
         s6 = rightSupply s5
         s2 = leftSupply s6
         s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s2 `seq` (s3 `seq` Curry_ErrorState.nd_OP_lt_star_gt
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_ErrorState.nd_OP_lt_dollar_gt (wrapNX id
    (Curry_Prelude.nd_C_flip (wrapDX (wrapDX (wrapDX (wrapDX id))) (acceptCs
    (acceptCs (acceptCs (acceptCs id)))
    FlatCurry.Annotated.Curry_Types.C_ACase)) x17)) (nd_C_normType x16 s0 cd cs)
    s1 cd cs)) (nd_C_normExpr x18 s3 cd cs) s4 cd cs))))
    (Curry_ErrorState.nd_C_mapES (wrapNX id nd_C_normBranch) x19 s7 cd cs) s8 cd
    cs))))
  FlatCurry.Annotated.Curry_Types.C_AFree x20 x21 x22 -> let s9 = s
    in s9 `seq` (let s8 = leftSupply s9
                     s10 = rightSupply s9
                     s5 = leftSupply s10
                     s7 = rightSupply s10
    in s8 `seq` (s10 `seq` (s5 `seq` (s7 `seq` Curry_ErrorState.nd_OP_lt_star_gt
    (let s4 = leftSupply s5
         s6 = rightSupply s5
         s2 = leftSupply s6
         s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s2 `seq` (s3 `seq` Curry_ErrorState.nd_OP_lt_star_gt
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_ErrorState.nd_OP_lt_dollar_gt (wrapDX (wrapDX
    (wrapDX id)) (acceptCs (acceptCs (acceptCs id))
    FlatCurry.Annotated.Curry_Types.C_AFree)) (nd_C_normType x20 s0 cd cs) s1 cd
    cs)) (Curry_ErrorState.nd_C_mapES (wrapNX id nd_C_normSnd) x21 s3 cd cs) s4
    cd cs)))) (nd_C_normExpr x22 s7 cd cs) s8 cd cs))))
  FlatCurry.Annotated.Curry_Types.C_ATyped x23 x24 x25 -> let s9 = s
    in s9 `seq` (let s8 = leftSupply s9
                     s10 = rightSupply s9
                     s5 = leftSupply s10
                     s7 = rightSupply s10
    in s8 `seq` (s10 `seq` (s5 `seq` (s7 `seq` Curry_ErrorState.nd_OP_lt_star_gt
    (let s4 = leftSupply s5
         s6 = rightSupply s5
         s2 = leftSupply s6
         s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s2 `seq` (s3 `seq` Curry_ErrorState.nd_OP_lt_star_gt
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_ErrorState.nd_OP_lt_dollar_gt (wrapDX (wrapDX
    (wrapDX id)) (acceptCs (acceptCs (acceptCs id))
    FlatCurry.Annotated.Curry_Types.C_ATyped)) (nd_C_normType x23 s0 cd cs) s1
    cd cs)) (nd_C_normExpr x24 s3 cd cs) s4 cd cs)))) (nd_C_normType x25 s7 cd
    cs) s8 cd cs))))
  FlatCurry.Annotated.Curry_Types.Choice_C_AExpr d i l r -> narrow d i
    (nd_C_normExpr l s cd cs) (nd_C_normExpr r s cd cs)
  FlatCurry.Annotated.Curry_Types.Choices_C_AExpr d i xs -> narrows cs d i
    (\z -> nd_C_normExpr z s cd cs) xs
  FlatCurry.Annotated.Curry_Types.Guard_C_AExpr d c e -> guardCons d c
    (nd_C_normExpr e s cd $! addCs c cs)
  FlatCurry.Annotated.Curry_Types.Fail_C_AExpr d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.normExpr" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference.normExpr"
    (showCons x1))

d_OP_normExpr_dot_normBinding_dot_453 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 t0
  FlatCurry.Curry_Types.C_TypeExpr) (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int Curry_Prelude.C_Int) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 t0
  FlatCurry.Curry_Types.C_TypeExpr) (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  Curry_Prelude.C_Int)))
d_OP_normExpr_dot_normBinding_dot_453 x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> Curry_ErrorState.d_OP_lt_star_gt
    (Curry_ErrorState.d_OP_lt_dollar_gt (acceptCs (acceptCs id)
    Curry_Prelude.OP_Tuple2) (d_C_normSnd x2 cd cs) cd cs) (d_C_normExpr x3 cd
    cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_normExpr_dot_normBinding_dot_453 l cd cs)
    (d_OP_normExpr_dot_normBinding_dot_453 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_normExpr_dot_normBinding_dot_453 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_normExpr_dot_normBinding_dot_453 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.normExpr.normBinding.453" [show x1] info)
  _ -> failCons cd (consFail
    "FlatCurry.Annotated.TypeInference.normExpr.normBinding.453" (showCons x1))

nd_OP_normExpr_dot_normBinding_dot_453 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 t0
  FlatCurry.Curry_Types.C_TypeExpr) (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int Curry_Prelude.C_Int)) (Curry_Prelude.C_Either
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 t0 FlatCurry.Curry_Types.C_TypeExpr)
  (FlatCurry.Annotated.Curry_Types.C_AExpr FlatCurry.Curry_Types.C_TypeExpr))
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int Curry_Prelude.C_Int))))
nd_OP_normExpr_dot_normBinding_dot_453 x1 s cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> let s5 = s
    in s5 `seq` (let s4 = leftSupply s5
                     s6 = rightSupply s5
                     s2 = leftSupply s6
                     s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s2 `seq` (s3 `seq` Curry_ErrorState.nd_OP_lt_star_gt
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_ErrorState.nd_OP_lt_dollar_gt (wrapDX (wrapDX
    id) (acceptCs (acceptCs id) Curry_Prelude.OP_Tuple2)) (nd_C_normSnd x2 s0 cd
    cs) s1 cd cs)) (nd_C_normExpr x3 s3 cd cs) s4 cd cs))))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_normExpr_dot_normBinding_dot_453 l s cd cs)
    (nd_OP_normExpr_dot_normBinding_dot_453 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_normExpr_dot_normBinding_dot_453 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (nd_OP_normExpr_dot_normBinding_dot_453 e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.normExpr.normBinding.453" [show x1] info)
  _ -> failCons cd (consFail
    "FlatCurry.Annotated.TypeInference.normExpr.normBinding.453" (showCons x1))

d_C_normSnd :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_Tuple2
  t0 FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int Curry_Prelude.C_Int) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 t0 FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int Curry_Prelude.C_Int)))
d_C_normSnd x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> Curry_ErrorState.d_OP_gt_plus_eq
    (d_C_normType x3 cd cs) (d_OP_normSnd_dot_uscore_hash_lambda69 x2)
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C_normSnd l cd cs)
    (d_C_normSnd r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C_normSnd z
    cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C_normSnd e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.normSnd" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference.normSnd"
    (showCons x1))

nd_C_normSnd :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_Tuple2
  t0 FlatCurry.Curry_Types.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int Curry_Prelude.C_Int)) (Curry_Prelude.C_Either
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 t0
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int))))
nd_C_normSnd x1 s cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> let s0 = s
    in s0 `seq` wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (nd_C_normType x3
    s0 cd cs) (wrapDX (wrapDX id) (d_OP_normSnd_dot_uscore_hash_lambda69 x2)))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C_normSnd l s cd cs)
    (nd_C_normSnd r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C_normSnd z
    s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (nd_C_normSnd e s cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference.normSnd" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference.normSnd"
    (showCons x1))

d_OP_normSnd_dot_uscore_hash_lambda69 :: forall t2 t0 t1 . (Curry_Prelude.Curry
  t2, Curry_Prelude.Curry t0, Curry_Prelude.Curry t1) => t0
  -> FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore -> t1 -> Cover
  -> ConstStore -> Curry_Prelude.C_Either t2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 t0 FlatCurry.Curry_Types.C_TypeExpr) t1)
d_OP_normSnd_dot_uscore_hash_lambda69 x1 x2 cd cs =
  Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Tuple2 x1 x2)

d_C_normBranch :: FlatCurry.Annotated.Curry_Types.C_ABranchExpr
  FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int Curry_Prelude.C_Int) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_ABranchExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int)))
d_C_normBranch x1 cd cs = case x1 of
  FlatCurry.Annotated.Curry_Types.C_ABranch x2 x3 -> Curry_ErrorState.d_OP_lt_star_gt
    (Curry_ErrorState.d_OP_lt_dollar_gt (acceptCs (acceptCs id)
    FlatCurry.Annotated.Curry_Types.C_ABranch) (d_C_normPattern x2 cd cs) cd cs)
    (d_C_normExpr x3 cd cs) cd cs
  FlatCurry.Annotated.Curry_Types.Choice_C_ABranchExpr d i l r -> narrow d i
    (d_C_normBranch l cd cs) (d_C_normBranch r cd cs)
  FlatCurry.Annotated.Curry_Types.Choices_C_ABranchExpr d i xs -> narrows cs d i
    (\z -> d_C_normBranch z cd cs) xs
  FlatCurry.Annotated.Curry_Types.Guard_C_ABranchExpr d c e -> guardCons d c
    (d_C_normBranch e cd $! addCs c cs)
  FlatCurry.Annotated.Curry_Types.Fail_C_ABranchExpr d info -> failCons d
    (traceFail "FlatCurry.Annotated.TypeInference.normBranch" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference.normBranch"
    (showCons x1))

nd_C_normBranch :: FlatCurry.Annotated.Curry_Types.C_ABranchExpr
  FlatCurry.Curry_Types.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int Curry_Prelude.C_Int)) (Curry_Prelude.C_Either
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_ABranchExpr
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int))))
nd_C_normBranch x1 s cd cs = case x1 of
  FlatCurry.Annotated.Curry_Types.C_ABranch x2 x3 -> let s5 = s
    in s5 `seq` (let s4 = leftSupply s5
                     s6 = rightSupply s5
                     s2 = leftSupply s6
                     s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s2 `seq` (s3 `seq` Curry_ErrorState.nd_OP_lt_star_gt
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_ErrorState.nd_OP_lt_dollar_gt (wrapDX (wrapDX
    id) (acceptCs (acceptCs id) FlatCurry.Annotated.Curry_Types.C_ABranch))
    (nd_C_normPattern x2 s0 cd cs) s1 cd cs)) (nd_C_normExpr x3 s3 cd cs) s4 cd
    cs))))
  FlatCurry.Annotated.Curry_Types.Choice_C_ABranchExpr d i l r -> narrow d i
    (nd_C_normBranch l s cd cs) (nd_C_normBranch r s cd cs)
  FlatCurry.Annotated.Curry_Types.Choices_C_ABranchExpr d i xs -> narrows cs d i
    (\z -> nd_C_normBranch z s cd cs) xs
  FlatCurry.Annotated.Curry_Types.Guard_C_ABranchExpr d c e -> guardCons d c
    (nd_C_normBranch e s cd $! addCs c cs)
  FlatCurry.Annotated.Curry_Types.Fail_C_ABranchExpr d info -> failCons d
    (traceFail "FlatCurry.Annotated.TypeInference.normBranch" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference.normBranch"
    (showCons x1))

d_C_normPattern :: FlatCurry.Annotated.Curry_Types.C_APattern
  FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int Curry_Prelude.C_Int) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_APattern FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int Curry_Prelude.C_Int)))
d_C_normPattern x1 cd cs = case x1 of
  FlatCurry.Annotated.Curry_Types.C_APattern x2 x3 x4 -> Curry_ErrorState.d_OP_lt_star_gt
    (Curry_ErrorState.d_OP_lt_star_gt (Curry_ErrorState.d_OP_lt_dollar_gt
    (acceptCs (acceptCs (acceptCs id))
    FlatCurry.Annotated.Curry_Types.C_APattern) (d_C_normType x2 cd cs) cd cs)
    (d_C_normSnd x3 cd cs) cd cs) (Curry_ErrorState.d_C_mapES d_C_normSnd x4 cd
    cs) cd cs
  FlatCurry.Annotated.Curry_Types.C_ALPattern x5 x6 -> Curry_ErrorState.d_OP_lt_dollar_gt
    (Curry_Prelude.d_C_flip (acceptCs (acceptCs id)
    FlatCurry.Annotated.Curry_Types.C_ALPattern) x6) (d_C_normType x5 cd cs) cd
    cs
  FlatCurry.Annotated.Curry_Types.Choice_C_APattern d i l r -> narrow d i
    (d_C_normPattern l cd cs) (d_C_normPattern r cd cs)
  FlatCurry.Annotated.Curry_Types.Choices_C_APattern d i xs -> narrows cs d i
    (\z -> d_C_normPattern z cd cs) xs
  FlatCurry.Annotated.Curry_Types.Guard_C_APattern d c e -> guardCons d c
    (d_C_normPattern e cd $! addCs c cs)
  FlatCurry.Annotated.Curry_Types.Fail_C_APattern d info -> failCons d
    (traceFail "FlatCurry.Annotated.TypeInference.normPattern" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference.normPattern"
    (showCons x1))

nd_C_normPattern :: FlatCurry.Annotated.Curry_Types.C_APattern
  FlatCurry.Curry_Types.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int Curry_Prelude.C_Int)) (Curry_Prelude.C_Either
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_APattern FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int Curry_Prelude.C_Int))))
nd_C_normPattern x1 s cd cs = case x1 of
  FlatCurry.Annotated.Curry_Types.C_APattern x2 x3 x4 -> let s9 = s
    in s9 `seq` (let s8 = leftSupply s9
                     s10 = rightSupply s9
                     s5 = leftSupply s10
                     s7 = rightSupply s10
    in s8 `seq` (s10 `seq` (s5 `seq` (s7 `seq` Curry_ErrorState.nd_OP_lt_star_gt
    (let s4 = leftSupply s5
         s6 = rightSupply s5
         s2 = leftSupply s6
         s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s2 `seq` (s3 `seq` Curry_ErrorState.nd_OP_lt_star_gt
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_ErrorState.nd_OP_lt_dollar_gt (wrapDX (wrapDX
    (wrapDX id)) (acceptCs (acceptCs (acceptCs id))
    FlatCurry.Annotated.Curry_Types.C_APattern)) (nd_C_normType x2 s0 cd cs) s1
    cd cs)) (nd_C_normSnd x3 s3 cd cs) s4 cd cs)))) (Curry_ErrorState.nd_C_mapES
    (wrapNX id nd_C_normSnd) x4 s7 cd cs) s8 cd cs))))
  FlatCurry.Annotated.Curry_Types.C_ALPattern x5 x6 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_ErrorState.nd_OP_lt_dollar_gt (wrapNX id
    (Curry_Prelude.nd_C_flip (wrapDX (wrapDX id) (acceptCs (acceptCs id)
    FlatCurry.Annotated.Curry_Types.C_ALPattern)) x6)) (nd_C_normType x5 s0 cd
    cs) s1 cd cs))
  FlatCurry.Annotated.Curry_Types.Choice_C_APattern d i l r -> narrow d i
    (nd_C_normPattern l s cd cs) (nd_C_normPattern r s cd cs)
  FlatCurry.Annotated.Curry_Types.Choices_C_APattern d i xs -> narrows cs d i
    (\z -> nd_C_normPattern z s cd cs) xs
  FlatCurry.Annotated.Curry_Types.Guard_C_APattern d c e -> guardCons d c
    (nd_C_normPattern e s cd $! addCs c cs)
  FlatCurry.Annotated.Curry_Types.Fail_C_APattern d info -> failCons d
    (traceFail "FlatCurry.Annotated.TypeInference.normPattern" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference.normPattern"
    (showCons x1))

d_C__case_0 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_Int
  -> Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int
  -> Curry_Prelude.C_Int -> Curry_Prelude.C_Maybe Curry_Prelude.C_Int -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int) -> Cover
  -> ConstStore -> Curry_Prelude.C_Either t0 (Curry_Prelude.OP_Tuple2
  FlatCurry.Curry_Types.C_TypeExpr (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int)))
d_C__case_0 x1 x4 x3 x6 cd cs = case x6 of
  Curry_Prelude.C_Nothing -> Curry_ErrorState.d_OP_gt_plus
    (Curry_ErrorState.d_C_puts (Curry_Prelude.OP_Tuple2 (Curry_Prelude.d_OP_plus
    x3 (Curry_Prelude.C_Int 1#) cd cs) (Curry_FiniteMap.d_C_addToFM x4 x1 x3 cd
    cs))) (Curry_ErrorState.d_C_returnES (FlatCurry.Curry_Types.C_TVar x3)) cd
    cs
  Curry_Prelude.C_Just x5 -> Curry_ErrorState.d_C_returnES
    (FlatCurry.Curry_Types.C_TVar x5)
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i (d_C__case_0 x1 x4 x3 l cd
    cs) (d_C__case_0 x1 x4 x3 r cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z -> d_C__case_0 x1
    x4 x3 z cd cs) xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c (d_C__case_0 x1 x4 x3 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference._case_0" [show x1, show x4, show x3, show
    x6] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference._case_0"
    (showCons x6))

nd_C__case_0 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_Int
  -> Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int
  -> Curry_Prelude.C_Int -> Curry_Prelude.C_Maybe Curry_Prelude.C_Int
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  Curry_Prelude.C_Int)) (Curry_Prelude.C_Either t0 (Curry_Prelude.OP_Tuple2
  FlatCurry.Curry_Types.C_TypeExpr (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int))))
nd_C__case_0 x1 x4 x3 x6 s cd cs = case x6 of
  Curry_Prelude.C_Nothing -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_ErrorState.nd_OP_gt_plus (wrapDX id
    (Curry_ErrorState.d_C_puts (Curry_Prelude.OP_Tuple2 (Curry_Prelude.d_OP_plus
    x3 (Curry_Prelude.C_Int 1#) cd cs) (Curry_FiniteMap.nd_C_addToFM x4 x1 x3 s0
    cd cs)))) (wrapDX id (Curry_ErrorState.d_C_returnES
    (FlatCurry.Curry_Types.C_TVar x3))) s1 cd cs))
  Curry_Prelude.C_Just x5 -> wrapDX id (Curry_ErrorState.d_C_returnES
    (FlatCurry.Curry_Types.C_TVar x5))
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i (nd_C__case_0 x1 x4 x3 l s
    cd cs) (nd_C__case_0 x1 x4 x3 r s cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z -> nd_C__case_0 x1
    x4 x3 z s cd cs) xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c (nd_C__case_0 x1 x4 x3 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference._case_0" [show x1, show x4, show x3, show
    x6] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference._case_0"
    (showCons x6))

d_C__case_1 :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => t0 -> (t0 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  Curry_Prelude.C_Int) -> Cover -> ConstStore -> Curry_Prelude.C_Either
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  Curry_Prelude.C_Int)))) -> Curry_Prelude.C_Either Curry_Prelude.OP_Unit t0
  -> Cover -> ConstStore -> t1 -> Cover -> ConstStore -> Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 t0 t1)
d_C__case_1 x2 x1 x5 cd cs = case x5 of
  Curry_Prelude.C_Left x3 -> Curry_Prelude.d_OP_dollar (acceptCs id
    Curry_ErrorState.d_C_failES) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "Normalization failed for: ")
    (Curry_Prelude.d_C_show x2 cd cs) cd cs) cd cs
  Curry_Prelude.C_Right x4 -> Curry_ErrorState.d_C_returnES x4
  Curry_Prelude.Choice_C_Either d i l r -> narrow d i (d_C__case_1 x2 x1 l cd
    cs) (d_C__case_1 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Either d i xs -> narrows cs d i (\z -> d_C__case_1 x2
    x1 z cd cs) xs
  Curry_Prelude.Guard_C_Either d c e -> guardCons d c (d_C__case_1 x2 x1 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Either d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference._case_1" [show x2, show x1, show x5]
    info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference._case_1"
    (showCons x5))

nd_C__case_1 :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => t0 -> Func t0 (Func (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int))
  (Curry_Prelude.C_Either Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple2 t0
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int Curry_Prelude.C_Int))))) -> Curry_Prelude.C_Either
  Curry_Prelude.OP_Unit t0 -> IDSupply -> Cover -> ConstStore -> Func t1
  (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 t0 t1))
nd_C__case_1 x2 x1 x5 s cd cs = case x5 of
  Curry_Prelude.C_Left x3 -> let s0 = s
    in s0 `seq` Curry_Prelude.nd_OP_dollar (wrapDX (wrapDX id) (acceptCs id
    Curry_ErrorState.d_C_failES)) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "Normalization failed for: ")
    (Curry_Prelude.d_C_show x2 cd cs) cd cs) s0 cd cs
  Curry_Prelude.C_Right x4 -> wrapDX id (Curry_ErrorState.d_C_returnES x4)
  Curry_Prelude.Choice_C_Either d i l r -> narrow d i (nd_C__case_1 x2 x1 l s cd
    cs) (nd_C__case_1 x2 x1 r s cd cs)
  Curry_Prelude.Choices_C_Either d i xs -> narrows cs d i (\z -> nd_C__case_1 x2
    x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Either d c e -> guardCons d c (nd_C__case_1 x2 x1 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Either d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference._case_1" [show x2, show x1, show x5]
    info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference._case_1"
    (showCons x5))

d_C__case_3 :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> t0
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List
  t0) -> Curry_Prelude.OP_List t0 -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List
  t0)
d_C__case_3 x2 x3 x5 x4 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_List x4
  Curry_Prelude.C_False -> d_C__case_2 x5 x3 (Curry_Prelude.d_C_otherwise cd cs)
    cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_3 x2 x3 x5 x4 l
    cd cs) (d_C__case_3 x2 x3 x5 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_3 x2 x3
    x5 x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_3 x2 x3 x5 x4 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference._case_3" [show x2, show x3, show x5, show
    x4, show x6] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference._case_3"
    (showCons x6))

d_C__case_2 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List t0) -> t0
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List t0)
d_C__case_2 x5 x3 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Cons x3
    (Curry_Prelude.d_C_fst x5 cd cs)) (Curry_Prelude.d_C_snd x5 cd cs)
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_2 x5 x3 l cd cs)
    (d_C__case_2 x5 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_2 x5 x3
    z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_2 x5 x3 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference._case_2" [show x5, show x3, show x6]
    info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference._case_2"
    (showCons x6))

d_C__case_5 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Rewriting.Curry_Term.C_Term (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_TypeExpr
d_C__case_5 x3 x4 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> FlatCurry.Curry_Types.C_FuncType (d_C_toTypeExpr
    (Curry_Prelude.d_OP_bang_bang x4 (Curry_Prelude.C_Int 0#) cd cs) cd cs)
    (d_C_toTypeExpr (Curry_Prelude.d_OP_bang_bang x4 (Curry_Prelude.C_Int 1#) cd
    cs) cd cs)
  Curry_Prelude.C_False -> d_C__case_4 x4 x3 (Curry_Prelude.d_C_otherwise cd cs)
    cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_5 x3 x4 l cd cs)
    (d_C__case_5 x3 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_5 x3 x4
    z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_5 x3 x4 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference._case_5" [show x3, show x4, show x5]
    info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference._case_5"
    (showCons x5))

d_C__case_4 :: Curry_Prelude.OP_List (Rewriting.Curry_Term.C_Term
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> FlatCurry.Curry_Types.C_TypeExpr
d_C__case_4 x4 x3 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> FlatCurry.Curry_Types.C_TCons (d_C_toQName x3 cd cs)
    (Curry_Prelude.d_C_map d_C_toTypeExpr x4 cd cs)
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_4 x4 x3 l cd cs)
    (d_C__case_4 x4 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_4 x4 x3
    z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_4 x4 x3 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference._case_4" [show x4, show x3, show x5]
    info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference._case_4"
    (showCons x5))

d_C__case_6 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  FlatCurry.Curry_Types.C_TypeExpr FlatCurry.Curry_Types.C_TypeExpr)
  -> Curry_Prelude.C_Either (Rewriting.Curry_UnificationSpec.C_UnificationError
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int (Rewriting.Curry_Term.C_Term (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))
d_C__case_6 x1 x4 cd cs = case x4 of
  Curry_Prelude.C_Left x2 -> Curry_Prelude.d_OP_dollar (acceptCs id
    Curry_ErrorState.d_C_failES) (d_C_showUnificationError x2 cd cs) cd cs
  Curry_Prelude.C_Right x3 -> Curry_ErrorState.d_C_returnES
    (Curry_FiniteMap.d_C_mapFM d_OP_solve_dot_uscore_hash_lambda63 x3 cd cs)
  Curry_Prelude.Choice_C_Either d i l r -> narrow d i (d_C__case_6 x1 l cd cs)
    (d_C__case_6 x1 r cd cs)
  Curry_Prelude.Choices_C_Either d i xs -> narrows cs d i (\z -> d_C__case_6 x1
    z cd cs) xs
  Curry_Prelude.Guard_C_Either d c e -> guardCons d c (d_C__case_6 x1 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Either d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference._case_6" [show x1, show x4] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference._case_6"
    (showCons x4))

nd_C__case_6 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  FlatCurry.Curry_Types.C_TypeExpr FlatCurry.Curry_Types.C_TypeExpr)
  -> Curry_Prelude.C_Either (Rewriting.Curry_UnificationSpec.C_UnificationError
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int (Rewriting.Curry_Term.C_Term (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))) -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_FiniteMap.C_FM Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))))
nd_C__case_6 x1 x4 s cd cs = case x4 of
  Curry_Prelude.C_Left x2 -> let s0 = s
    in s0 `seq` Curry_Prelude.nd_OP_dollar (wrapDX (wrapDX id) (acceptCs id
    Curry_ErrorState.d_C_failES)) (d_C_showUnificationError x2 cd cs) s0 cd cs
  Curry_Prelude.C_Right x3 -> let s0 = s
    in s0 `seq` wrapDX id (Curry_ErrorState.d_C_returnES
    (Curry_FiniteMap.nd_C_mapFM (wrapDX (wrapDX id)
    d_OP_solve_dot_uscore_hash_lambda63) x3 s0 cd cs))
  Curry_Prelude.Choice_C_Either d i l r -> narrow d i (nd_C__case_6 x1 l s cd
    cs) (nd_C__case_6 x1 r s cd cs)
  Curry_Prelude.Choices_C_Either d i xs -> narrows cs d i (\z -> nd_C__case_6 x1
    z s cd cs) xs
  Curry_Prelude.Guard_C_Either d c e -> guardCons d c (nd_C__case_6 x1 e s cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Either d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference._case_6" [show x1, show x4] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference._case_6"
    (showCons x4))

d_C__case_7 :: FlatCurry.Curry_Types.C_TypeExpr -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  -> FlatCurry.Curry_Types.C_TypeExpr -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr
  -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  FlatCurry.Curry_Types.C_TypeExpr FlatCurry.Curry_Types.C_TypeExpr))
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))
d_C__case_7 x3 x5 x1 x4 cd cs = case x4 of
  Curry_Prelude.OP_Tuple2 x6 x7 -> Curry_ErrorState.d_C_returnES
    (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x1 x3 cd cs) (Curry_Prelude.OP_Cons
    (d_OP_eq_dot_eq x7 (Curry_Prelude.d_C_foldr1 (acceptCs (acceptCs id)
    FlatCurry.Curry_Types.C_FuncType) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_map Curry_Prelude.d_C_snd x5 cd cs)
    (Curry_Prelude.OP_Cons x3 Curry_Prelude.OP_List) cd cs) cd cs) cd cs)
    Curry_Prelude.OP_List))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_7 x3 x5 x1 l
    cd cs) (d_C__case_7 x3 x5 x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_7 x3
    x5 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_7 x3 x5 x1 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference._case_7" [show x3, show x5, show x1, show
    x4] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference._case_7"
    (showCons x4))

nd_C__case_7 :: FlatCurry.Curry_Types.C_TypeExpr -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr)
  -> FlatCurry.Curry_Types.C_TypeExpr -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr
  -> IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  FlatCurry.Curry_Types.C_TypeExpr FlatCurry.Curry_Types.C_TypeExpr))
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))))
nd_C__case_7 x3 x5 x1 x4 s cd cs = case x4 of
  Curry_Prelude.OP_Tuple2 x6 x7 -> let s2 = s
    in s2 `seq` wrapDX id (Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Cons
    (d_OP_eq_dot_eq x1 x3 cd cs) (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x7
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_foldr1 (wrapDX (wrapDX id)
    (acceptCs (acceptCs id) FlatCurry.Curry_Types.C_FuncType))
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.nd_C_map (wrapDX id
    Curry_Prelude.d_C_snd) x5 s0 cd cs) (Curry_Prelude.OP_Cons x3
    Curry_Prelude.OP_List) cd cs) s1 cd cs)) cd cs) Curry_Prelude.OP_List)))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_7 x3 x5 x1 l
    s cd cs) (nd_C__case_7 x3 x5 x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_7
    x3 x5 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (nd_C__case_7 x3 x5 x1 e
    s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference._case_7" [show x3, show x5, show x1, show
    x4] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference._case_7"
    (showCons x4))

d_C__case_8 :: FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr -> Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 FlatCurry.Curry_Types.C_TypeExpr
  FlatCurry.Curry_Types.C_TypeExpr
d_C__case_8 x3 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> d_OP_eq_dot_eq x5 (Curry_Prelude.d_C_apply
    (d_C_exprType cd cs) x3 cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_8 x3 l cd cs)
    (d_C__case_8 x3 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_8 x3
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_8 x3 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference._case_8" [show x3, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference._case_8"
    (showCons x2))

d_C__case_9 :: Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) -> FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  FlatCurry.Curry_Types.C_TypeExpr FlatCurry.Curry_Types.C_TypeExpr))
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))
d_C__case_9 x9 x6 x8 cd cs = case x8 of
  Curry_Prelude.OP_Tuple2 x10 x11 -> d_OP_plus_plus_eq
    (Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x11
    (Curry_Prelude.d_C_foldr1 (acceptCs (acceptCs id)
    FlatCurry.Curry_Types.C_FuncType) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_map (d_C_exprType cd cs) x9 cd cs) (Curry_Prelude.OP_Cons
    x6 Curry_Prelude.OP_List) cd cs) cd cs) cd cs) Curry_Prelude.OP_List))
    (Curry_ErrorState.d_C_concatMapES d_C_eqsExpr x9 cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_9 x9 x6 l cd
    cs) (d_C__case_9 x9 x6 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_9 x9
    x6 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_9 x9 x6 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference._case_9" [show x9, show x6, show x8]
    info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference._case_9"
    (showCons x8))

nd_C__case_9 :: Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AExpr
  FlatCurry.Curry_Types.C_TypeExpr) -> FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  FlatCurry.Curry_Types.C_TypeExpr FlatCurry.Curry_Types.C_TypeExpr))
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))))
nd_C__case_9 x9 x6 x8 s cd cs = case x8 of
  Curry_Prelude.OP_Tuple2 x10 x11 -> let s5 = s
    in s5 `seq` (let s4 = leftSupply s5
                     s6 = rightSupply s5
                     s2 = leftSupply s6
                     s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s2 `seq` (s3 `seq` nd_OP_plus_plus_eq (wrapDX id
    (Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x11
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_foldr1 (wrapDX (wrapDX id)
    (acceptCs (acceptCs id) FlatCurry.Curry_Types.C_FuncType))
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.nd_C_map (wrapDX id
    (d_C_exprType cd cs)) x9 s0 cd cs) (Curry_Prelude.OP_Cons x6
    Curry_Prelude.OP_List) cd cs) s1 cd cs)) cd cs) Curry_Prelude.OP_List)))
    (Curry_ErrorState.nd_C_concatMapES (wrapNX id nd_C_eqsExpr) x9 s3 cd cs) s4
    cd cs))))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_9 x9 x6 l s
    cd cs) (nd_C__case_9 x9 x6 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_9
    x9 x6 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (nd_C__case_9 x9 x6 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference._case_9" [show x9, show x6, show x8]
    info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference._case_9"
    (showCons x8))

d_C__case_10 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr) -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Maybe FlatCurry.Curry_Types.C_TypeExpr -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))
d_C__case_10 x1 x3 x5 cd cs = case x5 of
  Curry_Prelude.C_Just x4 -> Curry_ErrorState.d_C_returnES
    (Curry_Prelude.OP_Tuple2 x1 x4)
  Curry_Prelude.C_Nothing -> Curry_ErrorState.d_OP_gt_plus_eq (d_C_nextTVar cd
    cs) (d_OP_freshVariant_dot_rename_dot_224_dot_uscore_hash_lambda34 x3 x1)
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i (d_C__case_10 x1 x3 l cd
    cs) (d_C__case_10 x1 x3 r cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z -> d_C__case_10 x1
    x3 z cd cs) xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c (d_C__case_10 x1 x3 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference._case_10" [show x1, show x3, show x5]
    info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference._case_10"
    (showCons x5))

nd_C__case_10 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr) -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Maybe FlatCurry.Curry_Types.C_TypeExpr -> IDSupply -> Cover
  -> ConstStore -> Func (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int FlatCurry.Curry_Types.C_TypeExpr))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))))
nd_C__case_10 x1 x3 x5 s cd cs = case x5 of
  Curry_Prelude.C_Just x4 -> wrapDX id (Curry_ErrorState.d_C_returnES
    (Curry_Prelude.OP_Tuple2 x1 x4))
  Curry_Prelude.C_Nothing -> let s0 = s
    in s0 `seq` wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (nd_C_nextTVar s0
    cd cs) (wrapDX (wrapDX id)
    (d_OP_freshVariant_dot_rename_dot_224_dot_uscore_hash_lambda34 x3 x1)))
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i (nd_C__case_10 x1 x3 l s cd
    cs) (nd_C__case_10 x1 x3 r s cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z -> nd_C__case_10 x1
    x3 z s cd cs) xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c (nd_C__case_10 x1 x3 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference._case_10" [show x1, show x3, show x5]
    info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference._case_10"
    (showCons x5))

d_C__case_12 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr -> Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.C_Maybe FlatCurry.Curry_Types.C_TypeExpr -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))
d_C__case_12 x1 x3 x5 x9 cd cs = case x9 of
  Curry_Prelude.C_Nothing -> d_C__case_11 x1 x5 (Curry_FiniteMap.d_C_lookupFM x5
    x1 cd cs) cd cs
  Curry_Prelude.C_Just x8 -> Curry_ErrorState.d_OP_gt_plus_eq (d_C_freshVariant
    x8 cd cs)
    (d_OP_getTypeVariant_dot_uscore_hash_lambda29_dot_uscore_hash_lambda32 x1)
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i (d_C__case_12 x1 x3 x5 l cd
    cs) (d_C__case_12 x1 x3 x5 r cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z -> d_C__case_12 x1
    x3 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c (d_C__case_12 x1 x3 x5 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference._case_12" [show x1, show x3, show x5
    , show x9] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference._case_12"
    (showCons x9))

nd_C__case_12 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr -> Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.C_Maybe FlatCurry.Curry_Types.C_TypeExpr -> IDSupply -> Cover
  -> ConstStore -> Func (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))))
nd_C__case_12 x1 x3 x5 x9 s cd cs = case x9 of
  Curry_Prelude.C_Nothing -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_11 x1 x5 (Curry_FiniteMap.nd_C_lookupFM x5
    x1 s0 cd cs) s1 cd cs))
  Curry_Prelude.C_Just x8 -> let s0 = s
    in s0 `seq` wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (nd_C_freshVariant
    x8 s0 cd cs) (wrapDX (wrapDX id)
    (d_OP_getTypeVariant_dot_uscore_hash_lambda29_dot_uscore_hash_lambda32 x1)))
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i (nd_C__case_12 x1 x3 x5 l s
    cd cs) (nd_C__case_12 x1 x3 x5 r s cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z -> nd_C__case_12 x1
    x3 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c (nd_C__case_12 x1 x3 x5 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference._case_12" [show x1, show x3, show x5
    , show x9] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference._case_12"
    (showCons x9))

d_C__case_11 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr -> Curry_Prelude.C_Maybe
  FlatCurry.Curry_Types.C_TypeExpr -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr) -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr)
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)))
d_C__case_11 x1 x5 x8 cd cs = case x8 of
  Curry_Prelude.C_Nothing -> Curry_ErrorState.d_C_failES
    (Curry_Prelude.toCurryString "Internal error: getTypeVariant")
  Curry_Prelude.C_Just x7 -> Curry_ErrorState.d_C_returnES
    (Curry_Prelude.OP_Tuple2 x1 x7)
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i (d_C__case_11 x1 x5 l cd
    cs) (d_C__case_11 x1 x5 r cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z -> d_C__case_11 x1
    x5 z cd cs) xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c (d_C__case_11 x1 x5 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference._case_11" [show x1, show x5, show x8]
    info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference._case_11"
    (showCons x8))

nd_C__case_11 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr -> Curry_Prelude.C_Maybe
  FlatCurry.Curry_Types.C_TypeExpr -> IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_Tuple4 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr)) (Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_Prelude.OP_Tuple4
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  FlatCurry.Curry_Types.C_TypeExpr))))
nd_C__case_11 x1 x5 x8 s cd cs = case x8 of
  Curry_Prelude.C_Nothing -> wrapDX id (Curry_ErrorState.d_C_failES
    (Curry_Prelude.toCurryString "Internal error: getTypeVariant"))
  Curry_Prelude.C_Just x7 -> wrapDX id (Curry_ErrorState.d_C_returnES
    (Curry_Prelude.OP_Tuple2 x1 x7))
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i (nd_C__case_11 x1 x5 l s cd
    cs) (nd_C__case_11 x1 x5 r s cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z -> nd_C__case_11 x1
    x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c (nd_C__case_11 x1 x5 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference._case_11" [show x1, show x5, show x8]
    info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference._case_11"
    (showCons x8))

d_C__case_14 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) FlatCurry.Curry_Types.C_Prog)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Maybe
  FlatCurry.Curry_Types.C_Prog -> Cover -> ConstStore -> Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_Prog)
d_C__case_14 x1 x3 x4 x6 cd cs = case x6 of
  Curry_Prelude.C_Nothing -> Curry_Prelude.C_Left (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "getTypeEnvFrom: Could not find module ") x3 cd
    cs)
  Curry_Prelude.C_Just x5 -> d_C__case_13 x4 x1 x5
    (d_OP_getTypeEnvFromProgEnv_dot_extract_dot_127 x1 x4 cd cs) cd cs
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i (d_C__case_14 x1 x3 x4 l cd
    cs) (d_C__case_14 x1 x3 x4 r cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z -> d_C__case_14 x1
    x3 x4 z cd cs) xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c (d_C__case_14 x1 x3 x4 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference._case_14" [show x1, show x3, show x4
    , show x6] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference._case_14"
    (showCons x6))

d_C__case_13 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) FlatCurry.Curry_Types.C_Prog)
  -> FlatCurry.Curry_Types.C_Prog -> Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_Prog) -> Cover -> ConstStore -> Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_Prog)
d_C__case_13 x4 x1 x5 x8 cd cs = case x8 of
  Curry_Prelude.C_Left x6 -> Curry_Prelude.C_Left x6
  Curry_Prelude.C_Right x7 -> Curry_Prelude.C_Right (Curry_Prelude.OP_Cons x5
    x7)
  Curry_Prelude.Choice_C_Either d i l r -> narrow d i (d_C__case_13 x4 x1 x5 l
    cd cs) (d_C__case_13 x4 x1 x5 r cd cs)
  Curry_Prelude.Choices_C_Either d i xs -> narrows cs d i (\z -> d_C__case_13 x4
    x1 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Either d c e -> guardCons d c (d_C__case_13 x4 x1 x5 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Either d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference._case_13" [show x4, show x1, show x5
    , show x8] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference._case_13"
    (showCons x8))

d_C__case_15 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) FlatCurry.Curry_Types.C_Prog)
  -> FlatCurry.Curry_Types.C_Prog -> Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_Prog) -> Cover -> ConstStore -> Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr)
d_C__case_15 x4 x1 x2 x10 cd cs = case x10 of
  Curry_Prelude.C_Left x8 -> Curry_Prelude.C_Left x8
  Curry_Prelude.C_Right x9 -> Curry_Prelude.C_Right (Curry_Prelude.d_OP_dollar
    d_C_extractKnownTypes (Curry_Prelude.OP_Cons x2 x9) cd cs)
  Curry_Prelude.Choice_C_Either d i l r -> narrow d i (d_C__case_15 x4 x1 x2 l
    cd cs) (d_C__case_15 x4 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Either d i xs -> narrows cs d i (\z -> d_C__case_15 x4
    x1 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Either d c e -> guardCons d c (d_C__case_15 x4 x1 x2 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Either d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference._case_15" [show x4, show x1, show x2
    , show x10] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference._case_15"
    (showCons x10))

nd_C__case_15 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) FlatCurry.Curry_Types.C_Prog)
  -> FlatCurry.Curry_Types.C_Prog -> Curry_Prelude.C_Either
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_Prog) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  FlatCurry.Curry_Types.C_TypeExpr)
nd_C__case_15 x4 x1 x2 x10 s cd cs = case x10 of
  Curry_Prelude.C_Left x8 -> Curry_Prelude.C_Left x8
  Curry_Prelude.C_Right x9 -> let s0 = s
    in s0 `seq` Curry_Prelude.C_Right (Curry_Prelude.nd_OP_dollar (wrapNX id
    nd_C_extractKnownTypes) (Curry_Prelude.OP_Cons x2 x9) s0 cd cs)
  Curry_Prelude.Choice_C_Either d i l r -> narrow d i (nd_C__case_15 x4 x1 x2 l
    s cd cs) (nd_C__case_15 x4 x1 x2 r s cd cs)
  Curry_Prelude.Choices_C_Either d i xs -> narrows cs d i (\z -> nd_C__case_15
    x4 x1 x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Either d c e -> guardCons d c (nd_C__case_15 x4 x1 x2 e
    s cd $! addCs c cs)
  Curry_Prelude.Fail_C_Either d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference._case_15" [show x4, show x1, show x2
    , show x10] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference._case_15"
    (showCons x10))

d_C__case_16 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> FlatCurry.Curry_Types.C_Rule -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C__case_16 x1 x7 cd cs = case x7 of
  FlatCurry.Curry_Types.C_Rule x8 x9 -> d_OP_depGraph_dot_called_dot_62 x1 x9 cd
    cs
  FlatCurry.Curry_Types.C_External x10 -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.Choice_C_Rule d i l r -> narrow d i (d_C__case_16 x1 l
    cd cs) (d_C__case_16 x1 r cd cs)
  FlatCurry.Curry_Types.Choices_C_Rule d i xs -> narrows cs d i (\z ->
    d_C__case_16 x1 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Rule d c e -> guardCons d c (d_C__case_16 x1 e
    cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Rule d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference._case_16" [show x1, show x7] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference._case_16"
    (showCons x7))

d_C__case_20 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr
  -> FlatCurry.Curry_Types.C_CombType -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C__case_20 x1 x7 x5 x6 cd cs = case x6 of
  Curry_Prelude.OP_Tuple2 x8 x9 -> d_C__case_19 x1 x8 x7 x5 x6
    (Curry_Prelude.d_OP_eq_eq x8 x1 cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_20 x1 x7 x5 l
    cd cs) (d_C__case_20 x1 x7 x5 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_20
    x1 x7 x5 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_20 x1 x7 x5 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference._case_20" [show x1, show x7, show x5
    , show x6] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference._case_20"
    (showCons x6))

d_C__case_19 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_Expr -> FlatCurry.Curry_Types.C_CombType
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_C__case_19 x1 x8 x7 x5 x6 x11 cd cs = case x11 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (let x10 = Curry_Prelude.OP_List in d_C__case_18 x10 x6 x5 cd cs)
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_concatMap
    (d_OP_depGraph_dot_called_dot_62 x1) cd cs) x7 cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_17 x7 x1 (Curry_Prelude.d_C_otherwise cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_19 x1 x8 x7 x5 x6
    l cd cs) (d_C__case_19 x1 x8 x7 x5 x6 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_19 x1
    x8 x7 x5 x6 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_19 x1 x8 x7 x5 x6
    e cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference._case_19" [show x1, show x8, show x7
    , show x5, show x6, show x11] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference._case_19"
    (showCons x11))

d_C__case_17 :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_Expr
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_C__case_17 x7 x1 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_concatMap
    (d_OP_depGraph_dot_called_dot_62 x1) cd cs) x7 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_17 x7 x1 l cd cs)
    (d_C__case_17 x7 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_17 x7
    x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_17 x7 x1 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference._case_17" [show x7, show x1, show x8]
    info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference._case_17"
    (showCons x8))

d_C__case_18 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_CombType -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C__case_18 x10 x6 x5 cd cs = case x5 of
  FlatCurry.Curry_Types.C_FuncCall -> Curry_Prelude.OP_Cons x6
    Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_FuncPartCall x11 -> Curry_Prelude.OP_Cons x6
    Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_ConsCall -> x10
  FlatCurry.Curry_Types.C_ConsPartCall x12 -> x10
  FlatCurry.Curry_Types.Choice_C_CombType d i l r -> narrow d i (d_C__case_18
    x10 x6 l cd cs) (d_C__case_18 x10 x6 r cd cs)
  FlatCurry.Curry_Types.Choices_C_CombType d i xs -> narrows cs d i (\z ->
    d_C__case_18 x10 x6 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_CombType d c e -> guardCons d c (d_C__case_18
    x10 x6 e cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_CombType d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference._case_18" [show x10, show x6, show x5]
    info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference._case_18"
    (showCons x5))

d_C__case_21 :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl t0)
  -> FlatCurry.Curry_Types.C_FuncDecl -> Curry_Prelude.C_Maybe
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl t0) -> Cover -> ConstStore -> t1
  -> Cover -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl t0) t1)
d_C__case_21 x2 x1 x4 cd cs = case x4 of
  Curry_Prelude.C_Just x3 -> Curry_ErrorState.d_C_returnES x3
  Curry_Prelude.C_Nothing -> Curry_ErrorState.d_C_failES
    (Curry_Prelude.toCurryString "Internal error: extract")
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i (d_C__case_21 x2 x1 l cd
    cs) (d_C__case_21 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z -> d_C__case_21 x2
    x1 z cd cs) xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c (d_C__case_21 x2 x1 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference._case_21" [show x2, show x1, show x4]
    info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference._case_21"
    (showCons x4))

d_C__case_22 :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_FuncDecl
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.C_Maybe FlatCurry.Curry_Types.C_FuncDecl -> Cover
  -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)
d_C__case_22 x7 x2 x1 x10 cd cs = case x10 of
  Curry_Prelude.C_Nothing -> Curry_Prelude.C_Left (Curry_Prelude.toCurryString
    "No such function")
  Curry_Prelude.C_Just x9 -> Curry_ErrorState.d_C_evalES
    (Curry_ErrorState.d_OP_gt_plus_eq (d_C_annFunc x9 cd cs) d_C_inferFunc)
    (d_C_initTIM x1 cd cs) cd cs
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i (d_C__case_22 x7 x2 x1 l cd
    cs) (d_C__case_22 x7 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z -> d_C__case_22 x7
    x2 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c (d_C__case_22 x7 x2 x1 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference._case_22" [show x7, show x2, show x1
    , show x10] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference._case_22"
    (showCons x10))

nd_C__case_22 :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_FuncDecl
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_FiniteMap.C_FM
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.C_Maybe FlatCurry.Curry_Types.C_FuncDecl -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (FlatCurry.Annotated.Curry_Types.C_AFuncDecl
  FlatCurry.Curry_Types.C_TypeExpr)
nd_C__case_22 x7 x2 x1 x10 s cd cs = case x10 of
  Curry_Prelude.C_Nothing -> Curry_Prelude.C_Left (Curry_Prelude.toCurryString
    "No such function")
  Curry_Prelude.C_Just x9 -> let s3 = s
    in s3 `seq` (let s2 = leftSupply s3
                     s4 = rightSupply s3
                     s0 = leftSupply s4
                     s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_ErrorState.nd_C_evalES
    (wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (nd_C_annFunc x9 s0 cd cs)
    (wrapNX id nd_C_inferFunc))) (nd_C_initTIM x1 s1 cd cs) s2 cd cs))))
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i (nd_C__case_22 x7 x2 x1 l s
    cd cs) (nd_C__case_22 x7 x2 x1 r s cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z -> nd_C__case_22 x7
    x2 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c (nd_C__case_22 x7 x2 x1 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference._case_22" [show x7, show x2, show x1
    , show x10] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference._case_22"
    (showCons x10))

d_C__case_23 :: FlatCurry.Curry_Types.C_Prog -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  FlatCurry.Curry_Types.C_Prog) -> Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) -> Cover
  -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (FlatCurry.Annotated.Curry_Types.C_AProg
  FlatCurry.Curry_Types.C_TypeExpr)
d_C__case_23 x2 x1 x5 cd cs = case x5 of
  Curry_Prelude.C_Left x3 -> Curry_Prelude.C_Left x3
  Curry_Prelude.C_Right x4 -> d_C_inferProgEnv x4 x2 cd cs
  Curry_Prelude.Choice_C_Either d i l r -> narrow d i (d_C__case_23 x2 x1 l cd
    cs) (d_C__case_23 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Either d i xs -> narrows cs d i (\z -> d_C__case_23 x2
    x1 z cd cs) xs
  Curry_Prelude.Guard_C_Either d c e -> guardCons d c (d_C__case_23 x2 x1 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Either d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference._case_23" [show x2, show x1, show x5]
    info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference._case_23"
    (showCons x5))

nd_C__case_23 :: FlatCurry.Curry_Types.C_Prog -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  FlatCurry.Curry_Types.C_Prog) -> Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) FlatCurry.Curry_Types.C_TypeExpr) -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (FlatCurry.Annotated.Curry_Types.C_AProg
  FlatCurry.Curry_Types.C_TypeExpr)
nd_C__case_23 x2 x1 x5 s cd cs = case x5 of
  Curry_Prelude.C_Left x3 -> Curry_Prelude.C_Left x3
  Curry_Prelude.C_Right x4 -> let s0 = s
    in s0 `seq` nd_C_inferProgEnv x4 x2 s0 cd cs
  Curry_Prelude.Choice_C_Either d i l r -> narrow d i (nd_C__case_23 x2 x1 l s
    cd cs) (nd_C__case_23 x2 x1 r s cd cs)
  Curry_Prelude.Choices_C_Either d i xs -> narrows cs d i (\z -> nd_C__case_23
    x2 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Either d c e -> guardCons d c (nd_C__case_23 x2 x1 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Either d info -> failCons d (traceFail
    "FlatCurry.Annotated.TypeInference._case_23" [show x2, show x1, show x5]
    info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.TypeInference._case_23"
    (showCons x5))

